/**** XgAhvV[W 쐬 ****/


SET QUOTED_IDENTIFIER ON 
SET ANSI_NULLS ON 
GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_num_archive_watch_delete_a]
  @nNumOfLeave int
AS

SET NOCOUNT ON

DECLARE @nInstanceId int
DECLARE @nApplNum smallint
DECLARE @nWatchNum smallint
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [TI].[instance_setup_id], [TA].[appl_num], [TW].[watch_num]
    FROM [bom_instance] AS [TI]
      INNER JOIN [bom_appl] AS [TA]
        ON [TI].[instance_setup_id] = [TA].[instance_setup_id]
      INNER JOIN [bom_watch] AS [TW]
        ON [TA].[appl_setup_id] = [TW].[appl_setup_id]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nApplNum, @nWatchNum

WHILE (@@FETCH_STATUS = 0)
BEGIN

  DECLARE @strSqlStmt nvarchar(500)
  DECLARE @strParams nvarchar(100)
  DECLARE @dtDate datetime

  SET @strSqlStmt = 
    N'SELECT @dtOut = MIN([T1].[archive_watch_time])
      FROM (
        SELECT TOP ' + CAST(@nNumOfLeave AS nvarchar) + N' [archive_watch_time]
          FROM [bom_archive_watch]
          WHERE [instance_setup_id] = @nId
            AND [appl_num] = @nNum1
            AND [watch_num] = @nNum2
          ORDER BY [archive_watch_time] DESC
      ) AS [T1]'
  SET @strParams = 
    N'@nId int, @nNum1 smallint, @nNum2 smallint, @dtOut datetime OUTPUT'

  EXECUTE sp_executesql @stmt = @strSqlStmt, @params = @strParams, 
    @nId = @nInstanceId, @nNum1 = @nApplNum, @nNum2 = @nWatchNum, 
    @dtOut = @dtDate OUTPUT

  DELETE FROM [bom_archive_watch]
    WHERE [instance_setup_id] = @nInstanceId
      AND [appl_num] = @nApplNum
      AND [watch_num] = @nWatchNum
      AND [archive_watch_time] < @dtDate

  FETCH NEXT FROM csr
    INTO @nInstanceId, @nApplNum, @nWatchNum

END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_num_archive_history_delete_a]
  @nNumOfLeave int
AS

SET NOCOUNT ON

DECLARE @nInstanceId int
DECLARE @nCategoryNum int
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [archive_status_category_num]
    FROM [bom_archive_history]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nCategoryNum

WHILE (@@FETCH_STATUS = 0)
BEGIN

  DECLARE @strSqlStmt nvarchar(500)
  DECLARE @strParams nvarchar(100)
  DECLARE @dtDate datetime

  SET @strSqlStmt = 
    N'SELECT @dtOut = MIN([T1].[archive_status_time])
      FROM (
        SELECT TOP ' + CAST(@nNumOfLeave AS nvarchar) + N' [archive_status_time]
          FROM [bom_archive_history]
          WHERE [instance_setup_id] = @nId
	    AND [archive_status_category_num] = @nCat
          ORDER BY [archive_status_time] DESC
      ) AS [T1]'
  SET @strParams = N'@nId int, @nCat int, @dtOut datetime OUTPUT'

  EXECUTE sp_executesql @stmt = @strSqlStmt, @params = @strParams, 
    @nId = @nInstanceId, @nCat = @nCategoryNum, @dtOut = @dtDate OUTPUT

  DELETE FROM [bom_archive_history]
    WHERE [instance_setup_id] = @nInstanceId
      AND [archive_status_category_num] = @nCategoryNum
      AND [archive_status_time] < @dtDate

  FETCH NEXT FROM csr
    INTO @nInstanceId, @nCategoryNum

END


CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_num_archive_ntevent_delete_a]
  @nNumOfLeave int
AS

SET NOCOUNT ON

DECLARE @nInstanceId int
DECLARE @strLogName nvarchar(127)
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [archive_ntevent_log_name]
    FROM [bom_archive_ntevent]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @strLogName

WHILE (@@FETCH_STATUS = 0)
BEGIN

  DECLARE @strSqlStmt nvarchar(500)
  DECLARE @strParams nvarchar(100)
  DECLARE @dtDate datetime

  SET @strSqlStmt = 
    N'SELECT @dtOut = MIN([T1].[archive_ntevent_generate_time])
      FROM (
        SELECT TOP ' + CAST(@nNumOfLeave AS nvarchar) + N' [archive_ntevent_generate_time]
          FROM [bom_archive_ntevent]
          WHERE [instance_setup_id] = @nId
            AND [archive_ntevent_log_name] = @strName
          ORDER BY [archive_ntevent_generate_time] DESC
          
      ) AS [T1]'
  SET @strParams = 
    N'@nId int, @strName nvarchar(127), @dtOut datetime OUTPUT'

  EXECUTE sp_executesql @stmt = @strSqlStmt, @params = @strParams, 
    @nId = @nInstanceId, @strName = @strLogName, @dtOut = @dtDate OUTPUT

  DELETE FROM [bom_archive_ntevent]
    WHERE [instance_setup_id] = @nInstanceId
      AND [archive_ntevent_log_name] = @strLogName
      AND [archive_ntevent_generate_time] < @dtDate

  FETCH NEXT FROM csr
    INTO @nInstanceId, @strLogName

END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO

USE [bom6_archive]
GO
CREATE PROCEDURE [sp_num_archive_sysinfo_delete_a]
  @nNumOfLeave int
AS

SET NOCOUNT ON

DECLARE @nInstanceId int
DECLARE @nSysinfoId int
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [sysinfo_id]
    FROM [dbo].[bom_archive_sysinfo]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nSysinfoId

WHILE (@@FETCH_STATUS = 0)
BEGIN

  DECLARE @strSqlStmt nvarchar(500)
  DECLARE @strParams nvarchar(100)
  DECLARE @dtDate datetime

  SET @strSqlStmt = 
    N'SELECT @dtOut = MIN([T1].[archive_time])
      FROM (
        SELECT TOP ' + CAST(@nNumOfLeave AS nvarchar) + N' [archive_time]
          FROM [dbo].[bom_archive_sysinfo]
          WHERE [instance_setup_id] = @nId
            AND [sysinfo_id] = @nSysId
          ORDER BY [archive_time] DESC
      ) AS [T1]'
  SET @strParams = 
    N'@nId int, @nSysId int, @dtOut datetime OUTPUT'

  EXECUTE sp_executesql @stmt = @strSqlStmt, @params = @strParams, 
    @nId = @nInstanceId, @nSysId = @nSysinfoId, @dtOut = @dtDate OUTPUT

  DELETE FROM [dbo].[bom_archive_sysinfo]
    WHERE [instance_setup_id] = @nInstanceId
      AND [sysinfo_id] = @nSysinfoId
      AND [archive_time] < @dtDate

  FETCH NEXT FROM csr
    INTO @nInstanceId, @nSysinfoId

END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_num_archive_performance_delete_a]
  @nNumOfLeave int
AS

SET NOCOUNT ON

DECLARE @nInstanceId int
DECLARE @sTarget nchar(64)
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [target]
    FROM [dbo].[bom_archive_performance]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @sTarget

WHILE (@@FETCH_STATUS = 0)
BEGIN

  DECLARE @strSqlStmt nvarchar(500)
  DECLARE @strParams nvarchar(100)
  DECLARE @dtDate datetime

  SET @strSqlStmt = 
    N'SELECT @dtOut = MIN([T1].[archive_time])
      FROM (
        SELECT TOP ' + CAST(@nNumOfLeave AS nvarchar) + N' [archive_time]
          FROM [dbo].[bom_archive_performance]
          WHERE [instance_setup_id] = @nId
            AND [target] = @sTargetName
          ORDER BY [archive_time] DESC
      ) AS [T1]'
  SET @strParams = 
    N'@nId int, @sTargetName nchar(64), @dtOut datetime OUTPUT'

  EXECUTE sp_executesql @stmt = @strSqlStmt, @params = @strParams, 
    @nId = @nInstanceId, @sTargetName = @sTarget, @dtOut = @dtDate OUTPUT

  DELETE FROM [dbo].[bom_archive_performance]
    WHERE [instance_setup_id] = @nInstanceId
      AND [target] = @sTarget
      AND [archive_time] < @dtDate

  FETCH NEXT FROM csr
    INTO @nInstanceId, @sTarget

END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_day_archive_watch_delete_a]
  @nDayOfLeave int
AS

SET NOCOUNT ON

DECLARE @dtDate datetime
SET @dtDate = DATEADD(day, -@nDayOfLeave, CONVERT(nvarchar, GETDATE(), 102))

DECLARE @nInstanceId int
DECLARE @nApplNum smallint
DECLARE @nWatchNum smallint
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [TI].[instance_setup_id], [TA].[appl_num], [TW].[watch_num]
    FROM [bom_instance] AS [TI]
      INNER JOIN [bom_appl] AS [TA]
        ON [TI].[instance_setup_id] = [TA].[instance_setup_id]
      INNER JOIN [bom_watch] AS [TW]
        ON [TA].[appl_setup_id] = [TW].[appl_setup_id]
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nApplNum, @nWatchNum

WHILE (@@FETCH_STATUS = 0)
BEGIN
  DELETE FROM [bom_archive_watch]
    WHERE [instance_setup_id] = @nInstanceId
      AND [appl_num] = @nApplNum
      AND [watch_num] = @nWatchNum
      AND [archive_watch_time] < @dtDate
  FETCH NEXT FROM csr
    INTO @nInstanceId, @nApplNum, @nWatchNum
END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_day_archive_history_delete_a]
  @nDayOfLeave int
AS

SET NOCOUNT ON

DECLARE @dtDate datetime
SET @dtDate = DATEADD(day, -@nDayOfLeave, CONVERT(nvarchar, GETDATE(), 102))

DECLARE @nInstanceId int
DECLARE @nCategoryNum int
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [archive_status_category_num]
    FROM [bom_archive_history]
    WHERE [archive_status_time] < @dtDate
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nCategoryNum

WHILE (@@FETCH_STATUS = 0)
BEGIN
  DELETE FROM [bom_archive_history]
    WHERE [instance_setup_id] = @nInstanceId
      AND [archive_status_category_num] = @nCategoryNum
      AND [archive_status_time] < @dtDate
  FETCH NEXT FROM csr
    INTO @nInstanceId, @nCategoryNum
END


CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


USE [bom6_archive]
GO
CREATE PROCEDURE [sp_day_archive_ntevent_delete_a]
  @nDayOfLeave int
AS

SET NOCOUNT ON

DECLARE @dtDate datetime
SET @dtDate = DATEADD(day, -@nDayOfLeave, CONVERT(nvarchar, GETDATE(), 102))

DECLARE @nInstanceId int
DECLARE @strLogName nvarchar(127)
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [archive_ntevent_log_name]
    FROM [bom_archive_ntevent]
    WHERE [archive_ntevent_generate_time] < @dtDate
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @strLogName

WHILE (@@FETCH_STATUS = 0)
BEGIN
  DELETE FROM [bom_archive_ntevent]
    WHERE [instance_setup_id] = @nInstanceId
      AND [archive_ntevent_log_name] = @strLogName
      AND [archive_ntevent_generate_time] < @dtDate
  FETCH NEXT FROM csr
    INTO @nInstanceId, @strLogName
END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF

GO


CREATE PROCEDURE [sp_day_archive_sysinfo_delete_a]
  @nDayOfLeave int
AS

SET NOCOUNT ON

DECLARE @dtDate datetime
SET @dtDate = DATEADD(day, -@nDayOfLeave, CONVERT(nvarchar, GETDATE(), 102))

DECLARE @nInstanceId int
DECLARE @nSysinfoId int
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [sysinfo_id]
    FROM [dbo].[bom_archive_sysinfo]
    WHERE [archive_time] < @dtDate
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @nSysinfoId

WHILE (@@FETCH_STATUS = 0)
BEGIN
  DELETE FROM [dbo].[bom_archive_sysinfo]
    WHERE [instance_setup_id] = @nInstanceId
      AND [sysinfo_id] = @nSysinfoId
      AND [archive_time] < @dtDate
  FETCH NEXT FROM csr
    INTO @nInstanceId, @nSysinfoId
END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF
GO


CREATE PROCEDURE [sp_day_archive_performance_delete_a]
  @nDayOfLeave int
AS

SET NOCOUNT ON

DECLARE @dtDate datetime
SET @dtDate = DATEADD(day, -@nDayOfLeave, CONVERT(nvarchar, GETDATE(), 102))

DECLARE @nInstanceId int
DECLARE @sTarget nchar(64)
DECLARE csr CURSOR LOCAL FAST_FORWARD FOR
  SELECT DISTINCT [instance_setup_id], [target]
    FROM [dbo].[bom_archive_performance]
    WHERE [archive_time] < @dtDate
OPEN csr

FETCH NEXT FROM csr
  INTO @nInstanceId, @sTarget

WHILE (@@FETCH_STATUS = 0)
BEGIN
  DELETE FROM [dbo].[bom_archive_performance]
    WHERE [instance_setup_id] = @nInstanceId
      AND [target] = @sTarget
      AND [archive_time] < @dtDate
  FETCH NEXT FROM csr
    INTO @nInstanceId, @sTarget
END

CLOSE csr
DEALLOCATE csr

SET NOCOUNT OFF
GO


USE [bom6_archive]
GO

CREATE FUNCTION [dbo].[get_bom_db_version]() 
RETURNS smallint
AS 
BEGIN
	return (600)
END
GO


CREATE FUNCTION [dbo].[is_bom6_sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom6_sr2_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom7_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom7sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom7sr2_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom7sr3_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom7sr4_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom8_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom8sr1_db] () RETURNS int AS BEGIN RETURN 1 END
GO
CREATE FUNCTION [dbo].[is_bom8sr2_db] () RETURNS int AS BEGIN RETURN 1 END
GO
