document.addEventListener("DOMContentLoaded", function() {
	fetch('/Indicator/generateCsrfToken')
        .then(response => response.json())
        .then(data => {
            // すべてのフォームにCSRFトークンを追加
            const csrfToken = data.csrfToken;
            document.querySelectorAll('form').forEach(form => {
                // フォーム内のすべての_csrfフィールドを取得
                let csrfInputs = form.querySelectorAll('input[name="_csrf"]');
                if (csrfInputs.length > 0) {
                    // すべての既存_csrfフィールドの値を更新
                    csrfInputs.forEach(input => {
                        input.value = csrfToken;
                    });
                } else {
                    // _csrfフィールドが存在しない場合は新しく作成
                    let csrfInput = document.createElement('input');
                    csrfInput.type = 'hidden';
                    csrfInput.name = '_csrf';
                    csrfInput.value = csrfToken;
                    form.appendChild(csrfInput);
                }
            });
        })
        .catch(error => console.error('Error fetching CSRF token:', error));
});