//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
var newDetailInstance = {};
$(document).ready(function(){
	newDetailInstance.instanceType = $('#instanceType').val();
	newDetailInstance.instanceId = $('#instanceId').val();
	newDetailInstance.parentId = $('#parentId').val();

	//-------------------------------------------------------------------------
	// コマンドバーのアドレスバー更新
	//-------------------------------------------------------------------------
	newDetailInstance.setCommandBarAddress = function(){
		// コマンドバーのアドレスバー更新
		var commandBarData = $('#mainCommandBar', top.document);
		if (commandBarData.get(0) != undefined && commandBarData.get(0).contentWindow != undefined && commandBarData.get(0).contentWindow.setCommandBarAddress != undefined) {
			commandBarData.get(0).contentWindow.setCommandBarAddress(newDetailInstance.instanceType, newDetailInstance.instanceId);
		}
	};

	//-------------------------------------------------------------------------
	// タブクリック時にリンク先URI設定
	//-------------------------------------------------------------------------
	$('li','#detailsInstanceForm').click(function(){
		var clickPage = $(this).parents('.tabs').children('div').eq($(this).index()).children();
		var srcString = clickPage.attr('id') + '.html?' + 'instanceId=' + newDetailInstance.instanceId;
		var visiblePage = '';
		var srcIndex = $(this).index();
		$(this).parents('.tabs').find('div').each(function(){
			var thisDiv = $(this);
			if( thisDiv.css('visibility') == 'visible' ){
				visiblePage = $('iframe', thisDiv).attr('src');
				return;
			}
		});

		if( visiblePage != srcString ){
		    //URL保存
		    top.pageNavigatePush('detailsInstance/detailsInstance.html?instanceId=' + newDetailInstance.instanceId + '&tabIndex=' + srcIndex);
			//ページ遷移
			clickPage.attr('src', srcString);
		}else{
			//ページ更新
			windowRefresh();
		}
	});

	//-------------------------------------------------------------------------
	// カレント情報を設定
	//-------------------------------------------------------------------------
	var mainDocument = top.document;
	$('#curentParentGroupId', mainDocument).val(newDetailInstance.parentId);
	$('#curentType', mainDocument).val(newDetailInstance.instanceType);
	$('#curentId', mainDocument).val(newDetailInstance.instanceId);

	//アドレスバー情報を更新する
	newDetailInstance.setCommandBarAddress();

	// タブ化
	$('div.tabs').simpleTabs({ 'tabIndex' : Number($('#tabIndex').val()) });
	$(window).resize(function(){
		var thisTabsForm = $('#detailsInstanceForm');
		var tabNavigator = thisTabsForm.find('ul.tabsNavigator');
		thisTabsForm.find('div.tab').each(function(){
			var thisTab = $(this);
			var thisTabHeight = $(window).innerHeight() - $('#mainLogview').outerHeight(false) - $('#mainCommandBar').outerHeight(false) - tabNavigator.outerHeight(false);
			thisTab.offset({top: $('#mainCommandBar').outerHeight(false) + tabNavigator.outerHeight(false)});
			thisTab.height(thisTabHeight);
		});
	});
	$(window).resize();
});
//=============================================================================
//インスタンス詳細のリフレッシュ処理
//=============================================================================
function windowRefresh(){
	var visibleTab = undefined;

	//アドレスバー情報を更新する
	newDetailInstance.setCommandBarAddress();

	//表示中のタブを取得する
	$('div.tab').each(function(){
		if($(this).css('visibility')=='visible'){
			visibleTab = $(this);
		}
	});

	if(visibleTab != undefined){
		//自分が表示しているウィンドウのリフレッシュ処理を呼び出す
		var windowObject = $('iframe', visibleTab).get(0).contentWindow;
		if(windowObject.windowRefresh != undefined){
			windowObject.windowRefresh();
		}
	}
}

//=============================================================================
//詳細インスタンスビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	var visibleTab = undefined;

	//表示中のタブを取得する
	$('div.tab').each(function(){
		if($(this).css('visibility')=='visible'){
			visibleTab = $(this);
		}
	});

	if(visibleTab != undefined){
		//自分が表示しているウィンドウのリフレッシュ処理を呼び出す
		var windowObject = $('iframe', visibleTab).get(0).contentWindow;
		if(windowObject.forceWindowRefreshEnd != undefined){
			windowObject.forceWindowRefreshEnd();
		}
	}
}

//=============================================================================
//現在非表示のタブページの中身を空にする
//=============================================================================
function tabPageClear(){
	//他のタブページの中身は空にする
	$('li','#detailsInstanceForm').parents('.tabs').find('div').each(function(){
		var thisDiv = $(this);
		if( thisDiv.css('visibility') == 'hidden' ){
			$('iframe', thisDiv).attr('src', '');
			return;
		}
	});
}