//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	//クラス定義
	var computer = function(){
		//プロパティ
		this.computerList = [];

		//メソッド
		//子要素の取得要求
		this.ajaxMonitorStatusRequest = function(){
			//Loadingタイマー開始
			$('body').viewLoadingScreen();
			var ajaxParam = { };
			ajaxParam.onFailure = onAjaxFailure;
			Kumu.Ajax.executeTeedaAjax(gatheringInstance_gatheringChoseComputerAction_ajaxComputerList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		};

		//子要素の取得応答
		this.ajaxMonitorStatusResponse = function(objectList){
			try{
				if(objectList.length<=0) throw 'noItem';

				delete this.computerList;
				this.computerList = [];
				for(i in objectList){
					this.computerList[i] = objectList[i];
				}
			}catch(e){
				if(e == 'noItem'){
					delete this.computerList;
					this.computerList = [];
				}
			}
		};

		//ページ表示の更新処理
		this.pageUpdate = function(){
			try {
				//テーブル要素の表示
				$('#computerList').children('tbody')
										.css('visibility', 'visible')
										.end()
										.trigger('update');

				getHostNameLoadingDisplayOn();
				getHostNameResolve(this.computerList);
			} finally {
		        //Loading終了
			    $('body').deleteLoadingScreen();
			}
		};
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	//このオブジェクト変数だけは、グローバルスコープ
	objGatheringChoseComputer = new computer();

	//=========================================================================
	// イベント処理
	//=========================================================================
	$('#ComputerAllCheck').click(function () {
		//コンピューターすべてのチェックを行ったり外したりする
		if($(this).is(':checked')){
			$('input[type=checkbox][name=computerList]').attr('checked', 'checked');
		}else{
			$('input[type=checkbox][name=computerList]').attr('checked', false);
		}
	});

	//探索中初期状態を設定
	$('#searchComputer').data('searchingFlag', false);
	$('#searchComputer').click(function(){
		//探索中は２重で探索を行わない。
		if($('#searchComputer').data('searchingFlag')){
			return false;
		}
		$('#searchComputer').data('searchingFlag', true);
		objGatheringChoseComputer.ajaxMonitorStatusRequest();
	});

	$('#addComputer').click(function () {
		var callBackFunction = function(result){
			var inputCheckFlg = false;
			var computerName = result;
			var ret = true;
			if(computerName == ''){
				return ret;
			}

			//文字数が255以下かをチェックする
			if(computerName.length > 255){
				inputCheckFlg = false;
				alert('IPアドレス、または、ホスト名が長すぎます。255文字以下で入力してください。');
				return false;
			}

			//入力された文字列をチェック
			//IPv4フォーマットなら許容する
			if(computerName.match(/^\d{0,3}\.\d{0,3}\.\d{0,3}\.\d{0,3}$/) != null){
				// IPv4アドレス (([0-9]{1-3}.){3}[0-9]{1-3})
				inputCheckFlg = false;
				var ipList = computerName.split('.');
				var i=0;
				var loopFlg = true;
				for(i=0; i<ipList.length; i+=1){
					if(ipList[i]=='' ||  parseInt(ipList[i]) > 255){
						loopFlg = false;
						break;
					}
				}
				if(loopFlg){
					inputCheckFlg = true;
				}
			}
			//IPv6フォーマットで許容する文字で構成されているか
			else if( (computerName.match(/:+/) != null)
					&& (computerName.match(/[^0-9a-fA-F:]+/) == null)){
				//一番はじめに正常な略式表記なしのIPv6のフォーマットであるかをチェックする
				if( computerName.match(/^[0-9a-fA-F]{1,4}(:[0-9a-fA-F]{1,4}){7}$/) != null ){
					//略式表記なしのIPv6フォーマットなのでOK
					inputCheckFlg = true;
				}else{
					if( computerName.match(/([^:]*:[^:]*){8}/) != null ){
						//IPv6の略式表記ではない
						//一番省略しない形で、:は7個まで
						inputCheckFlg = false;
					}else if( computerName.match(/^::[0-9a-fA-F]{1,4}(:[0-9a-fA-F]{1,4}){0,5}$/) != null ){
						//略式表記OK
						inputCheckFlg = true;
					}else if( computerName.match(/^[0-9a-fA-F]{1,4}(:[0-9a-fA-F]{1,4}){0,4}::[0-9a-fA-F]{1,4}(:[0-9a-fA-F]{1,4}){0,4}$/) != null ){
						//略式表記OK
						inputCheckFlg = true;
					}else{
						//該当なし
						//略式表記NG
						inputCheckFlg = false;
					}
				}
			}
			//ホスト名のフォーマットで許容する文字で構成されているか
			else if(computerName.match(/[^\w\-\.]+/) == null){
				if(computerName.match(/^\./) != null){
					//先頭への.は許容しない
				}else if(computerName.match(/\.$/) != null){
					//末尾への.は許容しない
				}else if(computerName.match(/\.\./) != null){
					//.の連続も許容しない
				}else{
					inputCheckFlg = true;
				}
			}
			//
			if(inputCheckFlg == true){
				//同じコンピューター名は登録できない。
				var searchHit = false;
				$('#computerList').children('tbody').find('label').each(function(){
					if(searchHit){
						return;
					}
					var thisText = $(this).text();
					if(thisText == computerName){
						searchHit = true;
						return;
					}
				});
				if(searchHit){
					alert('既に同名のコンピューター名が存在します。');
					ret = false;
				}else{
					var tableBody = $('#computerList').children('tbody');
					var tr = $('<tr/>');
					var td = $('<td/>');
					var label = $('<label/>');
					var checkbox = $('<input type="checkbox" name="computerList"/>');
					checkbox.attr('value', computerName);
					label.append(checkbox);
					label.append(computerName);
					td.append(label);
					tr.append(td);
					tableBody.append(tr);
				}
			}else{
				alert('入力されたフォーマットは有効ではありません');
				ret = false;
			}
			return ret;
		};
		//確認ダイアログを表示する
		showInputDialog('コンピューターの追加', 'コンピューターを追加します。IPアドレス、または、ホスト名で入力してください', '', callBackFunction);
	});

	$('#doNext').click(function () {
		var findChecked = false;
		var inputLists = $('#computerList tbody input[name="computerList"]');
		inputLists.each(function () {
			if ($(this).attr('checked') == undefined) {
				return;
			}
			findChecked = true;
		});

		if (findChecked) {
			//画面遷移中は他のボタンを効かないようにする
			// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
			// クリックイベントを無視する方向に変更する
			$('div.dialogButtons').children('input').on('click', function(){
				return false;
			});
		}else{
			alert('コンピューターは一つ以上選択してください。');
		}
		return findChecked;
	});

	//=========================================================================
	// 名前解決ローディング画面表示関連
	//=========================================================================
	//-------------------------------------------------------------------------
	// 名前解決ローディング画面表示
	//-------------------------------------------------------------------------
	function getHostNameLoadingDisplayOn(){
		var img = $('<img id="getHostNameLoading" src="../../images/progress32.gif"/>');
		$('#computerList').before(img);
	}
	//-------------------------------------------------------------------------
	// 名前解決ローディング画面表示消去
	//-------------------------------------------------------------------------
	function getHostNameLoadingDisplayOff(){
		$('#getHostNameLoading').remove();
	}

	//=========================================================================
	// 名前解決関連
	//=========================================================================
	function getHostNameResolve( ipAddressList ){
		var ipAddress = ipAddressList.shift();
		$('#getHostNameLoading').data('ipAddressList', ipAddressList);
		//名前解決を行う
		var ajaxParam = {'AjaxParam0' : ipAddress};
		ajaxParam.onFailure = onAjaxFailure;
		Kumu.Ajax.executeTeedaAjax(gatheringInstance_gatheringChoseComputerAction_ajaxGetHostName, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_TEXT);
	}

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// 子要素の取得応答
	//-------------------------------------------------------------------------
	function gatheringInstance_gatheringChoseComputerAction_ajaxComputerList(objectMapList) {
		//受信データ設定
		objGatheringChoseComputer.ajaxMonitorStatusResponse(objectMapList);
		//ページ表示の更新
		objGatheringChoseComputer.pageUpdate();
	}
	//-------------------------------------------------------------------------
	// 名前解決結果応答
	//-------------------------------------------------------------------------
	function gatheringInstance_gatheringChoseComputerAction_ajaxGetHostName(hostname) {
		var tableBody = $('#computerList').children('tbody');

		// コンピューター一覧をマージする
		var findItems = tableBody.find('input[value="' + hostname +'"]');
		if (findItems.size() == 0) {
			//受信データの追加
			var tr = $('<tr/>');
			var td = $('<td/>');
			var label = $('<label/>');
			var checkbox = $('<input type="checkbox" name="computerList"/>');
			checkbox.attr('value', hostname);
			label.append(checkbox);
			label.append(hostname);
			td.append(label);
			tr.append(td);
			tableBody.append(tr);
			tableBody = null;
		}

		//次の名前解決へ
		if($('#getHostNameLoading').data('ipAddressList').length > 0){
			getHostNameResolve($('#getHostNameLoading').data('ipAddressList'));
		}else{
			getHostNameLoadingDisplayOff();
			//探索中状態を初期化する
			$('#searchComputer').data('searchingFlag', false);
		}
	}
});

