//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objActionSetting = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined) window.parent.tabPageClear();

	//=========================================================================
	// プロパティ
	//=========================================================================
	objActionSetting.groupId = $('#groupId').val();
	objActionSetting.permissionWrite = $(top.document).find('#permissionWrite').val();
	objActionSetting.objectMapList = [];

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// 子要素の取得要求
	//-------------------------------------------------------------------------
	objActionSetting.ajaxActionSettingRequest = function(){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : this.groupId};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupActionAction_ajaxActionSetting, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupActionAction', 'action' : 'ajaxActionSetting', 'AjaxParam0' : objActionSetting.groupId}, detailsGroup_groupActionAction_ajaxActionSetting, 'json');
	};

	//-------------------------------------------------------------------------
	// 子要素の取得応答
	//-------------------------------------------------------------------------
	objActionSetting.ajaxActionSettingResponse = function( objectMapList ){
		try{
			if(objectMapList.length<=0) throw 'noItem';

			delete objActionSetting.objectMapList;
			objActionSetting.objectMapList = [];
			for (i in objectMapList) {
				objActionSetting.objectMapList[i] = objectMapList[i];
				//ステータスの設定
				if(!('enable' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['enable'] = 'false';
				}
				if(!('conditionNormal' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionNormal'] = 0;
				}
				if(!('conditionWarning' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionWarning'] = 0;
				}
				if(!('conditionDanger' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionDanger'] = 0;
				}
				if(!('conditionFailure' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionFailure'] = 0;
				}
				if(!('conditionMonitorDisconnect' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionMonitorDisconnect'] = false;
				}
				if(!('conditionHelperDisconnect' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionHelperDisconnect'] = false;
				}
				if(!('conditionComputerDisconnect' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['conditionComputerDisconnect'] = false;
				}

				//前回実行時刻の設定
				if(!('lastDatetime' in objActionSetting.objectMapList[i])){
					objActionSetting.objectMapList[i]['lastDatetime'] = '--';
				}
			}
		}catch(e){
			if(e == 'noItem'){
				delete objActionSetting.objectMapList;
				objActionSetting.objectMapList = [];
			}
		}
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objActionSetting.pageUpdate = function(){
		try{
			var tableBody = $('#groupActionTable').children('tbody');
			var statusIconHashTable = {'conditionComputerDisconnect':'../../images/summaryDisconnectComputer16.png',
										'conditionHelperDisconnect':'../../images/summaryDisconnectHelper16.png',
										'conditionMonitorDisconnect':'../../images/summaryDisconnectAgent16.png',
										'conditionFailure':'../../images/summaryFailure16.png',
										'conditionDanger':'../../images/summaryDanger16.png',
										'conditionWarning':'../../images/summaryWarning16.png',
										'conditionNormal':'../../images/summaryInformation16.png',
										'conditionInvisible':'../../images/invisible16.png'};
            var statusIconAltHashTable = {'conditionComputerDisconnect':'コンピューター接続エラー',
                    						'conditionHelperDisconnect':'ヘルパーサービス接続エラー',
                    						'conditionMonitorDisconnect':'監視サービス停止中',
                    						'conditionFailure':'失敗',
                    						'conditionDanger':'危険',
                    						'conditionWarning':'注意',
                    						'conditionNormal':'正常',
                    						'conditionInvisible':''};

			//受信データがない場合には中身をクリアする
			if(objActionSetting.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//アクション名
			var tdActionNameArray = [];
			for(i in objActionSetting.objectMapList){
				var thisObjectMap = objActionSetting.objectMapList[i];
				var td = $('<td>').addClass('groupActionActionNameStyle');
				var p = $('<p>');
				//書き込み権限がない場合には、アクション一覧へのリンクを追加しない
				if(objActionSetting.permissionWrite == 'true'){
					p.addClass('objectLink');
				}
				var inputActionInstanceId = $('<input type="hidden" name="actionInstanceId">').attr('value', thisObjectMap['groupId']);
				var string = thisObjectMap['name'];
				p.attr('title', string).append(inputActionInstanceId).append(string);
				td.append(p);
				tdActionNameArray.push(td);
			}

			//有効
			var tdEnableArray = [];
			var temp = {'true':'有効', 'false':'無効'};
			for(i in objActionSetting.objectMapList){
				var thisObjectMap = objActionSetting.objectMapList[i];
				var td = $('<td>').addClass('groupActionEnableStyle');
				var p = $('<p>');
				var string = temp[thisObjectMap['enable']];
				p.append(string);
				td.append(p);
				tdEnableArray.push(td);
			}

			//条件
			var tdTriggerArray = [];
			for(i in objActionSetting.objectMapList){
				var thisObjectMap = objActionSetting.objectMapList[i];
                var implantData = 0;
				var td = $('<td>').addClass('groupActionTriggerStyle');
				var p = $('<p>');

				var imgConditionComputerDisconnect = $('<img>');
				if(thisObjectMap['conditionComputerDisconnect']=='true'){
					imgConditionComputerDisconnect.attr('src', statusIconHashTable['conditionComputerDisconnect'])
						.attr('title', statusIconAltHashTable['conditionComputerDisconnect'])
						.addClass('disconnectComputer');
					implantData += 64;
				}else{
					imgConditionComputerDisconnect.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionHelperDisconnect = $('<img>');
				if(thisObjectMap['conditionHelperDisconnect']=='true'){
					imgConditionHelperDisconnect.attr('src', statusIconHashTable['conditionHelperDisconnect'])
						.attr('title', statusIconAltHashTable['conditionHelperDisconnect'])
						.addClass('disconnectHelper');
					implantData += 32;
				}else{
					imgConditionHelperDisconnect.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionMonitorDisconnect = $('<img>');
				if(thisObjectMap['conditionMonitorDisconnect']=='true'){
					imgConditionMonitorDisconnect.attr('src', statusIconHashTable['conditionMonitorDisconnect'])
						.attr('title', statusIconAltHashTable['conditionMonitorDisconnect'])
						.addClass('disconnectAgent');
					implantData += 16;
				}else{
					imgConditionMonitorDisconnect.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionFailure = $('<img>');
				if(thisObjectMap['conditionFailure']=='true'){
					imgConditionFailure.attr('src', statusIconHashTable['conditionFailure'])
						.attr('title', statusIconAltHashTable['conditionFailure'])
						.addClass('failure');
					implantData += 8;
				}else{
					imgConditionFailure.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionDanger = $('<img>');
				if(thisObjectMap['conditionDanger']=='true'){
					imgConditionDanger.attr('src', statusIconHashTable['conditionDanger'])
						.attr('title', statusIconAltHashTable['conditionDanger'])
						.addClass('danger');
					implantData += 4;
				}else{
					imgConditionDanger.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionWarning = $('<img>');
				if(thisObjectMap['conditionWarning']=='true'){
					imgConditionWarning.attr('src', statusIconHashTable['conditionWarning'])
						.attr('title', statusIconAltHashTable['conditionWarning'])
						.addClass('warning');
					implantData += 2;
				}else{
					imgConditionWarning.attr('src', statusIconHashTable['conditionInvisible']);
				}

				var imgConditionNormal = $('<img>');
				if(thisObjectMap['conditionNormal']=='true'){
					imgConditionNormal.attr('src', statusIconHashTable['conditionNormal'])
						.attr('title', statusIconAltHashTable['conditionNormal'])
						.addClass('normal');
					implantData += 1;
				}else{
					imgConditionNormal.attr('src', statusIconHashTable['conditionInvisible']);
				}
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', implantData);

				p.append(imgConditionComputerDisconnect)
					.append(imgConditionHelperDisconnect)
					.append(imgConditionMonitorDisconnect)
					.append(imgConditionFailure)
					.append(imgConditionDanger)
					.append(imgConditionWarning)
					.append(imgConditionNormal)
					.append(inputSortdata);
				td.append(p);
				tdTriggerArray.push(td);
			}

			//アクション概要
			var tdActionSummaryArray = [];
			var actionSummaryHashTable = {'MAIL' : 'メール送信','CUSTOM' : 'カスタムアクション'};
			for(i in objActionSetting.objectMapList){
				var thisObjectMap = objActionSetting.objectMapList[i];
				var td = $('<td>').addClass('groupActionActionSummaryStyle');
				var p = $('<p>');
				var actionKind = thisObjectMap['actionKind'];
				var string = '';
				if(actionKind == 'MAIL'){
					var actionParams = thisObjectMap['actionParams'].split(',');
					var smtpPortString = '';
					var smtpHostString = '';

					//SMTPポート番号の設定を探して格納
					for(i in actionParams){
						if(actionParams[i].indexOf('SMTP_PORT') > 0){
							smtpPortString = actionParams[i];
							smtpPortString = smtpPortString.replace(/"/g, '');
							smtpPortString = smtpPortString.replace(/SMTP_PORT:/, '');
							break;
						}
					}
					//ホスト名の設定を探して格納する
					for(i in actionParams){
						if(actionParams[i].indexOf('SMTP_HOST') > 0){
							smtpHostString = actionParams[i];
							smtpHostString = smtpHostString.replace(/"/g, '');
							smtpHostString = smtpHostString.replace(/SMTP_HOST:/, '');
							break;
						}
					}

					//サーバー名とポート番号を抽出する
					string += actionSummaryHashTable[actionKind]+ '[' + smtpHostString + ':' + smtpPortString + ']';
				}else{
					var actionCommand = thisObjectMap['actionCommand'];
					string += actionSummaryHashTable[actionKind]+ '[' + actionCommand + ']';
				}
				p.attr('title', string).append(string);
				td.append(p);
				tdActionSummaryArray.push(td);
			}

			//最終実行日時
			var tdLastDateArray = [];
			for(i in objActionSetting.objectMapList){
				var thisObjectMap = objActionSetting.objectMapList[i];
				var lastDatetime = thisObjectMap['lastDatetime'];
				var td = $('<td>').addClass('groupActionLastDateStyle');
				var p = $('<p>');
				var string = '';
				var setDate = 0;
				if(lastDatetime != '--'){
					string = (new String(lastDatetime)).slice(0,19).replace(/-/g, '/').replace(/ /, '<br/>');
					setDate = (new String(lastDatetime)).slice(0,19).replace(/-/g, '/');
				}
				var input = $('<input type="hidden" name="date">').attr('value', setDate);
				p.append(string).append(input);
				td.append(p);
				tdLastDateArray.push(td);
			}

			//合成する
			tableBody.empty();
			for(i in objActionSetting.objectMapList){
				tableBody.append($('<tr>').append(tdActionNameArray[i]).append(tdEnableArray[i]).append(tdTriggerArray[i]).append(tdActionSummaryArray[i]).append(tdLastDateArray[i]));
			}

			tdActionNameArray = null;
			tdEnableArray = null;
			tdTriggerArray = null;
			tdActionSummaryArray = null;
			tdLastDateArray = null;

			//テーブル要素の表示
			$('#groupActionTable').children('tbody')
										.css('visibility', 'visible')
									.end()
									.trigger('update');
		}finally{
			var divToolBox = $('#groupActionTable').data('divToolBox');
			if( divToolBox != undefined ){
				$('#groupActionTable').tableDataFilter(divToolBox, true);
			}
			if($('#groupActionTable').data('refresh') == true){
				$('#groupActionTable').tableDataSort();
				$('#groupActionTable').removeData('refresh');
			}
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objActionSetting.ajaxActionSettingRequest();

	//テーブル機能の拡張を行う
	$('#groupActionTable').fixedHeaderTable();

	//=========================================================================
	//コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// アクション名をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionTable').on('click', '.objectLink', function(){
		top.window.showDialog('action/actionList.html?groupId='+ $('#groupId').val(), 'アクションの編集');
	});

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#groupActionTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#groupActionTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#groupActionTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			$('#groupActionTable').tableDataFilter($(this).parents('div.divToolBox'), true);
			$('#groupActionTable').removeData('divToolBox');
			//絞り込みのためのツールボックス情報と、クリック位置を保存する
			var clickIndex = $(this).parents('div.divToolBox').data('clickIndex');
			$('#groupActionTable').data('divToolBox', $(this).parents('div.divToolBox').clone(true).data('clickIndex', clickIndex));
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#groupActionTable').removeData('divToolBox');
			$('#groupActionTable').removeData('sortData');//ソート順も解除する
			$(this).parents('div.divToolBox').remove();
			//初期表示に戻すため、サーバーにデータを再要求する
			objActionSetting.ajaxActionSettingRequest();
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objActionSetting.intervalTimerId = setInterval(autoRefreshTimer, 1000);
	$(window).unload(function() {
		clearInterval(objActionSetting.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// 子要素の取得応答
//=============================================================================
function detailsGroup_groupActionAction_ajaxActionSetting(objectMapList) {
	//受信データ設定
	objActionSetting.ajaxActionSettingResponse(objectMapList);
	//ページ表示の更新
	objActionSetting.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');

}

//=============================================================================
//グループアクション設定のリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#groupActionTable').data('refresh', true);
	//グループアクション設定の情報取得要求
	objActionSetting.ajaxActionSettingRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#groupActionTable').data('refresh') == true){
		$('#groupActionTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objActionSetting.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#groupActionTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#groupActionTable').data('refresh') == true){
		$('#groupActionTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
