//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objactionLog = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined) window.parent.tabPageClear();

	//書き込み権限
	objactionLog.permissionWrite = $(top.document).find('#permissionWrite').val();

	//=========================================================================
	// プロパティ
	//=========================================================================
	objactionLog.groupId = $('#groupId').val();
	objactionLog.maxRow = ($('#maxLogRow', top.document).val() != undefined)? $('#maxLogRow', top.document).val(): '300';
	objactionLog.objectMapList = [];
	objactionLog.logOffset = 0;
	objactionLog.requestParams = {};

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// アクションログの取得要求
	//-------------------------------------------------------------------------
	objactionLog.ajaxActionLogRequest = function( requestData ){
		//デフォルトパラメータ
		var requestParams = {'groupId':objactionLog.groupId,
				'maxRow':				objactionLog.maxRow,
				'order':				false};
		if( requestData == undefined ){
			//未定義の場合には、現在の条件のまま、要求を行う
			requestParams = objactionLog.requestParams;
		}else if( requestData == 'default' ){
			//nullの場合には、絞込みの条件なしで、要求を行う
			//要求パラメータの保存
			objactionLog.requestParams = requestParams;
		}else{
			var requestType = {'未来時間表示日時過去時間表示':'filterDate', 'アクション名':'filterActionName', 'トリガー':'filterConditionList', '結果':'filterResultCodeList', 'コード':'filterExitCodeList', '概要':'filterOutline'};
			//設定のあった項目だけ上書きする
			if(requestType[requestData['filter']] == 'filterActionName'){
				requestParams['filterActionName'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterInstanceName'){
				requestParams['filterInstanceName'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterDate'){
				var timeStringBefore = requestData['data'].find(':text[name=filterDateBefore]').val();
				var temp = (Date.parse(timeStringBefore)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['beginDate'] = temp;
				}

				var timeString = requestData['data'].find(':text[name=filterDate]').val();
				var temp = (Date.parse(timeString)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['endDate'] = temp;
				}
			}else if(requestType[requestData['filter']] == 'filterConditionList'){
				//アクション実行条件による絞込み
				var conditionList = new Array();
				requestData['data'].find(':checked').each(function(){
					conditionList.push($(this).val());
				});
				requestParams['filterConditionList'] = conditionList;
				//インスタンス名による絞込み
				var instanceName = requestData['data'].find('input:text[name="instanceName"]').val();
				requestParams['filterInstanceName'] = instanceName;
			}else if(requestType[requestData['filter']] == 'filterResultCodeList'){
				var resultCodeList = [];
				requestData['data'].find(':checked').each(function(){
					resultCodeList.push(Number($(this).val()));
				});
				requestParams['filterResultCodeList'] = resultCodeList;
			}else if(requestType[requestData['filter']] == 'filterExitCodeList'){
				var exitCodeList = [];
				var temp;
				//「,」区切り文字とする
				temp = (requestData['data'].find(':text').val()).split(',');
				for(i in temp){
					if(isNaN(Number(temp[i]))==false){
						exitCodeList.push(Number(temp[i]));
					}
				}
				requestParams['filterExitCodeList'] = exitCodeList;
			}else if(requestType[requestData['filter']] == 'filterOutline'){
				requestParams['filterOutline'] = requestData['data'].find(':text').val();
			}
		};
		//要求パラメータの保存
		objactionLog.requestParams = requestParams;

		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupActionLogAction_ajaxActionLog, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupActionLogAction', 'action' : 'ajaxActionLog', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsGroup_groupActionLogAction_ajaxActionLog, 'json');
	};

	//-------------------------------------------------------------------------
	// アクションログの取得応答
	//-------------------------------------------------------------------------
	objactionLog.ajaxActionLogResponse = function( objectMapList ){
		try{
			//次ページが存在しない場合には、過去時間表示のボタンを消す
			if(objectMapList.length<parseInt(objactionLog.maxRow)){
			    $('#iconGoPastPage').hide();
			}else{
			    $('#iconGoPastPage').show();
			}
			if(objectMapList.length<=0) throw 'noItem';

			delete objactionLog.objectMapList;
			objactionLog.objectMapList = [];
			for (i in objectMapList) {
				objactionLog.objectMapList[i] = objectMapList[i];
				//ステータスの設定
				if(!('normal' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['normal'] = 0;
				}
				if(!('warning' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['warning'] = 0;
				}
				if(!('danger' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['danger'] = 0;
				}
				if(!('failure' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['failure'] = 0;
				}
				if(!('disconnectAgent' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['disconnectAgent'] = false;
				}
				if(!('disconnectHelper' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['disconnectHelper'] = false;
				}
				if(!('disconnectComputer' in objactionLog.objectMapList[i])){
					objactionLog.objectMapList[i]['disconnectComputer'] = false;
				}
			}
		}catch(e){
			if(e == 'noItem'){
				delete objactionLog.objectMapList;
				objactionLog.objectMapList = [];
			}
		}
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objactionLog.pageUpdate = function(){
		try{
			var tableBody = $('#groupActionLogTable').children('tbody');

			//受信データがない場合には中身をクリアする
			if(objactionLog.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//実行日時
			var tdActionLogDateArray = [];
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogDateStyle');
				var p = $('<p>');
				var string = (new String(thisObjectMap['date'])).replace(/ /, '<br/>');
				var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['date']);
				p.append(string).append(input);
				td.append(p);
				tdActionLogDateArray.push(td);
			}

			//アクション名
			var tdActionNameArray = [];
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogActionNameStyle');
				var p = $('<p>');
				//書き込み権限がない場合には、アクション一覧へのリンクを追加しない
				if(objactionLog.permissionWrite == 'true'){
					p.addClass('objectLinkAction');
				}
				var inputActionInstanceId = $('<input type="hidden" name="actionInstanceId">').attr('value', thisObjectMap['groupId']);
				var string = thisObjectMap['actionName'];
				p.attr('title', string).append(inputActionInstanceId).append(string);
				td.append(p);
				tdActionNameArray.push(td);
			}

			//トリガー
			var tdTriggerArray = [];
			var statusIconHashTable = {'triggerComputerDisconnect':'../../images/summaryDisconnectComputer16.png',
										'triggerHelperDisconnect':'../../images/summaryDisconnectHelper16.png',
										'triggerMonitorDisconnect':'../../images/summaryDisconnectAgent16.png',
										'triggerFailure':'../../images/summaryFailure16.png',
										'triggerDanger':'../../images/summaryDanger16.png',
										'triggerWarning':'../../images/summaryWarning16.png',
										'triggerNormal':'../../images/summaryInformation16.png'};
            var statusIconAltHashTable = {'triggerComputerDisconnect':'実行条件：コンピューター接続エラー',
					'triggerHelperDisconnect':'実行条件：ヘルパーサービス接続エラー',
					'triggerMonitorDisconnect':'実行条件：監視サービス停止中',
					'triggerFailure':'実行条件：失敗',
					'triggerDanger':'実行条件：危険',
					'triggerWarning':'実行条件：注意',
					'triggerNormal':'実行条件：正常'};
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogTriggerStyle');
				var p = $('<p>');
				var pInstance = $('<p>');
				var imgTriggerIconArray = $('<span>');
				var imgTriggerIcon;
				var temp = '';
	            var implantData = 0;
				var instanceName = thisObjectMap['instanceName'];
				if(instanceName != ""){
					if(thisObjectMap['triggerComputerDisconnect']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'コンピュータとの通信断';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerComputerDisconnect']).attr('title', statusIconAltHashTable['triggerComputerDisconnect']);
						implantData += 64;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerHelperDisconnect']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'ヘルパーサービス接続エラー';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerHelperDisconnect']).attr('title', statusIconAltHashTable['triggerHelperDisconnect']);
						implantData += 32;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerMonitorDisconnect']=='true'){
						imgTriggerIcon = $('<img>');
						temp = '監視サービス停止中';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerMonitorDisconnect']).attr('title', statusIconAltHashTable['triggerMonitorDisconnect']);
						implantData += 16;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerFailure']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'ステータス「失敗」';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerFailure']).attr('title', statusIconAltHashTable['triggerFailure']);
						implantData += 8;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerDanger']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'ステータス「危険」';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerDanger']).attr('title', statusIconAltHashTable['triggerDanger']);
						implantData += 4;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerWarning']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'ステータス「警告」';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerWarning']).attr('title', statusIconAltHashTable['triggerWarning']);
						implantData += 2;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(thisObjectMap['triggerNormal']=='true'){
						imgTriggerIcon = $('<img>');
						temp = 'ステータス「正常」';
						imgTriggerIcon.attr('src', statusIconHashTable['triggerNormal']).attr('title', statusIconAltHashTable['triggerNormal']);
						implantData += 1;
						imgTriggerIconArray.append(imgTriggerIcon);
					}
					if(temp != ''){
						var spanText = $('<span>').addClass('objectLink');
						var inputInstanceName = $('<input type="hidden" name="instanceName">').attr('value', thisObjectMap['instanceName']);
						var inputCurrentType = $('<input type="hidden" name="currentType">').attr('value', thisObjectMap['instanceType']);
						var inputCurrentId = $('<input type="hidden" name="currentId">').attr('value', thisObjectMap['instanceId']);
							spanText.append(inputInstanceName).append(inputCurrentType).append(inputCurrentId).append(instanceName).attr('title', thisObjectMap['instanceName']);
						var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', implantData);
						p.append('[').append(imgTriggerIconArray).append('] ').append(inputSortdata);
						pInstance.append(spanText);
						td.append(p).append(pInstance);
					}
				}else{
					p.append('（削除されました）');
					td.append(p);
				}
				tdTriggerArray.push(td);
			}

			//終了結果
			var tdResultArray = [];
			var resultTable = {'0':'成功', '1':'エラー', '2':'失敗'};
			var statusIconHashTable = {'0':'logStateInformation16', '1':'logStateError16', '2':'logStateWarning16'};
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogResultStyle');
				var p = $('<p>');
				var imgResultCode = $('<img  src="../../images/invisible16.png>').addClass(statusIconHashTable[thisObjectMap['resultCode']]);
				var string = resultTable[thisObjectMap['resultCode']];
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', thisObjectMap['resultCode']);
				p.append(imgResultCode).append(string).append(inputSortdata);
				td.append(p);
				tdResultArray.push(td);
			}

			//終了コード
			var tdExitCodeArray = [];
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogExitCodeStyle');
				var p = $('<p>');
				var temp = Number(thisObjectMap['exitCode']);
				if(temp<0){
					temp = temp + parseInt('ffffffff', 16)+1;
				}
				var string = '0x'+ temp.toString(16).toUpperCase();
				p.append(string);
				td.append(p);
				tdExitCodeArray.push(td);
			}

			//概要
			var tdOutlineArray = [];
			for(i in objactionLog.objectMapList){
				var thisObjectMap = objactionLog.objectMapList[i];
				var td = $('<td>').addClass('groupActionLogActionSummaryStyle');
				var p = $('<p>');
				var string = thisObjectMap['outline'];
				p.attr('title', string).append(string);
				td.append(p);
				tdOutlineArray.push(td);
			}

			//データを合成
			//tbody
			tableBody.empty();
			for(i in objactionLog.objectMapList){
				tableBody.append($('<tr>').append(tdActionLogDateArray[i]).append(tdActionNameArray[i]).append(tdTriggerArray[i]).append(tdResultArray[i]).append(tdExitCodeArray[i]).append(tdOutlineArray[i]));
			}

			tdActionLogDateArray = null;
			tdActionNameArray = null;
			tdTriggerArray = null;
			tdResultArray = null;
			tdExitCodeArray = null;
			tdOutlineArray = null;

			//テーブル要素の表示
			$('#groupActionLogTable').children('tbody')
											.css('visibility', 'visible')
											.end()
											.trigger('update');
		}finally{
			if($('#groupActionLogTable').data('refresh') == true){
				$('#groupActionLogTable').tableDataSort();
				$('#groupActionLogTable').removeData('refresh');
			}
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objactionLog.ajaxActionLogRequest('default');

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//テーブル機能の拡張を行う
	$('#groupActionLogTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// 絞込みボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		var requestData = {'filter':thisDivToolBox.data('targetTh').text(), 'data':thisDivToolBox};
		objactionLog.logOffset = 0;
		objactionLog.ajaxActionLogRequest(requestData);
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 絞込み解除ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterCancelButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		objactionLog.logOffset = 0;
		objactionLog.ajaxActionLogRequest('default');
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 過去時間表示か未来時間表示をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionLogTable').on('click', '#iconGoFuturePage,#iconGoPastPage', function(){
		var maxRow = parseInt(objactionLog.maxRow);
		if($(this).attr('id') == 'iconGoPastPage'){
			objactionLog.logOffset+=maxRow;
		}else{
			if(objactionLog.logOffset >= maxRow){
				objactionLog.logOffset-=maxRow;
			}
		}
		//リクエストパラメータの編集
		var requestParams = objactionLog.requestParams;
		//表示ページを移動する
		requestParams['offset'] = objactionLog.logOffset;

		//データを要求する
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupActionLogAction_ajaxActionLog, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupActionLogAction', 'action' : 'ajaxActionLog', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsGroup_groupActionLogAction_ajaxActionLog, 'json');
		return false;
	});
	//-------------------------------------------------------------------------
    // リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionLogTable').on('click', '.objectLink', function(){
    	var currentId = $(this).find('[name=currentId]').val();

		//ページ移動
		$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + currentId);
    });
	//-------------------------------------------------------------------------
    // リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionLogTable').on('click', '.objectLinkAction', function(){
    	var actionInstanceId = $(this).find('[name=actionInstanceId]').val();
		window.parent.parent.showDialog('action/actionList.html?groupId='+actionInstanceId, 'アクションの編集');
   });

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupActionLogTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#groupActionLogTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#groupActionLogTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#groupActionLogTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#groupActionLogTable').removeData('sortData');////ソート順も解除する
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objactionLog.intervalTimerId = setInterval(autoRefreshTimer, 1000);
	$(window).unload(function() {
		clearInterval(objactionLog.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// アクションログの取得応答
//=============================================================================
function detailsGroup_groupActionLogAction_ajaxActionLog(objectMapList) {
	objactionLog.ajaxActionLogResponse(objectMapList);
	objactionLog.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//グループアクションログのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#groupActionLogTable').data('refresh', true);
	//グループアクションログ情報取得要求
	objactionLog.ajaxActionLogRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#groupActionLogTable').data('refresh') == true){
		$('#groupActionLogTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objactionLog.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#groupActionLogTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#groupActionLogTable').data('refresh') == true){
		$('#groupActionLogTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

