//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objhistoryLogList = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined){
		window.parent.tabPageClear();
	}

	//=========================================================================
	// プロパティ
	//=========================================================================
	objhistoryLogList.groupId = $('#groupId').val();
	objhistoryLogList.maxRow = ($('#maxLogRow', top.document).val()!=undefined)? $('#maxLogRow', top.document).val(): '300';
	objhistoryLogList.logOffset = 0;
	objhistoryLogList.objectMapList = [];
	objhistoryLogList.iconImgSrcTable = {
			'invisible': '../../images/invisible32.png'
	};
	objhistoryLogList.requestParams = {};

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// サマリーの取得要求
	//-------------------------------------------------------------------------
	objhistoryLogList.ajaxHistoryLogListRequest = function( requestData ){
		//デフォルトパラメータ
		var requestParams = {'id':	objhistoryLogList.groupId,
				'maxRow':			objhistoryLogList.maxRow,
				'order':			false};
		if( requestData == undefined ){
			//未定義の場合には、現在の条件のまま、要求を行う
			requestParams = objhistoryLogList.requestParams;
		}else if( requestData == 'default' ){
			//nullの場合には、絞込みの条件なしで、要求を行う
			//要求パラメータの保存
			objhistoryLogList.requestParams = requestParams;
		}else{
			var requestType = {'タイプ':'filterTypeList','表示名':'filterName', '未来時間表示日時過去時間表示':'filterDate', 'カテゴリ':'filterCategory', 'サマリー':'filterSummary'};
			//設定のあった項目だけ上書きする
			if(requestType[requestData['filter']] == 'filterName'){
				requestParams['filterName'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterDate'){
				var timeStringBefore = requestData['data'].find(':text[name=filterDateBefore]').val();
				var temp = (Date.parse(timeStringBefore)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['beginDate'] = temp;
				}

				var timeString = requestData['data'].find(':text[name=filterDate]').val();
				var temp = (Date.parse(timeString)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['endDate'] = temp;
				}
			}else if(requestType[requestData['filter']] == 'filterTypeList'){
				var typeList = [];
				requestData['data'].find(':checked').each(function(){
					typeList.push($(this).val());
				});
				requestParams['filterTypeList'] = typeList;
			}else if(requestType[requestData['filter']] == 'filterCategory'){
				requestParams['filterCategory'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterSummary'){
				requestParams['filterSummary'] = requestData['data'].find(':text').val();
			}
			//要求パラメータの保存
			objhistoryLogList.requestParams = requestParams;
		}

		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupHistoryLogAction', 'action' : 'ajaxHistoryLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, 'json');
	};

	//-------------------------------------------------------------------------
	// サマリーの取得応答
	//-------------------------------------------------------------------------
	objhistoryLogList.ajaxHistoryLogListResponse = function(objectMapList){
		try{
			//次ページが存在しない場合には、過去時間表示のボタンを消す
			if(objectMapList.length<parseInt(objhistoryLogList.maxRow)){
			    $('#iconGoPastPage').hide();
			}else{
			    $('#iconGoPastPage').show();
			}
			if(objectMapList.length<=0) throw 'noItem';
			delete objhistoryLogList.objectMapList;
			objhistoryLogList.objectMapList = [];
			for (i in objectMapList) {
				objhistoryLogList.objectMapList[i] = objectMapList[i];
			}
		}catch(e){
			if(e == 'noItem'){
				delete objhistoryLogList.objectMapList;
				objhistoryLogList.objectMapList = [];
			}
		}
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objhistoryLogList.pageUpdate = function(){
		try{
			var tableBody = $('#groupHistoryLogTable').children('tbody');
			objhistoryLogList.statusStringHashTable = {1:'エラー',
					2:'警告',
					4:'情報'};

			objhistoryLogList.statusIconHashTable = {1:'logStateError32',
					2:'logStateWarning32',
					4:'logStateInformation32'};


			//受信データがない場合には中身をクリアする
			if(objhistoryLogList.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//タイプ
			var tdTypeArray = [];
			for(i in objhistoryLogList.objectMapList){
				var thisObjectMap = objhistoryLogList.objectMapList[i];
				var td = $('<td>').addClass('groupHistoryTypeStyle');
				var p = $('<p>');
				var imgLogType = $('<img>').attr('src', objhistoryLogList.iconImgSrcTable['invisible']).addClass(objhistoryLogList.statusIconHashTable[thisObjectMap['logType']]);
				var string = objhistoryLogList.statusStringHashTable[thisObjectMap['logType']];
				p.append(imgLogType).append(string);
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', thisObjectMap['logType']);
				td.append(p).append(inputSortdata);
				tdTypeArray.push(td);
			}

			//表示名
			var tdDisplayNameArray = [];
			for(i in objhistoryLogList.objectMapList){
				var thisObjectMap = objhistoryLogList.objectMapList[i];
				var td = $('<td>').addClass('groupHistoryInstanceNameStyle');
				var p = $('<p>').addClass('objectLink');
				var inputCurrentType = $('<input type="hidden" name="currentType">').attr('value', thisObjectMap['type']);
				var inputCurrentId = $('<input type="hidden" name="currentId">').attr('value', thisObjectMap['id']);
				var string = thisObjectMap['name'];
				p.attr('title', string).append(inputCurrentType).append(inputCurrentId).append(string);
				td.append(p);
				tdDisplayNameArray.push(td);
			}

			//日時
			var tdDateArray = [];
			for(i in objhistoryLogList.objectMapList){
				var thisObjectMap = objhistoryLogList.objectMapList[i];
				var td = $('<td>').addClass('groupHistoryDateStyle');
				var p = $('<p>');
				var string = (new String(thisObjectMap['date'])).replace(/ /, '<br/>');
				var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['date']);
				p.append(string).append(input);
				td.append(p);
				tdDateArray.push(td);
			}

			//カテゴリ
			var tdCategoryArray = [];
			for(i in objhistoryLogList.objectMapList){
				var thisObjectMap = objhistoryLogList.objectMapList[i];
				var td = $('<td>').addClass('groupHistoryCategoryStyle');
				var p = $('<p>');
				var string = thisObjectMap['category'];
				p.append(string);
				td.append(p);
				tdCategoryArray.push(td);
			}

			//サマリー
			var tdSummaryArray = [];
			for(i in objhistoryLogList.objectMapList){
				var thisObjectMap = objhistoryLogList.objectMapList[i];
				var td = $('<td>').addClass('groupHistorySummaryStyle');
				var p = $('<p>');
				var string = thisObjectMap['summary'];
				p.attr('title', string).append(string);
				td.append(p);
				tdSummaryArray.push(td);
			}

			//データを合成
			//tbody
			tableBody.empty();
			for(i in objhistoryLogList.objectMapList){
				tableBody.append($('<tr>').append(tdTypeArray[i]).append(tdDisplayNameArray[i]).append(tdDateArray[i]).append(tdCategoryArray[i]).append(tdSummaryArray[i]));
			}

			tdTypeArray = null;
			tdDisplayNameArray = null;
			tdDateArray = null;
			tdCategoryArray = null;
			tdSummaryArray = null;

			//テーブル要素の表示
			$('#groupHistoryLogTable').children('tbody')
											.css('visibility', 'visible')
										.end()
										.trigger('update');
		}finally{
			if($('#groupHistoryLogTable').data('refresh') == true){
				$('#groupHistoryLogTable').tableDataSort();
				$('#groupHistoryLogTable').removeData('refresh');
			}
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objhistoryLogList.ajaxHistoryLogListRequest('default');

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//テーブル機能の拡張を行う
	$('#groupHistoryLogTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// 絞込みボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		var requestData = {'filter':thisDivToolBox.data('targetTh').text(), 'data':thisDivToolBox};
		objhistoryLogList.logOffset = 0;
		objhistoryLogList.ajaxHistoryLogListRequest(requestData);
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 絞込み解除ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterCancelButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		objhistoryLogList.logOffset = 0;
		objhistoryLogList.ajaxHistoryLogListRequest('default');
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 過去時間表示か未来時間表示をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupHistoryLogTable').on('click', '#iconGoFuturePage,#iconGoPastPage', function(){
		var maxRow = parseInt(objhistoryLogList.maxRow);
		if($(this).attr('id') == 'iconGoPastPage'){
			objhistoryLogList.logOffset+=maxRow;
		}else{
			if(objhistoryLogList.logOffset >= maxRow){
				objhistoryLogList.logOffset-=maxRow;
			}
		}
		//リクエストパラメータの編集
		var requestParams = objhistoryLogList.requestParams;
		//表示ページを移動する
		requestParams['offset'] = objhistoryLogList.logOffset;

		//データを要求する
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupHistoryLogAction', 'action' : 'ajaxHistoryLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, 'json');
		return false;
	});
	//-------------------------------------------------------------------------
    // リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupHistoryLogTable').on('click', '.objectLink', function(){
    	var currentId = $(this).find('[name=currentId]').val();
		//ページ移動
    	$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + currentId);
    });

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupHistoryLogTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#groupHistoryLogTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#groupHistoryLogTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#groupHistoryLogTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#groupHistoryLogTable').removeData('sortData');////ソート順も解除する
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objhistoryLogList.intervalTimerId = setInterval(autoRefreshTimer, 1000);
	$(window).unload(function() {
		clearInterval(objhistoryLogList.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// 子要素の取得応答
//=============================================================================
function detailsGroup_groupHistoryLogAction_ajaxHistoryLogList(objectMapList) {
	//受信データ設定
	objhistoryLogList.ajaxHistoryLogListResponse(objectMapList);
	//ページ表示の更新
	objhistoryLogList.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//グループヒストリーログのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#groupHistoryLogTable').data('refresh', true);
 //グループヒストリーログの情報取得要求
	objhistoryLogList.ajaxHistoryLogListRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#groupHistoryLogTable').data('refresh') == true){
		$('#groupHistoryLogTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objhistoryLogList.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#groupHistoryLogTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
// ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#groupHistoryLogTable').data('refresh') == true){
		$('#groupHistoryLogTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
