//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
var newStatusLogList = {};
newStatusLogList.requestParams = {};
$(document).ready(function(){
	//他のタブの情報を削除する
	window.parent.tabPageClear();

	//=========================================================================
	// プロパティ定義
	//=========================================================================
	newStatusLogList.instanceId = $('#instanceId').val();			//インスタンスID
	newStatusLogList.maxRow = $('#maxLogRow', top.document).val();	//最大件数
	newStatusLogList.logOffset = 0;									//表示位置
	newStatusLogList.objectMapList = [];							//受信したデータの格納エリア
	newStatusLogList.instanceStateClassTable = {
    		'disconnectComputer'	:'instanseStateDisconnectComputer32',
            'disconnectHelper'		:'instanseStateDisconnectHelper32',
            'disconnectAgent'		:'instanseStateDisconnectAgent32',
            'failure'				:'instanseStateFailure32',
            'danger'				:'instanseStateDanger32',
            'warning'				:'instanseStateWarning32',
            'normal'				:'instanseStateSuccess32'};
	newStatusLogList.imagePathTable = {
			'confirmed'	: '../../images/confirm32.png',
			'invisible'	: '../../images/invisible32.png'};
	newStatusLogList.titleStringTable = {
    		'disconnectComputer'	:'コンピューター接続エラー',
            'disconnectHelper'		:'ヘルパーサービス接続エラー',
            'disconnectAgent'		:'監視サービス停止中',
            'failure'				:'失敗',
            'danger'				:'危険',
            'warning'				:'注意',
            'normal'				:'正常',
            'invisible'				:''};

	//=========================================================================
	// メソッド定義
	//=========================================================================
	//-------------------------------------------------------------------------
	// ステータスログの取得要求
	//-------------------------------------------------------------------------
	newStatusLogList.ajaxStatusLogListRequest = function( requestData ){
		//デフォルトパラメータ
		var requestParams = {'id':	this.instanceId,
				'maxRow':			this.maxRow,
				'order':			false};
		if( requestData == undefined ){
			//未定義の場合には、現在の条件のまま、要求を行う
			requestParams = newStatusLogList.requestParams;
		}else if( requestData == 'default' ){
			//nullの場合には、絞込みの条件なしで、要求を行う
			//要求パラメータの保存
			newStatusLogList.requestParams = requestParams;
		}else{
			//その他の場合には、設定されたデータで、要求を行う
			var requestType = {'filterFailureCount':'filterFailureCount', 'filterDangerCount':'filterDangerCount', 'filterWarningCount':'filterWarningCount', 'filterNormalCount':'filterNormalCount', '未来時間表示時刻過去時間表示':'filterDate', 'ステータス':'filterStatusList', '概要':'filterOutline'};
			//設定のあった項目だけ上書きする
			if(requestType[requestData['filter']] == 'filterDate'){
				var timeStringBefore = requestData['data'].find(':text[name=filterDateBefore]').val();
				var temp = (Date.parse(timeStringBefore)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['beginDate'] = temp;
				}

				var timeString = requestData['data'].find(':text[name=filterDate]').val();
				var temp = (Date.parse(timeString)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['endDate'] = temp;
				}
			}else if(requestType[requestData['filter']] == 'filterStatusList'){
				var statusList = [];
				requestData['data'].find(':checked').each(function(){
					statusList.push($(this).val());
				});
				requestParams['filterStatusList'] = statusList;
			}else if(requestType[requestData['filter']] == 'filterFailureCount'){
				requestParams['filterFailureCount'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterDangerCount'){
				requestParams['filterDangerCount'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterWarningCount'){
				requestParams['filterWarningCount'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterNormalCount'){
				requestParams['filterNormalCount'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterOutline'){
				requestParams['filterOutline'] = requestData['data'].find(':text').val();
			}
			//要求パラメータの保存
			newStatusLogList.requestParams = requestParams;
		}

		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceStatusLogAction_ajaxStatusLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceStatusLogAction', 'action' : 'ajaxStatusLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsInstance_instanceStatusLogAction_ajaxStatusLogList, 'json');
	};
	//-------------------------------------------------------------------------
	// 確認ステータスの設定要求
	//-------------------------------------------------------------------------
	newStatusLogList.ajaxConfirmStatusRequest = function(idList, checked){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(idList),'AjaxParam1' : checked};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceStatusLogAction_ajaxConfirmStatus, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceStatusLogAction', 'action' : 'ajaxConfirmStatus', 'AjaxParam0' : Kumu.JSONSerializer.serialize(idList), 'AjaxParam1' : checked}, detailsInstance_instanceStatusLogAction_ajaxConfirmStatus, 'json');
	};
	//-------------------------------------------------------------------------
	// 確認ステータスの設定要求(全部)
	//-------------------------------------------------------------------------
	newStatusLogList.ajaxAllConfirmStatusRequest = function(paramInstanceId){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : paramInstanceId};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceStatusLogAction_ajaxAllConfirmStatus, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceStatusLogAction', 'action' : 'ajaxAllConfirmStatus', 'AjaxParam0' : paramInstanceId}, detailsInstance_instanceStatusLogAction_ajaxAllConfirmStatus, 'json');
	};
	//-------------------------------------------------------------------------
	// 子要素の取得応答
	//-------------------------------------------------------------------------
	newStatusLogList.ajaxStatusLogListResponse = function(objectMapList, option){
		var objectMapListLength = objectMapList.length;
		if( option != 'partialUpdate' ){
			//次ページが存在しない場合には、過去時間表示のボタンを消す
			if(objectMapListLength<parseInt(newStatusLogList.maxRow)){
			    $('#iconGoPastPage').hide();
			}else{
			    $('#iconGoPastPage').show();
			}
		}

		this.objectMapList = [];
		if(objectMapListLength<=0){
			return;
		}
		for(var i=0; i<objectMapListLength; i+=1){
			this.objectMapList[i] = objectMapList[i];
			//ステータスの設定
			if(!('normal' in this.objectMapList[i])){
				this.objectMapList[i]['normal'] = 0;
			}
			if(!('warning' in this.objectMapList[i])){
				this.objectMapList[i]['warning'] = 0;
			}
			if(!('danger' in this.objectMapList[i])){
				this.objectMapList[i]['danger'] = 0;
			}
			if(!('failure' in this.objectMapList[i])){
				this.objectMapList[i]['failure'] = 0;
			}
			if(!('disconnectAgent' in this.objectMapList[i])){
				this.objectMapList[i]['disconnectAgent'] = 'false';
			}
			if(!('disconnectHelper' in this.objectMapList[i])){
				this.objectMapList[i]['disconnectHelper'] = 'false';
			}
			if(!('disconnectComputer' in this.objectMapList[i])){
				this.objectMapList[i]['disconnectComputer'] = 'false';
			}
			if(!('statusConfirmed' in this.objectMapList[i])){
				this.objectMapList[i]['statusConfirmed'] = 'false';
			}
		}
	};
	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	newStatusLogList.pageUpdate = function(partialUpdate){
		try{
			var tableBody = $('#instanceStatusLogTable').children('tbody');
	        var objectMapListLength = this.objectMapList.length;
	        var i = 0;
	        var j = 0;

			//確認の処理を行う
			var tdStatusConfirmArray = [];
			for(i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusConfirmStyle');
				if(thisObjectMap['statusConfirmed'] == 'true'){
					td.append($('<p/>')
							.append($('<label/>')
									.append( $('<input type="checkbox"/>').attr('checked', true).attr('name', 'logId').val(thisObjectMap['logId']) )
									.append( $('<input type="hidden"/>').attr('name', 'sortdata').val('1') )
							)
					);
				}else{
					td.append($('<p/>')
							.append($('<label/>')
									.append( $('<input type="checkbox"/>').attr('checked', false).attr('name', 'logId').val(thisObjectMap['logId']) )
									.append( $('<input type="hidden"/>').attr('name', 'sortdata').val('0') )
							)
					);
				}
				tdStatusConfirmArray.push(td);
				td = null;
			}

			//ポーリング時刻の処理を行う
			var tdPollingDateArray = [];
			for(var i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusPollingDateStyle')
					.append($('<p/>').html((new String(thisObjectMap['date'])).replace(/ /, '<br/>'))
							.prepend( $('<input type="hidden"/>').attr('name', 'date').val(thisObjectMap['date']) )
					);
				tdPollingDateArray.push(td);
				td = null;
			}

			//ステータスの処理を行う
			var tdStatusArray = [];
			var allStatusTable1 = ['disconnectComputer', 'disconnectHelper', 'disconnectAgent'];
			var allStatusTable2 = ['failure', 'danger', 'warning', 'normal'];
			var allStatusImplantDataHashTable = {'disconnectComputer':64, 'disconnectHelper':32, 'disconnectAgent':16,
	                'failure':8, 'danger':4, 'warning':2, 'normal':1};
			var allStatusHashTable = {'disconnectComputer':'', 'disconnectHelper':'', 'disconnectAgent':'',
			                      'failure':'', 'danger':'', 'warning':'', 'normal':''};
			for(var i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusStatusStyle')
					.append( $('<p/>') );
	            var implantData = 0;

				var statusConfirmed = (thisObjectMap['statusConfirmed']=='true')?'true':'false';
				var srcString = '';
				var titleString = '';
				var className = '';
				var statusTableSize = 0;

				//全ステータスのデータを作成する
				statusTableSize = allStatusTable1.length;
				for(j=0; j<statusTableSize; j+=1){
					var thisStatus = allStatusTable1[j];
					if(thisObjectMap[thisStatus]=='true'){
						className = this.instanceStateClassTable[thisStatus];
						titleString = this.titleStringTable[thisStatus];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = this.imagePathTable['confirmed'];
						}else{
							srcString = this.imagePathTable['invisible'];
						}
						implantData += allStatusImplantDataHashTable[thisStatus];
					}else{
						className = '';
						srcString = this.imagePathTable['invisible'];
						titleString = '';
					}
					allStatusHashTable[thisStatus] = $('<img/>').addClass(className).attr('src', srcString).attr('title', titleString);
				}

				//全ステータスのデータを作成する
				statusTableSize = allStatusTable2.length;
				for(j=0; j<statusTableSize; j+=1){
					var thisStatus = allStatusTable2[j];
					if(Number(thisObjectMap[thisStatus])>0){
						className = this.instanceStateClassTable[thisStatus];
						titleString = this.titleStringTable[thisStatus];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = this.imagePathTable['confirmed'];
						}else{
							srcString = this.imagePathTable['invisible'];
						}
						implantData += allStatusImplantDataHashTable[thisStatus];
					}else{
						className = '';
						srcString = this.imagePathTable['invisible'];
						titleString = '';
					}
					allStatusHashTable[thisStatus] = $('<img/>').addClass(className).attr('src', srcString).attr('title', titleString);
				}


				statusTableSize = allStatusTable1.length;
				for(j=0; j<statusTableSize; j+=1){
					var thisStatus = allStatusTable1[j];
					td.children('p').append(allStatusHashTable[thisStatus]);
					allStatusHashTable[thisStatus] = null;
				}
				statusTableSize = allStatusTable2.length;
				for(j=0; j<statusTableSize; j+=1){
					var thisStatus = allStatusTable2[j];
					td.children('p').append(allStatusHashTable[thisStatus]);
					allStatusHashTable[thisStatus] = null;
				}

				td.children('p')
					.append( $('<input type="hidden"/>').attr('name', 'sortdata').val(implantData) )
					.append( $('<input type="hidden"/>').attr('name', 'statusConfirmed').val(statusConfirmed) );

				tdStatusArray.push(td);
			}

			//失敗
			var tdFailureArray = [];
			for(i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusFailureStyle');
				td.append(
						$('<p/>')
							.html(thisObjectMap['failure'])
							.prepend( $('<input type="hidden"/>').attr('name', 'sortdata').val(thisObjectMap['failure']) )
					);
				tdFailureArray.push(td);
				td = null;
			}

			//危険
			var tdDangerArray = [];
			for(i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusDangerStyle');
				td.append(
						$('<p/>')
							.html(thisObjectMap['danger'])
							.prepend( $('<input type="hidden"/>').attr('name', 'sortdata').val(thisObjectMap['danger']) )
					);
				tdDangerArray.push(td);
				td = null;
			}

			//注意
			var tdWarningArray = [];
			for(i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusWarningStyle');
				td.append(
						$('<p/>')
							.html(thisObjectMap['warning'])
							.prepend( $('<input type="hidden"/>').attr('name', 'sortdata').val(thisObjectMap['warning']) )
					);
				tdWarningArray.push(td);
				td = null;
			}

			//正常
			var tdNormalArray = [];
			for(i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusNormalStyle');
				td.append(
						$('<p/>').html(thisObjectMap['normal'])
							.prepend( $('<input type="hidden"/>').attr('name', 'sortdata').val(thisObjectMap['normal']) )
					);
				tdNormalArray.push(td);
				td = null;
			}

			//概要の処理を行う
			var tdSummaryArray = [];
			for( i=0; i<objectMapListLength; i+=1){
				var thisObjectMap = this.objectMapList[i];
				var td = $('<td/>').addClass('instanceStatusSummaryStyle')
					.append( $('<p/>').attr('title', thisObjectMap['outline']).html(thisObjectMap['outline']) );
				tdSummaryArray.push(td);
				td = null;
			}

			//データを合成
			//tbody
			//指定があった場合には部分更新
			if(partialUpdate == 'partialUpdate'){
				var tableBodyObj = tableBody.clone(true);
				tableBodyObj.empty();
				for(var i=0; i<objectMapListLength; i+=1){
					tableBodyObj.append($('<tr>/')
							.append(tdStatusConfirmArray[i])
							.append(tdPollingDateArray[i])
							.append(tdStatusArray[i])
							.append(tdFailureArray[i])
							.append(tdDangerArray[i])
							.append(tdWarningArray[i])
							.append(tdNormalArray[i])
							.append(tdSummaryArray[i]));
				}

				//対象の行のみ修正
				var responseTrData = tableBodyObj.children('tr');
				var searchCheckbox = tableBody.children('tr').children('td.instanceStatusConfirmStyle').find('input:checkbox[name="logId"]');

				responseTrData.each(function(){
					var thisTrData = $(this);
					var thisLogId = thisTrData.children('td.instanceStatusConfirmStyle').find('input:checkbox[name="logId"]').val();
					var findString = 'input:checkbox[value="' + thisLogId + '"]';
					searchCheckbox.filter(findString).parents('tr').html(thisTrData.html());
				});
			}else{
				tableBody.empty();
				for(var i=0; i<objectMapListLength; i+=1){
					tableBody.append($('<tr>/')
							.append(tdStatusConfirmArray[i])
							.append(tdPollingDateArray[i])
							.append(tdStatusArray[i])
							.append(tdFailureArray[i])
							.append(tdDangerArray[i])
							.append(tdWarningArray[i])
							.append(tdNormalArray[i])
							.append(tdSummaryArray[i]));
				}
			}

			tdStatusConfirmArray = null;
			tdPollingDateArray = null;
			tdStatusArray = null;
			tdFailureArray = null;
			tdDangerArray = null;
			tdWarningArray = null;
			tdNormalArray = null;
			tdSummaryArray = null;

			//画面すべてのステータスがログ確認してある場合には、一括確認チェックを付け、
			//そうでない場合には、一括確認チェックを外す
			if($('#instanceStatusLogTable').find('input:checkbox[name="logId"]').filter(':not(:checked)').size() > 0){
				$('#allCheckRequest').attr('checked', false);
			}else{
				$('#allCheckRequest').attr('checked', 'checked');
			}

			//テーブル要素の表示
			$('#instanceStatusLogTable').children('tbody')
										.css('visibility', 'visible')
									.end()
									.trigger('update');
		}finally{
			if($('#instanceStatusLogTable').data('refresh') == true){
				$('#instanceStatusLogTable').tableDataSort();
				$('#instanceStatusLogTable').removeData('refresh');
			}

	        //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//処理はここから
	newStatusLogList.ajaxStatusLogListRequest('default');

	//他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined) window.parent.tabPageClear();

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//テーブル機能の拡張を行う
	$('#instanceStatusLogTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// チェック確認応答
	//-------------------------------------------------------------------------
	function detailsInstance_instanceStatusLogAction_ajaxConfirmStatus(objectMapList) {
		//受信データ設定
		newStatusLogList.ajaxStatusLogListResponse(objectMapList, 'partialUpdate');
		//ページ表示の更新
		newStatusLogList.pageUpdate('partialUpdate');
	}
	//-------------------------------------------------------------------------
	// 全チェック確認応答
	//-------------------------------------------------------------------------
	function detailsInstance_instanceStatusLogAction_ajaxAllConfirmStatus(objectMap) {
		var confirmStatusNum = objectMap;
		//確認したインスタンスがある場合には画面をリフレッシュする
		if(confirmStatusNum > 0){
			windowRefresh();
		}else{
			//処理中画面消去
			$('body').deleteLoadingScreen();
		}
	}
	//-------------------------------------------------------------------------
	// リスト内のチェックボックスクリック処理
	//-------------------------------------------------------------------------
	$('#instanceStatusLogTable').on('click', 'input:checkbox[name=logId]', function(){
		var logIdlist = [$(this).val()];
		newStatusLogList.ajaxConfirmStatusRequest(logIdlist, $(this).attr('checked') == 'checked');
	});
	//-------------------------------------------------------------------------
	// 一括チェッククリック処理
	//-------------------------------------------------------------------------
	$('#instanceStatusLogTable').on('click', '#allCheckRequest', function(){
		//すでに一括チェックマークがついている場合には、クリックしてないことにする
		if($(this).attr('checked') != 'checked'){
			$(this).attr('checked', 'checked');
			return;
		}
		//確認ダイアログを表示する
		if(confirm('表示しているステータスログの一括確認を行います。\nよろしいですか？') == false){
			$(this).attr('checked', false);
			return;
		}

		var checkboxList = $('#instanceStatusLogTable').find('input:checkbox[name=logId]:not(:checked)');
		var checkRequestList = [];

		checkboxList.each(function(){
			checkRequestList.push($(this).val());
		});
		if(checkRequestList.length > 0){
			newStatusLogList.ajaxConfirmStatusRequest(checkRequestList, true);
		}
	});
	//-------------------------------------------------------------------------
	// 絞込みボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		var thisTh = thisDivToolBox.data('targetTh');
		var requestData = {};
		//絞込み処理のため、表示位置をクリアする
		newStatusLogList.logOffset = 0;
		if(thisTh.find('img').hasClass('instanseStateFailure16')){
			requestData = {'filter':'filterFailureCount', 'data':thisDivToolBox};
		}else if(thisTh.find('img').hasClass('instanseStateDanger16')){
			requestData = {'filter':'filterDangerCount', 'data':thisDivToolBox};
		}else if(thisTh.find('img').hasClass('instanseStateWarning16')){
			requestData = {'filter':'filterWarningCount', 'data':thisDivToolBox};
		}else if(thisTh.find('img').hasClass('instanseStateSuccess16')){
			requestData = {'filter':'filterNormalCount', 'data':thisDivToolBox};
		}else{
			requestData = {'filter':thisTh.text(), 'data':thisDivToolBox};
		}
		newStatusLogList.ajaxStatusLogListRequest(requestData);
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 絞込み解除ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterCancelButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		//絞込み処理のため、表示位置をクリアする
		newStatusLogList.logOffset = 0;
		newStatusLogList.ajaxStatusLogListRequest('default');
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 過去時間表示か未来時間表示をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#instanceStatusLogTable').on('click', '#iconGoPastPage,#iconGoFuturePage', function(){
		var maxRow = parseInt(newStatusLogList.maxRow);
		if($(this).attr('id') == 'iconGoPastPage'){
			newStatusLogList.logOffset+=maxRow;
		}else{
			if(newStatusLogList.logOffset >= maxRow){
				newStatusLogList.logOffset-=maxRow;
			}
		}
		//リクエストパラメータの編集
		var requestParams = newStatusLogList.requestParams;
		//表示ページを移動する
		requestParams['offset'] = newStatusLogList.logOffset;

		//データを要求する
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceStatusLogAction_ajaxStatusLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceStatusLogAction', 'action' : 'ajaxStatusLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsInstance_instanceStatusLogAction_ajaxStatusLogList, 'json');
		return false;
	});
	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#instanceStatusLogTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		//テーブル機能の拡張を行う
		if(thisTh.is('.allConfirmData') == true){
			option = {'allConfirmed': true};
		}
		$('#instanceStatusLogTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#instanceStatusLogTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#instanceStatusLogTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#instanceStatusLogTable').removeData('sortData');//ソート順も解除する
		});
		//---------------------------------------------------------------------
		// 一括確認
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.allConfirmed', function(){
			$(this).closest('div.divToolBox').remove();
			//確認ダイアログを表示する
			if(confirm('対象インスタンスの過去を含む全てのステータスログの一括確認を行います。\nよろしいですか？') == false){
				return;
			}
			var checkboxList = $('#instanceStatusLogTable').find('input:checkbox[name=logId]:not(:checked)');
			if(checkboxList.length > 0){
				newStatusLogList.ajaxAllConfirmStatusRequest(newStatusLogList.instanceId);
			}
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	newStatusLogList.intervalTimerId = setInterval(autoRefreshTimer, 1000);
});

//=============================================================================
// 子要素の取得応答
//=============================================================================
function detailsInstance_instanceStatusLogAction_ajaxStatusLogList(objectMapList) {
	//受信データ設定
	newStatusLogList.ajaxStatusLogListResponse(objectMapList);
	//ページ表示の更新
	newStatusLogList.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//インスタンスステータスログのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#instanceStatusLogTable').data('refresh', true);
	//インスタンスステータスログ情報取得要求
	newStatusLogList.ajaxStatusLogListRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#instanceStatusLogTable').data('refresh') == true){
		$('#instanceStatusLogTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(newStatusLogList.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#instanceStatusLogTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#instanceStatusLogTable').data('refresh') == true){
		$('#instanceStatusLogTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
