/**
 * jquery.caretpos.js 0.1 - jQuery Plugin
 * http://d.hatena.ne.jp/tubureteru/
 * Copyright (c) 2011 tubureteru
 * Licensed under the MIT license
 */
(function($) {
  var caretPos = function(pos) {
    var item = this.get(0);

    if (pos == null) {
      return get(item);
    }

    if (pos == "first") pos = 0;
    if (pos == "last") pos = this.val().length;
    set(item, pos);
    return this;
  };

  var get = function(item) {
    var CaretPos = 0;
    if (document.selection) { // IE
      item.focus ();
      var Sel = document.selection.createRange();
      Sel.moveStart ("character", -item.value.length);
      CaretPos = Sel.text.length;
    } else if (item.selectionStart || item.selectionStart == "0") { // Firefox, Chrome
      CaretPos = item.selectionStart;
    }
    return (CaretPos);
  };

  var set = function(item, pos) {
    if (item.setSelectionRange) {  // Firefox, Chrome
      item.focus();
      item.setSelectionRange(pos, pos);
    } else if (item.createTextRange) { // IE
      var range = item.createTextRange();
      range.collapse(true);
      range.moveEnd("character", pos);
      range.moveStart("character", pos);
      range.select();
    }
  };

  $.fn.extend({caretPos: caretPos});

})(jQuery);
