//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	//クラス定義
	var licenseCheck = function(){
		//受信データ保存
		this.objectMapList = [];

		//メソッド
		//サマリーの取得要求
		this.ajaxLicenseCheckRequest = function(){
			//パラメータ
			//Loadingタイマー開始
			$('body').viewLoadingScreen();
			var ajaxParam = {'onFailure' : onAjaxFailure};
			Kumu.Ajax.executeTeedaAjax(licenseCheck_licenseCheckViewerAction_ajaxLicenseCheck, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		};
		//子要素の取得応答
		this.ajaxLicenseCheckResponse = function(objectMapList){
			try{
				if(objectMapList.length<=0) throw 'noItem';

				delete this.objectMapList;
				this.objectMapList = [];
				for (i in objectMapList) {
					this.objectMapList[i] = objectMapList[i];
				}
			}catch(e){
				if(e == 'noItem'){
					delete this.objectMapList;
					this.objectMapList = [];
				}
			}
		};
		//ページ表示の更新処理
		this.pageUpdate = function(){
			try{
				var tableBody = $('#licenseCheckViewerTable').children('tbody');

				//受信データがない場合には中身をクリアする
				if(this.objectMapList.length<=0){
					tableBody.empty();
					return;
				}

				//グループ名
				var tdGroupNameArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('licenseCheckGroupStyle');
					var p = $('<p>').attr('title', thisObjectMap['groupPath']).append(thisObjectMap['groupPath']);
					td.append(p);
					td.data('groupId', thisObjectMap['groupId']);
					tdGroupNameArray.push(td);
				}

				//表示名
				var tdDisplayNameArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('licenseCheckNameStyle');
					var p = $('<p>').attr('title', thisObjectMap['displayName']).append(thisObjectMap['displayName']);
					td.append(p);
					td.data('instanceId', thisObjectMap['instanceId']);
					tdDisplayNameArray.push(td);
				}

				//ライセンスキー
				var tdLicenseKeyArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('licenseCheckLicenseKeyStyle');
					var p = $('<p>');
					var string = (thisObjectMap['licenseKey']!=undefined) ? thisObjectMap['licenseKey'] : '';
					p.attr('title', string).append(string);
					td.append(p);
					tdLicenseKeyArray.push(td);
				}

				//ライセンスキー詳細
				var tdLicenseKeyDetailArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('licenseCheckDetailStyle');
					var p = $('<p>');
					var string = (thisObjectMap['licenseDetails']!=undefined) ? thisObjectMap['licenseDetails'] : '';
					p.attr('title', string).append(string);
					td.append(p);
					tdLicenseKeyDetailArray.push(td);
				}

				//データを合成
				//tbody
				var tableBodyObj = tableBody.clone(true);
				tableBodyObj.empty();
				for(i in this.objectMapList){
					var tr = $('<tr>');
					tr.append(tdGroupNameArray[i]).append(tdDisplayNameArray[i]).append(tdLicenseKeyArray[i]).append(tdLicenseKeyDetailArray[i]);
					tableBodyObj.append(tr);
				}
				tableBody.replaceWith(tableBodyObj);

				//テーブル要素の表示
				$('#licenseCheckViewerTable').children('tbody')
													.css('visibility', 'visible')
												.end()
												.trigger('update');
				//iPad用の処理
				//テーブルの幅を揃える
				if(navigator.userAgent.search(/iPad/) != -1){
					$('#licenseCheckViewerTable').find('tbody').width($('#licenseCheckViewerTable').find('thead').width());
				}
			}finally{
				var divToolBox = $('#licenseCheckViewerTable').data('divToolBox');
				if( divToolBox != undefined ){
					if(divToolBox.find('input[name="filterDuplication"]').is(':checked')){
						duplicateLicenseShow(divToolBox);
					}else{
						$('#licenseCheckViewerTable').tableDataFilter(divToolBox, true);
					}
				}
				if($('#licenseCheckViewerTable').data('refresh') == true){
					$('#licenseCheckViewerTable').tableDataSort();
				}
	            //Loading終了
			    $('body').deleteLoadingScreen();
			}
		};
		//テーブル機能の拡張を行う
		$('#licenseCheckViewerTable').fixedHeaderTable();
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	//このオブジェクト変数だけは、グローバルスコープ
	objLicenseCheckViewer = new licenseCheck();
	//ログ情報取得要求
	objLicenseCheckViewer.ajaxLicenseCheckRequest();

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//=========================================================================
	// グループ名クリックしたときの処理
	//=========================================================================
	$('#licenseCheckViewerTable').on('click', 'td.licenseCheckGroupStyle', function(event){
		if($(event.target).is('p') == true){
			//表示中のタイアログを閉じる
			window.parent.$('#indicatorDialog').dialog('close');
			//ページ遷移
			$('#mainDetails', top.document).attr('src', 'detailsGroup/detailsGroup.html?groupId=' + $(this).data('groupId'));
		}
	});

	//=========================================================================
	// 表示名クリックしたときの処理
	//=========================================================================
	$('#licenseCheckViewerTable').on('click', 'td.licenseCheckNameStyle', function(event){
		if($(event.target).is('p') == true){
			//表示中のタイアログを閉じる
			window.parent.$('#indicatorDialog').dialog('close');
			//ページ遷移
			$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + $(this).data('instanceId'));
		}
	});

	//コールバックメソッドの設定
	//=========================================================================
	// ログ情報取得応答処理
	//=========================================================================
	function licenseCheck_licenseCheckViewerAction_ajaxLicenseCheck(objectMapList) {
		//受信データ設定
		objLicenseCheckViewer.ajaxLicenseCheckResponse(objectMapList);
		//ページ表示の更新
		objLicenseCheckViewer.pageUpdate();
	}

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#licenseCheckViewerTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#licenseCheckViewerTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#licenseCheckViewerTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#licenseCheckViewerTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//表示を絞込み前の状態に戻す
			$('#licenseCheckViewerTable').tableDataFilter($(this).parents('div.divToolBox'), false);
			var thisDivToolBox = $(this).parents('div.divToolBox');
			if(thisDivToolBox.find('input[name="filterDuplication"]').is(':checked')){
				duplicateLicenseShow(thisDivToolBox);
				//絞り込みのためのツールボックス情報と、クリック位置を保存する
				var clickIndex = $(this).parents('div.divToolBox').data('clickIndex');
				$('#licenseCheckViewerTable').data('divToolBox', $(this).parents('div.divToolBox').clone(true).data('clickIndex', clickIndex));
			}else{
				$('#licenseCheckViewerTable').tableDataFilter($(this).parents('div.divToolBox'), true);
				//絞り込みのためのツールボックス情報と、クリック位置を保存する
				var clickIndex = $(this).parents('div.divToolBox').data('clickIndex');
				$('#licenseCheckViewerTable').data('divToolBox', $(this).parents('div.divToolBox').clone(true).data('clickIndex', clickIndex));
			}
			$('#licenseCheckViewerTable').removeData('divToolBox');
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#licenseCheckViewerTable').removeData('divToolBox');
			$('#licenseCheckViewerTable').removeData('sortData');//ソート順も解除する
			$(this).parents('div.divToolBox').remove();
			//初期表示に戻すため、サーバーにデータを再要求する
			objLicenseCheckViewer.ajaxLicenseCheckRequest();
		});
	});
	//=============================================================================
	// 重複ライセンス表示処理
	//=============================================================================
	function duplicateLicenseShow(divToolBox){
		if(divToolBox.find('input[name="filterDuplication"]').is(':checked')){
			var licenseKeyList = $('#licenseCheckViewerTable').children('tbody').find('td.licenseCheckLicenseKeyStyle').clone().get();
			var licenseKeyListTextArray = [];
			var duplicateLicenseArray = [];
			var targetTdWidthArray = [];
			var widthSetTr = undefined;
			var tableSizeSetFlg = false;

			for(i in licenseKeyList){
				licenseKeyListTextArray.push(licenseKeyList[i].innerText);
			}

			//ライセンスキー情報の配列から重複しているものを探し、重複用の領域に入れる
			while(licenseKeyListTextArray.length > 0){
				var searchData = licenseKeyListTextArray.shift();
				for(i in licenseKeyListTextArray){
					if(searchData == licenseKeyListTextArray[i]){
						var noneFlg = true;
						for(j in duplicateLicenseArray){
							if(searchData == duplicateLicenseArray[j]){
								noneFlg = false;
								break;
							}
						}
						if(noneFlg == true){
							duplicateLicenseArray.push(searchData);
						}
					}
				}

			}
			//-----------------------------------------------------------------
			// 重複しているデータのみを表示する
			//-----------------------------------------------------------------
			//表示したままにしておくデータをマーキングする
			var trDataList = $('#licenseCheckViewerTable').children('tbody').children('tr');
			for(i in duplicateLicenseArray){
				var visibleMarkingData = duplicateLicenseArray[i];
				trDataList.each(function(){
					var thisTr = $(this);
					if(visibleMarkingData == thisTr.children('td.licenseCheckLicenseKeyStyle').text()){
						thisTr.data('visible', true);
					}
				});
			}

			//---------------------------------------------------------------------
			// テーブル幅を取得する
			//---------------------------------------------------------------------
			$('#licenseCheckViewerTable').find('tr:first').children().each(function(i){
				targetTdWidthArray[i] = $(this).width();
			});

			//マーキングされていないデータを非表示する
			trDataList.each(function(){
				var thisTr = $(this);
				if(thisTr.data('visible') != true){
					thisTr.css('display', 'none');
				}else{
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
				}
			});
			if(widthSetTr != undefined){
				//テーブルサイズを設定する
				widthSetTr.children().each(function(i){
					$(this).width(targetTdWidthArray[i]);
				});
			}
		}
	}
});
