//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	if (window != top) {
		// フレーム内表示だった場合に、トップウィンドウ表示に切り替える
		if($('#outlineMessageText').text() == ''){
			top.location.href = window.location.href;
		}else{
			top.location.href = window.location.href + '&outlineMessageText=' + encodeURI($('#outlineMessageText').text());
		}
	}

	//メンテナンスモードの値をクリアする
	$.jStorage.set('maintenanceMode', '');

	//=========================================================================
	// クライアントユーザー固有データ取得処理
	//=========================================================================
	//-------------------------------------------------------------------------
	// ログイン情報の読み出し
	//-------------------------------------------------------------------------
	var loginData = $.jStorage.get('loginData', 'none');
	if( loginData != 'none' ){
		//入力フォームに情報を入れる
		var userName = unescape(base64decode(loginData['loginName']));
		var userPassword = unescape(base64decode(loginData['loginPassword']));
		$('#loginName').val(userName);
		$('#loginPassword').val(userPassword);
		$('#setCookie').attr('checked', 'checked');
	}

	//---------------------------------------------------------------------
	// RSS設定の読み出し
	//---------------------------------------------------------------------
	var rssVisible = $.jStorage.get('rssVisible', false);
	var rssURL = $.jStorage.get('rssURL', 'http://www.say-tech.co.jp/rss.xml');
	var rssSupport = getRSSSupport();
	//-------------------------------------------------------------------------
	// RSSの取得
	//-------------------------------------------------------------------------
	if(rssVisible == true){
		if(rssSupport == true){
			rssGet(rssURL, 10);
		}else{
			//RSS情報表示設定をクリアする
			$.jStorage.deleteKey('rssURL');
			$.jStorage.deleteKey('rssVisible');
			alert('ActiveXの実行が許可されていないため、RSS取得が行えませんでした。\nActiveXの実行を許可する設定にしてください');
		}
	}
	//-------------------------------------------------------------------------
	// RSSのチェックマークを付ける
	//-------------------------------------------------------------------------
	if(rssVisible == true){
		if(rssSupport == true){
			$('#setRSSVisible').attr('checked', 'checked');
		}else{
			$('#setRSSVisible').attr('checked', false);
		}
	}

	//=========================================================================
	// RSSが使えるか否かを返す関数
	//=========================================================================
	function getRSSSupport(){
		var retBoolean = true;
		var browser = navigator.appName;
		var xml;
		try{
			if (browser == 'Microsoft Internet Explorer') {
				xml = new ActiveXObject('Microsoft.XMLDOM');
			}else{
				xml = new DOMParser();
			}
			if(xml == undefined){
				retBoolean = false;
			}
		}catch(e){
			retBoolean = false;
		}
		return retBoolean;
	}

	//=========================================================================
	// RSSフィード取得処理
	//=========================================================================
	function rssGet(localRssURL, localLimit){
		$('#rssMessageArea').rssfeed(localRssURL, {
			limit: 100,
			header: false,
			content: false,
			errormsg: 'RSSの取得に失敗しました。設定等をご確認ください',
			linktarget: '_blank',
			ssl: true
		}, function(){
			//取得したRSSフィードの表示順を日付、タイトルの順に設定する
			var feedList = $('#rssMessageArea').find('li');
			var feedListAfter = [];
			var i=0;
			feedList.sort(function(left, right){
				var leftTimeText = $(left).find('div').text();
				var rightTimeText = $(right).find('div').text();
				var leftTime = (new Date(leftTimeText)).getTime();
				var rightTime = (new Date(rightTimeText)).getTime();
				return rightTime - leftTime;
			});
			feedList.each(function(){
				var thisList = $(this);
				thisList.prepend(thisList.children('div'));
			});
			for(i=0; i< localLimit; i+=1){
				feedListAfter.push(feedList[i]);
			}
			$('#rssMessageArea').find('ul').empty().append(feedListAfter);
			$('#rssMessageArea').css('display', 'table-cell');
		}
		);
	}

	//=========================================================================
	// 「ログイン」ボタンを押した時の処理
	//=========================================================================
	$('#doLoginSubmit').on('click', function(){
		if( $('#setCookie').is(':checked') == true){
			//ログイン情報をストレージに保存する
			var loginName = base64encode(escape($('#loginName').val()));
			var loginPW = base64encode(escape($('#loginPassword').val()));
			$.jStorage.set('loginData', {'loginName': loginName, 'loginPassword': loginPW});
		}else{
			//ログイン情報をクリアする
			$.jStorage.deleteKey('loginData');
		}
	});

	//=========================================================================
	// 「セイ・テクノロジーズからの情報を表示する」チェックをつけた時の処理
	//=========================================================================
	$('#setRSSVisible').on('click', function(){
		var callBackFunction = function(result){
			var retRssURL = result;
			if(retRssURL == ''){
				$('#setRSSVisible').attr('checked', false);
				return true;
			}
			//RSS情報をストレージに保存する
			$.jStorage.set('rssURL', retRssURL);
			$.jStorage.set('rssVisible', true);
			rssGet(retRssURL, 10);
			return true;
		};
		//-------------------------------------------------------------------------
		// RSS情報の読み出し
		//-------------------------------------------------------------------------
		var rssURL = $.jStorage.get('rssURL', 'http://www.say-tech.co.jp/rss.xml');
		if( $('#setRSSVisible').is(':checked') == true){
			var rssSupport = getRSSSupport();
			if(rssSupport == false){
				alert('ActiveXの実行が許可されていないため、RSS取得が行えませんでした。\nActiveXの実行を許可する設定にしてください');
				$.jStorage.deleteKey('rssURL');
				$.jStorage.deleteKey('rssVisible');
				$('#setRSSVisible').attr('checked', false);
				return;
			}
			//確認ダイアログを表示する
			showInputDialog('RSS情報のURLを入力', '入力されたURLのRSSを取得いたします(デフォルトはセイ・テクノロジーズのRSS)', rssURL, callBackFunction);
		}else{
			//RSS情報表示設定をクリアする
			$.jStorage.deleteKey('rssURL');
			$.jStorage.deleteKey('rssVisible');
			$('#rssMessageArea').empty();
			$('#rssMessageArea').css('display', 'none');
		}
	});

	//エラー画面の表示切替
	var stringOutlineMessage = $.trim($('#outlineMessageText').text());
	$('#allMessages').children('li').each(function(){
		if($.trim($(this).text()) != stringOutlineMessage){
			//エラー文字列の結合
			$('#allMessages').append('<li>' + stringOutlineMessage + '</li>');
		}
	});
	if($('#allMessages').children('li').length > 0){
		$('#systemMessage').show();
	}else{
		//自動ログアウトを行なっていた場合には、自動ログアウトのメッセージを表示する
		if($.jStorage.get('autoLogoutMessageFlag', false) == true){
			//自動ログアウトしましたは黒色文字
			$.jStorage.set('autoLogoutMessageFlag', false);
			$('#systemMessage').text('自動ログアウトしました。');
			$('#systemMessage').css('color', '#000000');
			$('#systemMessage').show();
		}else{
			if(stringOutlineMessage != ""){
				//エラー文字列の結合
				$('#systemMessage').append('<ul id="allMessages"> <li>' + stringOutlineMessage + '</li></ul>');
				$('#systemMessage').show();
			}else{
				$('#systemMessage').hide();
			}
		}
	}

	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//iPadは、回転イベント時にはリロードをする
		$(window).bind("orientationchange",function(){
			$('body').hide();
			location.reload();
		});
	}
});
