//*****************************************************************************
// Copyright (C) 2016 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	// グループ名のオートコンプリート候補取得
	var ajaxParam = {};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(action_actionEditAction_ajaxGroupAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	// メールサーバー オートコンプリート
	var ajaxParam = {};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(action_actionEditAction_ajaxMailSettingAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	// メール接続の保護変更
	$('#smtpCryptType').change(function () {
		if ($(this).val() == 'NONE') {
			if( $('#smtpPort').val() == '' | $('#smtpPort').val() == '465' | $('#smtpPort').val() == '587'){
				$('#smtpPort').val('25');
			}
		} else if ($(this).val() == 'SSL_TLS') {
			if( $('#smtpPort').val() == '25' | $('#smtpPort').val() == '587'){
				$('#smtpPort').val('465');
			}
		} else if ($(this).val() == 'STARTTLS') {
			if( $('#smtpPort').val() == '25' | $('#smtpPort').val() == '465'){
				$('#smtpPort').val('587');
			}
		}
	});

	//メール接続ポート番号の初期値設定
	$('#smtpCryptType').change();

	// メール認証変更
	$('#mailAuthenticationType').change(function () {
		if ($('#actionType').val() == 'MAIL') {
			if ($(this).val() == 'NONE') {
				// 認証なし
				$('.mailSmtpAuthentication').hide();
			} else {
				// SMTP AUTH PLAIN
				$('.mailSmtpAuthentication').show();
			}
		}else{
			//メールアクションでない場合には、メール認証の表示はしない
			$('.mailSmtpAuthentication').hide();
		}
	});
	$('#mailAuthenticationType').change();

	// リセットボタンを押した時の動作
	$('div.dialogButtons input[type=reset]').on('click', function(){
		$('#actionEditForm').get(0).reset();
		// 表示非表示切り替え
		showOrHideSwitch();
		$('#smtpCryptType').change();
		$('#mailAuthenticationType').change();
		return false;
	});

	//=========================================================================
	// 予約済み変数関連の処理
	//=========================================================================
	var caret_pos;	//カーソル位置のグローバル変数

	//-------------------------------------------------------------------------
	// カーソル位置へのテキストの挿入関数
	//-------------------------------------------------------------------------
	function insertTextAtPosision(obj, pos, txt) {
	    obj.focus();
	    if (jQuery.browser.msie) {
	        pos.text = txt;
	        pos.select();
	    } else {
	        var s = obj.value;
	        var np = pos + txt.length;
	        obj.value = s.substr(0, pos) + txt + s.substr(pos);
	        obj.setSelectionRange(np, np);
	    }
	}
	//-------------------------------------------------------------------------
	// カーソル位置取得関数
	//-------------------------------------------------------------------------
	function getCaretPosition(obj) {
	    obj.focus();
	    var pos;
	    if (jQuery.browser.msie) {
	        pos = document.selection.createRange();
	    } else {
	        pos = obj.selectionStart;
	    }
	    return pos;
	}

	//-------------------------------------------------------------------------
	// iPad用の注意喚起文表示関数
	//-------------------------------------------------------------------------
	function iPadCautionDisplay(){
		var labelString = '<span class="actionWorkingFolderLabel">iPadのパス区切り文字は[\\(半角)]を指定してください</span>';
		$('#actionWorkingFolderLabel').html($('#actionWorkingFolderLabel').text() + '<BR/>' + labelString);
	};
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		iPadCautionDisplay();
	}



	//オートコンプリートの表示が横にずれる問題の対策
	//<body>の幅をそのwindowの幅に設定する
	$('body').width($(window).width());
});

//Ajaxコールバック関数
function action_actionEditAction_ajaxGroupAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#groupPath').autocomplete({
			source : autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}
function action_actionEditAction_ajaxMailSettingAutoCompleteCandidate(objectMapList) {
	var itemList = new Array();
	for (i in objectMapList) {
		var objectMap = objectMapList[i];
		// リストに追加済みなら何も行わない
		var find = false;
		for (j in itemList) {
			if (itemList[j]['label'] == objectMap['smtpServer'] + ':' + objectMap['smtpPort']) {
				find = true;
				break;
			}
		}
		if (find) {
			continue;
		}

		var map = new Array();
		map['label'] = objectMap['smtpServer'] + ':' + objectMap['smtpPort'];
		map['value'] = objectMap['smtpServer'];
		itemList.push(map);
	}

	$('#smtpServer').autocomplete({
		source : itemList,
		select : function(event, ui) {
			for (i in objectMapList) {
				var objectMap = objectMapList[i];
				if (ui['item']['label'] == objectMap['smtpServer'] + ':' + objectMap['smtpPort']) {
					$('#smtpPort').val(objectMap['smtpPort']);
					$('#smtpCryptType').val(objectMap['smtpCryptType']);
					$('#mailAuthenticationType').val(objectMap['mailAuthenticationType']);
					$('#mailUserId').val(objectMap['mailUserId']);
					$('#mailPassword').val(objectMap['mailPassword']);
					$('#mailAuthenticationType').change();
					$('#sourceMailAddress').val(objectMap['sourceMailAddress']);
				}
			}
		},
		delay : 50,
		minLength : 0
	});

	$('#doConfirm,#jumpActionList').on('click', function(){

		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
}


