//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	//Loadingタイマー開始
	$('body').viewLoadingScreen();
	//サーバーへのサマリー情報の取得要求
	var ajaxParam = {'AjaxParam0' : 1};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(summary_summaryAction_ajaxSummaryStatus, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
});

//=============================================================================
// サーバーからのサマリー情報の取得応答
//=============================================================================
function summary_summaryAction_ajaxSummaryStatus(objectMap) {

	var toolTipTable = {
			'disconnectComputer': 'コンピューター接続エラー',
			'disconnectHelper': 'ヘルパーサービス接続エラー',
			'disconnectAgent': '監視サービス停止中',
			'failure': '失敗',
			'danger':'危険',
			'warning':'注意',
			'normal':'正常',
			'noStatus':''};
	var iconImgSrcTable = {
			'confirmed': '../../images/confirm128.png',
			'invisible': '../../images/invisible128.png'
	};

    //Loading終了
    $('body').deleteLoadingScreen();

	//アイコンを変更
	$('#summaryIcon').each(function() {
		$(this).removeClass('instanseStateDisconnectComputer128 instanseStateDisconnectHelper128 instanseStateDisconnectAgent128 instanseStateFailure128 instanseStateDanger128 instanseStateWarning128 instanseStateNormal128');
		var className = '';
		var tooltipText = '';

		if (objectMap['disconnectComputer'] == 'true') {
			className = 'instanseStateDisconnectComputer128';
			tooltipText = toolTipTable['disconnectComputer'];
		} else if (objectMap['disconnectHelper'] == 'true') {
			className = 'instanseStateDisconnectHelper128';
			tooltipText = toolTipTable['disconnectHelper'];
		} else if (objectMap['disconnectAgent'] == 'true') {
			className = 'instanseStateDisconnectAgent128';
			tooltipText = toolTipTable['disconnectAgent'];
		} else if (objectMap['failure'] > 0) {
			className = 'instanseStateFailure128';
			tooltipText = toolTipTable['failure'];
		} else if (objectMap['danger'] > 0) {
			className = 'instanseStateDanger128';
			tooltipText = toolTipTable['danger'];
		} else if (objectMap['warning'] > 0) {
			className = 'instanseStateWarning128';
			tooltipText = toolTipTable['warning'];
		} else if (objectMap['normal'] > 0) {
			className = 'instanseStateSuccess128';
			tooltipText = toolTipTable['normal'];
		}

		$('img' ,this).remove();
		//ステータス確認済みのチェックを表示する
		if(('statusConfirmed' in objectMap) && (objectMap['statusConfirmed'] == 'true')){
			//表示を追加
			$(this).append('<img src="'+iconImgSrcTable['confirmed'] + '" class="' + className + '" title="' + tooltipText + '" alt="" />');
		}else{
			//表示を消す
			$(this).append('<img src="'+iconImgSrcTable['invisible'] + '" class="' + className + '" title="' + tooltipText + '" alt="" />');
		}
	});
}

//=============================================================================
// サマリービューのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	//Loadingタイマー開始
	$('body').viewLoadingScreen();

	var ajaxParam = {'AjaxParam0' : 1};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(summary_summaryAction_ajaxSummaryStatus, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
}

