
from pydantic import Field, constr

from app.entity import CommonModel

class SendMailActionData(CommonModel):
    to: constr(strip_whitespace=True, min_length=1)
    subject: constr(strip_whitespace=True, min_length=1)
    body: constr(strip_whitespace=True, min_length=1)

class WebhookActionData(CommonModel):
    url: constr(strip_whitespace=True, min_length=8)   # http://a
    method: constr(strip_whitespace=True, min_length=3)
    header:str = Field(description="リクエストヘッダー")
    body: str = Field("", description="送信内容")

class CommandActionData(CommonModel):
    command: constr(strip_whitespace=True, min_length=1)
    options: str = Field("", description="コマンドライン引数")
    work_dir: str = Field("", description="実行ディレクトリ")
    multi: bool = Field(False, description="多重起動許可")
