
from typing import Optional
from datetime import datetime

from pydantic import constr, Field

from app import datetime_now_aware, SYSTEM_USER_ID
from app.entity import CommonModel

class Configure(CommonModel):
    """サーバー設定
    """
    ckey:constr(max_length=64)
    cval:Optional[str] = Field(None, description="設定値")

    update_by:str = Field(SYSTEM_USER_ID, description="更新者ID")
    update_at: datetime = Field(description="更新日時", default_factory=lambda: datetime_now_aware(),)
