
from typing import Any

from pydantic import Field, constr, conint

from app.enum import ResponseDataType
from app.entity import CommonModel

class SysErrorResponse(CommonModel):
    """UI 返却用データクラス

    UI にデータを返却するためのクラス
    
    """
    message_type:constr(strip_whitespace=True,min_length=1)
    message:constr(strip_whitespace=True, min_length=1)
    detail_type:conint(ge=min(list(map(int, ResponseDataType))), le=max(list(map(int, ResponseDataType))))
    detail:Any = Field(..., description="返却データ")
