
from sqlalchemy import Column, DateTime, Index, BigInteger, Integer, Identity, String

from app.models import Base

class MailFlow(Base):
    """メール流量
    """
    __tablename__ = "mail_flow"

    flow_id = Column(
        BigInteger().with_variant(Integer, "sqlite"), 
        Identity(start=1, cycle=False),
        nullable=False, 
        primary_key=True, 
        autoincrement="auto")
    filter_id = Column(BigInteger, nullable=False, default=0)
    mail_name = Column(String(256), nullable=False)
    update_at = Column(DateTime(timezone=True), nullable=False)

    # 末尾の ,) がミソ
    __table_args__ = (Index("idx_flow_1",  "filter_id", "update_at", unique=False),)
