
from sqlalchemy import Enum, event
from sqlalchemy import Column, String, Boolean

from app.enum import RoleType
from app.models import Base, UpdatesMixin, modified_at_hook

class Users(Base, UpdatesMixin):
    """ユーザー
    """
    __tablename__ = "users"

    user_id = Column(String(32), primary_key=True)
    user_name = Column(String(64), nullable=False)
    enabled = Column(Boolean, nullable=False, default=True)
    secret_key = Column(String(64), nullable=False)
    role = Column(Enum(RoleType), nullable=False, default=RoleType.viewer.name)


    # secret_key は別で更新する
    UPDATE_FIELDS = [
        "user_name",
        "enabled",
        "role",
        "update_by",
    ]

# event
event.listen(Users, "before_insert", modified_at_hook)
event.listen(Users, "before_update", modified_at_hook)
