
import time

class WithRetry(object):
    def __init__(self, r_count:int=0, r_wait:int=0, r_exponent:int=0):
        adjust_zero = lambda x: x if x >= 0 else 0
        self.r_count = adjust_zero(int(r_count))
        self.r_wait  = adjust_zero(int(r_wait))
        self.r_exponent = adjust_zero(int(r_exponent))

    def get_loop_count(self) -> int:
        return 1 + self.r_count

    def retry_wait(self, i) -> int:
        """リトライ待機処理

        リトライ発生時のスリープ処理

        Parameters
        ----------
        i:int
            リトライ回数。1～

        Returns
        -------
        int
            スリープ時間(ミリ秒)
        """
        w_time = 0

        if self.r_wait > 0:
            w_time = self.r_wait
            if self.r_exponent > 0:
                w_time = (i - 1) * self.r_exponent * self.r_wait
            time.sleep(w_time / 1000)

        return w_time