
const hideAlert = function() {
    // エラーメッセージ領域
    $('#alertDlg').hide();
    $('#alertMsg').html("")
}

const showAlert = function(messages) {
    if (messages.length) {
        $('#alertMsg').html(messages.map(msg => msg + '<br>'));
    }
    $('#alertDlg').show();
}

const showErrorEntity = function(ent, messages) {
    ent.addClass("errorItem");
    const typ = toString.call(messages);
    let errMsg = "";
    if (typ.includes("Array")) {
        errMsg = messages.map(msg => '<li>' + msg + '</li>').join("<br>");
    } else {
        errMsg = '<li>' + messages + '</li>';
    }

    balloonMsg = '<div><ul>' + errMsg + '</ul></div>';

    ent.balloon({
        html: true,
        contents: balloonMsg,
    });
}

const hideErrorEntity = function(ent) {
    ent.removeClass('errorItem');
    ent.off();  // balloon off
}

const resetAllErrorEntity = function() {
    $('.errorItem').each(function() {
        hideErrorEntity($(this));
    });
}

const responseToMessage = function(jqXHR) {
    let alt_msg = [];

    if (jqXHR.responseJSON) {
        let obj = jqXHR.responseJSON;
        alt_msg.push(obj.message);
        if (obj.detail_type == 1) {
            alt_msg.push(obj.detail);
        } else if (obj.detail_type == 2) {
            $.each(obj.detail, function(index, elem) {
                alt_msg.push(elem);
            });
        } else if (obj.detail_type == 3) {
            $.each(Object.keys(obj.detail), function(index, key) {
                $.each(obj.detail[key], function(index, val) {
                    alt_msg.push(key + ":" + val);
                });
            });
        }
    } else {
        // HTML
        $('html').html(jqXHR.responseText);
    }

    return alt_msg
}

$('#alertMsgClose').on('click', function () {
    hideAlert();
});
