$(function() {
    $(function() {
        // initialize
        // パスワード変更メニューを利用不可にする
        $("#mnuChangePass").addClass("disabled-link");

        $(document).keydown(function(e){
            if (e.key == "Enter") {
                $("#btnChange").click();
                return false;
            }
            return true;
        });
        $("#txtOldPass").focus();
    });

    $("#btnPrev").on('click', function() {
        history.back();
    });

    $("#btnChange").on('click', function() {
        let o_pass = $("#txtOldPass").val();
        let n_pass = $("#txtNewPass").val();
        let c_pass = $("#txtConPass").val();

        // 初期化
        resetAllErrorEntity();
        hideAlert();

        let validateErrors = 0;
        if (o_pass == "") {
            showErrorEntity($("#txtOldPass"), "現在のパスワードが入力されていません。");
            ++validateErrors;
        }

        if (c_pass == "") {
            showErrorEntity($("#txtConPass"), "確認用パスワードが入力されていません。");
            ++validateErrors;
        }

        if (n_pass == "") {
            showErrorEntity($("#txtNewPass"), "新しいパスワードが入力されていません。");
            ++validateErrors;
        } else if (c_pass != n_pass) {
            showErrorEntity($("#txtConPass"), "新しいパスワードが確認用パスワードと一致しません。");
            ++validateErrors;
        } else if (o_pass == c_pass) {
            showErrorEntity($("#txtNewPass"), "パスワードが変更されていません。");
            ++validateErrors;
        }

        if (validateErrors > 0) {
            return;
        }

        const body_str = JSON.stringify({
            old_pass: o_pass,
            new_pass: n_pass,
            conf_pass: c_pass
        });

        let url = "/change/user/" + $("#uid").val();

        $.ajax(url, {
            method: "PUT",
            data: body_str,
            cache: false,
            dataType: "json",
            jsonp: false,
        }).done(function(data, textStatus, jqXHR) {
            alert("パスワードが変更されました。\nログイン画面に戻ります。");
            window.location.href = '/login';
        }).fail(function(jqXHR, textStatus, errorThrown) {
            const alt_msg = responseToMessage(jqXHR);
            if (alt_msg.length > 0) {
                showAlert(alt_msg);
            }
        });
    });
});
