$(function() {
    $(function() {
        // initialize
    });

    /**
     * フィルターデータ取得
     * 
     * @return {*} フィルターデータ hash
     */
    let getFilterItem = function() {
        const filterId = parseInt($("#fltId").val()) || 0;
        var filterItem = {};

        const showItemErrors = function(ent) {
            if (ent.errors.length > 0) {
                showErrorEntity(ent, ent.errors);
            }
        };

        // 初期化
        resetAllErrorEntity();
        var totalValidError = 0;

        // filter_times
        var filterTimes = [];
        let index = 1;
        $('div[name="timeTermRow"]').each(function() {
            var validateError = 0;

            let eSelDayField = $(this).find('select[name="selDayField"]');
            let eFromTm = $(this).find('input[name="fromTm"]');
            let eToTm = $(this).find('input[name="toTm"]');

            eSelDayField.errors = [];
            eFromTm.errors = [];
            eToTm.errors = [];

            const timeType = parseInt(eSelDayField.val()) || 0;
            const timeFrom = eFromTm.val();
            const timeTo   = eToTm.val();

            if (timeFrom == "") {
                // 時間が双方未入力の場合
                if (timeTo == "") {
                    // 当該行はスキップ
                    return true;
                }
                validateError++;
                eFromTm.errors.push("開始時間が入力されていません。");
            } else if (timeTo == "") {
                validateError++;
                eToTm.errors.push("終了時間が入力されていません。");
            }
            if (timeType == "") {
                validateError++;
                eSelDayField.errors.push("日付パターンが選択されていません。");
            }
            if (timeFrom >= timeTo) {
                validateError++;
                const msg = "開始時間と終了時間が矛盾しています。";

                eFromTm.errors.push(msg);
                eToTm.errors.push(msg);
            }

            if (validateError > 0) {
                totalValidError += validateError;

                showItemErrors(eSelDayField);
                showItemErrors(eFromTm);
                showItemErrors(eToTm);

                return true;    // continue
            }

            // アイテムを追加
            filterTimes.push({
                term_no: index,
                time_type: timeType,
                time_from: timeFrom,
                time_to: timeTo,
            });
            ++index;
        });
        // 仮格納
        filterItem.filter_times = filterTimes;

        // mail_terms
        var mailTerms = [];
        index = 1;
        $('div[name="mailTermRow"]').each(function() {
            var validateError = 0;
            let eSelMlField  = $(this).find('select[name="selMlField"]');
            let eTermMlValue = $(this).find('input[name="termMlValue"]');
            let eSelMlTerm   = $(this).find('select[name="selMlTerm"]');

            const fieldType = parseInt(eSelMlField.val()) || 0;
            const keyWords  = eTermMlValue.val();
            const termType  = parseInt(eSelMlTerm.val()) || 0;

            eSelMlField.errors = [];
            eTermMlValue.errors = [];
            eSelMlTerm.errors = [];
            
            if (keyWords == "") {
                validateError++;
                eTermMlValue.errors.push("条件キーワードが入力されていません。");
            }
            if (fieldType == "") {
                validateError++;
                eSelMlField.errors.push("条件確認箇所が選択されていません。");
            }
            if (termType == "") {
                validateError++;
                eSelMlTerm.errors("メールフィルター条件式が選択されていません。");
            }

            if (validateError > 0) {
                totalValidError += validateError;

                showItemErrors(eSelMlField);
                showItemErrors(eTermMlValue);
                showItemErrors(eSelMlTerm);

                return true;    // continue
            }

            // アイテムを追加
            mailTerms.push({
                term_no: index,
                field_type: fieldType,
                keywords: keyWords,
                term_type: termType,
            });
            ++index;
        });
        // 仮格納
        filterItem.mail_terms = mailTerms;

        // log_filters
        var logFilters = [];
        index = 1;
        $('div[name="logTermRow"]').each(function() {
            var validateError = 0;
            let eTermKwValue = $(this).find('input[name="termKwValue"]');
            let eSelKwTerm   = $(this).find('select[name="selKwTerm"]');

            const keyWords = eTermKwValue.val();
            const termType  =parseInt(eSelKwTerm.val()) || 0;

            eTermKwValue.errors = [];
            eSelKwTerm.errors = [];

            if (keyWords == "") {
                validateError++;
                showErrorEntity(eTermKwValue, "条件キーワードが入力されていません。");
            }
            if (termType == "") {
                validateError++;
                showErrorEntity(eSelKwTerm, "ログメッセージ条件式が選択されていません。");
            }

            if (validateError > 0) {
                totalValidError += validateError;

                showItemErrors(eTermKwValue);
                showItemErrors(eSelKwTerm);

                return true;    // continue
            }

            logFilters.push({
                term_no: index,
                keywords: keyWords,
                term_type: termType,
            });
            ++index;
        });
        // 仮格納
        filterItem.log_filters = logFilters;

        // filter_actions
        var filterActions = [];
        const actFields = ["#chkResMailUse", "#chkResWebhookUse", "#chkResCmdUse"];
        $.each(actFields, function(idx, ctrlId) {
            if ($(ctrlId).prop("checked")) {
                actData = {};
                actType = parseInt($(ctrlId).val()) || 0;
                if (actType == 1) {
                    actData.to = $("#txtMail").val();
                    if (actData.to == "") {
                        showErrorEntity($("#txtMail"), "宛先が入力されていません。");
                        ++totalValidError;
                    }
                    actData.subject = $("#txtSubject").val();
                    if (actData.subject == "") {
                        showErrorEntity($("#txtSubject"), "表題が入力されていません。");
                        ++totalValidError;
                    }
                    actData.body = $("#txtBody").val();
                    if (actData.body == "") {
                        showErrorEntity($("#txtBody"), "本文が入力されていません。");
                        ++totalValidError;
                    }
                } else if (actType == 2) {
                    actData.url = $("#txtUrl").val();
                    if (actData.url == "") {
                        showErrorEntity($("#txtUrl"), "URL が入力されていません。");
                        ++totalValidError;
                    }
                    actData.method = $("#selMethod").val();
                    if (actData.method == "") {
                        showErrorEntity($("#selMethod"), "HTTP メソッドが選択されていません。");
                        ++totalValidError;
                    }
                    actData.header = $('#txtHead').val();
                    actData.body = $("#txtJson").val();
                } else if (actType == 3) {
                    actData.command = $("#txtCmd").val();
                    if  (actData.command == "") {
                        showErrorEntity($("#txtCmd"), "コマンドが入力されていません。");
                        ++totalValidError;
                    }
                    actData.options = $("#txtArgs").val();
                    actData.work_dir = $("#txtDirectory").val();
                    actData.multi = $("#chkMultiple").prop("checked");
                } else {
                    return true;
                }

                filterActions.push({
                    act_type: actType,
                    act_data: encodeURI(JSON.stringify(actData)),
                });
            }
        });
        filterItem.filter_actions = filterActions;

        // filter main
        if (filterId > 0) {
            filterItem.filter_id  = filterId;
        }
        filterItem.filter_name    = $("#txtName").val();
        filterItem.priority       = parseInt($("#txtWgt").val()) || 0;
        filterItem.enabled        = $("#chkEnabled").prop("checked");
        filterItem.mail_term_join = parseInt($('input[name="rdoMailConj"]:checked').val()) || 0;
        filterItem.enable_flow    = $("#chkEnableFlow").prop("checked");
        filterItem.flow_interval  = filterItem.enable_flow ? parseInt($("#txtCheckMinute").val()) || 0 : null;
        filterItem.flow_count     = filterItem.enable_flow ? parseInt($("#txtMailCount").val())   || 0 : null;
        filterItem.flow_term      = filterItem.enable_flow ? parseInt($("#selFlTerm").val())      || 0 : null;
        filterItem.log_term_join  = parseInt($('input[name="rdoEvtConj"]:checked').val()) || 0;
        filterItem.send_empty_log = $("#chkEmptyEvt").prop("checked");
        if (filterItem.filter_name == "") {
            ++totalValidError;
            showErrorEntity($("#txtName"), "フィルター名が入力されていません。");
        }
        if (filterItem.priority == "") {
            ++totalValidError;
            showErrorEntity($("#txtWgt"), "優先度が入力されていません。");
        }
        if (filterItem.mail_terms.length <= 0) {
            ++totalValidError;
            showErrorEntity($("#divMailTerm"), "メールのフィルター条件が設定されていません。");
        }

        if (filterItem.enable_flow) {
            // 流量条件 ON の場合のみチェック
            if (filterItem.flow_interval == "") {
                ++totalValidError;
                showErrorEntity($("#txtCheckMinute"), "流量確認期間が入力されていません。");
            }
            if (filterItem.flow_count == "") {
                ++totalValidError;
                showErrorEntity($("#txtMailCount"), "流量が入力されていません。");
            }
            if (filterItem.flow_term == "") {
                ++totalValidError;
                showErrorEntity($("#selFlTerm"), "流量条件が選択されていません。");
            }

            $("#flowTerms").find("input[type='number']").each(function() {
                let vv = parseInt($(this).val()) || 0;
                let mx = parseInt($(this).prop("max")) || 0;
                let mn = parseInt($(this).prop("min")) || 0;
                let nm = $(this).attr("aria-label");

                if (vv < mn) {
                    ++totalValidError;
                    showErrorEntity($(this), nm + "が小さすぎます。");
                } else if (vv > mx) {
                    ++totalValidError;
                    showErrorEntity($(this), nm + "が大きすぎます。");
                }
            });
        }

        // number の入力チェック
        $("#baseInfo").find("input[type='number']").each(function() {
            let vv = parseInt($(this).val()) || 0;
            let mx = parseInt($(this).prop("max")) || 0;
            let mn = parseInt($(this).prop("min")) || 0;
            let nm = $(this).attr("aria-label");

            if (vv < mn) {
                ++totalValidError;
                showErrorEntity($(this), nm + "が小さすぎます。");
            } else if (vv > mx) {
                ++totalValidError;
                showErrorEntity($(this), nm + "が大きすぎます。");
            }
        });

        if (filterItem.mail_term_join == "") {
            $("#rdoMailAnd").prop("checked", true);
            filterItem.mail_term_join = parseInt($("#rdoMailAnd").val());
        }
        if (filterItem.log_term_join == "") {
            $("#rdoEvtOr").prop("checked", true);
            filterItem.log_term_join = parseInt($("#rdoEvtOr").val());
        }

        return (totalValidError > 0) ? null : filterItem;
    }

    $("#btnTmAdd").on('click', function() {
        // テンプレートコピー
        $('#tTermItem').contents().clone(true).appendTo('#timeTerms');
    });

    $(document).on('click', 'button[name="btnTmDel"]', function() {
        // 削除
        $(this).parent().parent().remove();
    });

    $("#btnMlAdd").on('click', function() {
        // テンプレートコピー
        $('#mTermItem').contents().clone(true).appendTo('#mailTerms');
    });

    $(document).on('click', 'button[name="btnMlDel"]', function() {
        // 削除
        $(this).parent().parent().remove();
    });

    $("#btnKwAdd").on('click', function() {
        // テンプレートコピー
        $('#kTermItem').contents().clone(true).appendTo('#kwdTerms');
    });

    $(document).on('click', 'button[name="btnKwDel"]', function() {
        // 削除
        $(this).parent().parent().remove();
    });

    $("#chkEnableFlow").on('click', function() {
        if ($(this).prop('checked')) {
            $("#flowTerms").removeAttr('disabled');
            $("#txtCheckMinute").addClass("has-background-danger-light");
            $("#txtMailCount").addClass("has-background-danger-light");
        } else {
            $("#flowTerms").attr('disabled', 'disabled');
            $("#txtCheckMinute").removeClass("has-background-danger-light");
            $("#txtMailCount").removeClass("has-background-danger-light");
        }
    });

    $("#btnSave").on('click', function() {
        // 初期化
        hideAlert();
        resetAllErrorEntity();

        // データ取得
        const data = getFilterItem();
        if (data == null) {
            return false;
        }

        var url = ("filter_id" in data) ? '/filter/item/' + String(data.filter_id) : '/filter/item';
        var method = ("filter_id" in data) ? "PUT" : "POST";
        const data_str = JSON.stringify(data)

        $.ajax(url, {
            method: method,
            data: data_str,
            cache: false,
            headers: {'content-type':'application/json'},
            dataType: "json",
            jsonp: false,
        }).done(function(data, textStatus, jqXHR) {
            // 保存を終えて、一覧に戻る
            window.location.href = '/filter/list';
        }).fail(function(jqXHR, textStatus, errorThrown) {
            const alt_msg = responseToMessage(jqXHR);
            if (alt_msg.length > 0) {
                showAlert(alt_msg);
            }
        });
    });

    $("#btnDiscard").on('click', function() {
        window.location.href = '/filter/list';
    });

    $("a[name=filterAction]").on('click', function() {
        if ($(this).parent().hasClass('is-active')) {
            return;
        }

        // タブの切り替え
        let actTab = $(this).parent().parent().find('.is-active');
        actTab.removeClass('is-active');
        let panelId = actTab.attr('aria-controls');
        $(panelId).hide();

        $(this).parent().addClass('is-active');
        panelId = $(this).parent().attr('aria-controls');
        $(panelId).show();
    });
});
