$(function() {
    $(function() {
        // 最大件数以上の作成を許可しない
        let curCnt = parseInt($("#rowCnt").val()) || 0;
        let maxCnt = parseInt($("#maxCnt").val()) || 0;
        let currPg = parseInt($("#currentPage").val()) || 1;
        let lineCnt = parseInt($("#lineCount").val()) || 1;

        // ページマークの数
        const totalMarkCount = 5;

        // 上限オーバー
        if (curCnt >= maxCnt) {
            console.log("limit over: " + curCnt + " >= " + maxCnt);
            $("#btnCreateFilter").prop("disabled", true);
            $("#btnCreateFilter").prop("title", "設定可能な上限(" + maxCnt + ")を超えたため、新規追加することはできません。");
            $('a[name="mntCpy"]').addClass("disabled-link");
            $("#rNumber").text("0");
        } else {
            console.log("safe: " + curCnt + " < " + maxCnt);
            $("#rNumber").text(String(maxCnt - curCnt));
        }

        // ページ遷移
        let baseUrl = "/filter/list?page=";
        let pages = [currPg];
        let pageHTML = [];
        let totalPg = Math.ceil(curCnt / lineCnt);
        let jumpHTML = "";

        // 現ページより前のページ番号を作成
        for (let ctr = 1 ; ctr <= Math.floor(totalMarkCount / 2) ; ++ctr) {
            let pageNumber = currPg - ctr;
            if (pageNumber < 1) {
                break;
            }
            pages.unshift(pageNumber);
        }

        // 現ページ以降のページ番号を作成
        for (let ctr = 1 ; ctr <= Math.floor(totalMarkCount / 2) ; ++ctr) {
            let pageNumber = currPg + ctr;
            if (pageNumber > totalPg) {
                break;
            }
            pages.push(pageNumber);
        }

        // ページ数が所定の件数ない場合、補完処理を行う
        if (pages.length < totalMarkCount) {
            if (pages[0] == 1) {
                // 後のページに余裕がある
                for (let ctr = pages[pages.length - 1] + 1 ; ctr <= totalPg ; ++ctr) {
                    pages.push(ctr);
                    if (pages.length >= totalMarkCount) {
                        break;
                    }
                }
            } else {
                // 前のページに余裕がある
                for (let ctr = pages[0] - 1 ; ctr > 0 ; --ctr) {
                    pages.unshift(ctr);
                    if (pages.length >= totalMarkCount) {
                        break;
                    }
                }
            }
        }

        // ページマーク HTML の準備
        pages.forEach(pageNumber => {
            if (pageNumber != currPg) {
                pageHTML.push('<a class="pagination-link" aria-label="'
                    + pageNumber.toString() + 'ページ目" href="' + baseUrl + pageNumber.toString()
                    + '">' + pageNumber.toString() + '</a>');
            } else {
                pageHTML.push('<a class="pagination-link is-current" aria-label="'
                + pageNumber.toString() + 'ページ目" href="' + baseUrl + pageNumber.toString()
                + '">' + pageNumber.toString() + '</a>');
            }
        });

        // ページ前後の省略記号設定
        if (pages[0] > 1) {
            jumpHTML += '<a class="pagination-previous" href="' + baseUrl + '1">最初</a>' + "\n";
            pageHTML.unshift('<span class="pagination-ellipsis">&hellip;</span>');
        }
        if (pages.length >= totalMarkCount && pages[pages.length - 1] < totalPg) {
            jumpHTML += '<a class="pagination-next" href="' + baseUrl + totalPg.toString() + '">最後</a>' + "\n";
            pageHTML.push('<span class="pagination-ellipsis">&hellip;</span>');
        }

        // ページネーション本体
        jumpHTML += '<ul class="pagination-list" id="pageNumber"></ul>';

        // HTML に反映
        $('#pagenationRoot').html(jumpHTML);
        $('#pageNumber').html(pageHTML.map(anchor => '<li>' + anchor + '</li>'));
    });

    $(document).on('click', '.dropdown-item',function() {
        let id = $(this).parents('tr').find('input[type="hidden"]').val();
        let ctrl = $(this).text();

        if (ctrl != '削除') {
            url = '/filter/item/' + id;
            if (ctrl == "複製") {
                // コピー新規
                url += "?method=cp";
            }
            window.location.href = url;
        } else {
            if (confirm('ID=' + id + ' のフィルターを削除します。')) {
                let url = "/filter/item/" + String(id);
        
                $.ajax(url, {
                    method: "DELETE",
                    cache: false,
                }).done(function(data, textStatus, jqXHR) {
                    window.location.reload();
                }).fail(function(jqXHR, textStatus, errorThrown) {
                    const alt_msg = responseToMessage(jqXHR);
                    if (alt_msg.length > 0) {
                        showAlert(alt_msg);
                    }
                });
            } else {
                return false;
            }
        }
    });
    
    $("#btnCreateFilter").on('click', function() {
        window.location.href = '/filter/item';
    });
});
