//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	// グループ名のオートコンプリート候補取得
	var ajaxParam = {};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(action_actionEditAction_ajaxGroupAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	// アクション種別変更
	$('#actionType').change(function () {
		// 表示非表示切り替え
		showOrHideSwitch();
		// カスタムアクションを選択した場合、
		//   メールの設定のアノテーションに引っかかってしまわないように、メール設定の
		//   中身を消す
		// メール送信を選択した場合、
		//   プログラム名のアノテーションに引っかかってしまわないように、アクション設定の
		//   中身を消す
		if ($('#actionType').val() == 'CUSTOM') {
			$('#smtpServer').val('');
			$('#smtpPort').val('');
			$('#smtpCryptType').val('');
			$('#mailAuthenticationType').val('');
			$('#mailUserId').val('');
			$('#mailPassword').val('');
			$('#sourceMailAddress').val('');
			$('#destinationMailAddress').val('');
			$('#mailSubject').val('');
			$('#mailMessage').val('');
		}else if ($('#actionType').val() == 'MAIL') {
			$('#actionCommand').val('');
			$('#actionParams').val('');
			$('#actionWorkingFolder').val('');
			$('#smtpPort').val('25');
			$('#smtpCryptType').val('NONE');
			$('#mailAuthenticationType').val('NONE');
		}
		$('#mailAuthenticationType').change();
	});
	// 表示非表示切り替え
	showOrHideSwitch();

	// メールサーバー オートコンプリート
	var ajaxParam = {};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(action_actionEditAction_ajaxMailSettingAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	// メール接続の保護変更
	$('#smtpCryptType').change(function () {
		if ($(this).val() == 'NONE') {
			if( $('#smtpPort').val() == '' | $('#smtpPort').val() == '465' | $('#smtpPort').val() == '587'){
				$('#smtpPort').val('25');
			}
		} else if ($(this).val() == 'SSL_TLS') {
			if( $('#smtpPort').val() == '25' | $('#smtpPort').val() == '587'){
				$('#smtpPort').val('465');
			}
		} else if ($(this).val() == 'STARTTLS') {
			if( $('#smtpPort').val() == '25' | $('#smtpPort').val() == '465'){
				$('#smtpPort').val('587');
			}
		}
	});

	//メール接続ポート番号の初期値設定
	$('#smtpCryptType').change();

	// メール認証変更
	$('#mailAuthenticationType').change(function () {
		if ($('#actionType').val() == 'MAIL') {
			if ($(this).val() == 'NONE') {
				// 認証なし
				$('.mailSmtpAuthentication').hide();
			} else {
				// SMTP AUTH PLAIN
				$('.mailSmtpAuthentication').show();
			}
		}else{
			//メールアクションでない場合には、メール認証の表示はしない
			$('.mailSmtpAuthentication').hide();
		}
	});
	$('#mailAuthenticationType').change();

	// リセットボタンを押した時の動作
	$('div.dialogButtons input[type=reset]').on('click', function(){
		$('#actionEditForm').get(0).reset();
		// 表示非表示切り替え
		showOrHideSwitch();
		$('#smtpCryptType').change();
		$('#mailAuthenticationType').change();
		return false;
	});

	//=========================================================================
	// 予約済み変数関連の処理
	//=========================================================================
	var caret_pos;	//カーソル位置のグローバル変数

	//-------------------------------------------------------------------------
	// 予約済み変数ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('input.reservedVariableButton').on('click', function() {
		var thisInput = $(this);
		//---------------------------------------------------------------------
		// セレクト項目初期化
		//---------------------------------------------------------------------
		var reservedVariableMap = {};
		var options = '';
		$('input.reservedVariableList').each(function () {
			reservedVariableMap[$(this).attr('name')] = $(this).val();
			options += '<option value="' + $(this).attr('name') + '" label="' + $(this).attr('name') + '"/>';
		});
		$('#reservedVariable').html(options);
		$('#reservedVariable').off('change');
		$('#reservedVariable').on('change', function () {
			var reservedVariableDetails = reservedVariableMap[$(this).val()];
			if (reservedVariableDetails == undefined) {
				reservedVariableDetails = '';
			}
			$('#reservedVariableDetails').get(0).innerText = reservedVariableDetails;
		});
		$('#reservedVariable').change();

		var targetTextArea = undefined;
		if (thisInput.attr('id') == 'reservedVariableButtonParams') {
			targetTextArea = $('#actionParams');
		} else if (thisInput.attr('id') == 'reservedVariableButtonMessage'){
			targetTextArea = $('#mailMessage');
		}
		//---------------------------------------------------------------------
		// カーソル位置を保存する
		//---------------------------------------------------------------------
		caret_pos  = getCaretPosition(targetTextArea.get(0));
		targetTextArea.blur();

		//---------------------------------------------------------------------
		// カーソル位置への挿入イベント登録
		//---------------------------------------------------------------------
		if (targetTextArea != undefined) {
			$('#dialogInsert').off('click');
			//---------------------------------------------------------------------
			// カーソル位置への「挿入」ボタンをクリックしたときの処理
			//---------------------------------------------------------------------
			$('#dialogInsert').on('click', function() {
				insertTextAtPosision(targetTextArea.get(0), caret_pos, $('#reservedVariable').val());
				return;
			});
		}
		//---------------------------------------------------------------------
		// 「閉じる」ボタンをクリックした時の処理
		//---------------------------------------------------------------------
		$('#dialogClose').click(function() {
			$('#reservedVariableDialog').dialog('close');
		});

		//---------------------------------------------------------------------
		// ダイアログ表示処理
		//---------------------------------------------------------------------
		$('#reservedVariableDialog').dialog({
			autoOpen: true,
			modal: true,
			position: [40,15], //ダイアログの表示位置を左上の端っこにする
			title: thisInput.val(),
			width: 320,
			height: 160,
			resizable: false
		});
		//ボタンを綺麗にする
		$('#reservedVariableDialog').find('button').button();
		//初期フォーカスをOKボタンに合わせる
		$('#dialogInsert').focus();
	});
	//-------------------------------------------------------------------------
	// 表示非表示切り替え
	//-------------------------------------------------------------------------
	function showOrHideSwitch() {
		if ($('#actionType').val() == 'CUSTOM') {
			// カスタムアクション選択
			$('.customAction').show();
			$('.mailAction').hide();
		} else if ($('#actionType').val() == 'MAIL') {
			// メールアクション選択
			$('.customAction').hide();
			$('.mailAction').show();
		}
	}
	//-------------------------------------------------------------------------
	// カーソル位置へのテキストの挿入関数
	//-------------------------------------------------------------------------
	function insertTextAtPosision(obj, pos, txt) {
	    obj.focus();
	    if (jQuery.browser.msie) {
	        pos.text = txt;
	        pos.select();
	    } else {
	        var s = obj.value;
	        var np = pos + txt.length;
	        obj.value = s.substr(0, pos) + txt + s.substr(pos);
	        obj.setSelectionRange(np, np);
	    }
	}
	//-------------------------------------------------------------------------
	// カーソル位置取得関数
	//-------------------------------------------------------------------------
	function getCaretPosition(obj) {
	    obj.focus();
	    var pos;
	    if (jQuery.browser.msie) {
	        pos = document.selection.createRange();
	    } else {
	        pos = obj.selectionStart;
	    }
	    return pos;
	}

	//-------------------------------------------------------------------------
	// iPad用の注意喚起文表示関数
	//-------------------------------------------------------------------------
	function iPadCautionDisplay(){
		var labelString = '<span class="actionWorkingFolderLabel">iPadのパス区切り文字は[\\(半角)]を指定してください</span>';
		$('#actionWorkingFolderLabel').html($('#actionWorkingFolderLabel').text() + '<BR/>' + labelString);
	};
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		iPadCautionDisplay();
	}



	//オートコンプリートの表示が横にずれる問題の対策
	//<body>の幅をそのwindowの幅に設定する
	$('body').width($(window).width());
});

//Ajaxコールバック関数
function action_actionEditAction_ajaxGroupAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#groupPath').autocomplete({
			source : autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}
function action_actionEditAction_ajaxMailSettingAutoCompleteCandidate(objectMapList) {
	var itemList = new Array();
	for (i in objectMapList) {
		var objectMap = objectMapList[i];
		// リストに追加済みなら何も行わない
		var find = false;
		for (j in itemList) {
			if (itemList[j]['label'] == objectMap['smtpServer'] + ':' + objectMap['smtpPort']) {
				find = true;
				break;
			}
		}
		if (find) {
			continue;
		}

		var map = new Array();
		map['label'] = objectMap['smtpServer'] + ':' + objectMap['smtpPort'];
		map['value'] = objectMap['smtpServer'];
		itemList.push(map);
	}

	$('#smtpServer').autocomplete({
		source : itemList,
		select : function(event, ui) {
			for (i in objectMapList) {
				var objectMap = objectMapList[i];
				if (ui['item']['label'] == objectMap['smtpServer'] + ':' + objectMap['smtpPort']) {
					$('#smtpPort').val(objectMap['smtpPort']);
					$('#smtpCryptType').val(objectMap['smtpCryptType']);
					$('#mailAuthenticationType').val(objectMap['mailAuthenticationType']);
					$('#mailUserId').val(objectMap['mailUserId']);
					$('#mailPassword').val(objectMap['mailPassword']);
					$('#mailAuthenticationType').change();
					$('#sourceMailAddress').val(objectMap['sourceMailAddress']);
				}
			}
		},
		delay : 50,
		minLength : 0
	});

	$('#doTestExecute').on('click', function(){
		//ダイアログボタンの「☓」を押しても閉じないようにデータを入れておく
		$('#actionEditForm').append('<input type="hidden" id="canClose" value="false" />');

		//Chromeの処理中表示をIEの画面でも表示させる設定
		$('#actionEditForm').addClass('waitMouseCursor');
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
		//処理中表示
		$.blockUI({
			message:'カスタムアクション実行中',
			overlayCSS:  {
				backgroundColor: '#aaa',
				opacity:         0.6,
				cursor:          'wait'},
			css: {
				padding: '33px 0 0 0',
				margin:  0,
				height:  '50px',
				width:   '250px',
				border:  '2px solid #aaa',}
		});
	});
	$('#doConfirm,#jumpActionList').on('click', function(){

		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
}


