//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
// ヘッダー固定テーブル
$.fn.extend({
	//==============================================================================
	// Wedget
	//==============================================================================
	// ヘッダー固定テーブル
	fixedHeaderTable : function(options) {
		return this.each(function(index) {
			if($(this).has('fixedTable') == false){
				return;
			}

			var fixedHeaderTable = $(this);
			var fixedHeaderTableThead = fixedHeaderTable.children('thead');
			var fixedHeaderTableThList = fixedHeaderTableThead.find('th');
			var fixedHeaderTableTbody = fixedHeaderTable.children('tbody');

			fixedHeaderTable.width(fixedHeaderTable.parent().width());
			fixedHeaderTable.height(fixedHeaderTable.parent().height());

			fixedHeaderTableThead.css('overflow', 'hidden');
			fixedHeaderTableTbody.css('overflow-x', 'hidden');
			fixedHeaderTableTbody.css('overflow-y', 'scroll');

			// テーブルの設定
			fixedHeaderTableThead.css('position', 'absolute');
			fixedHeaderTableTbody.css('position', 'absolute');

			var fixedHeaderTableWidth = fixedHeaderTable.width();
			var fixedHeaderTableHeight = fixedHeaderTable.height();

			fixedHeaderTableThead.width(fixedHeaderTableWidth - 16);
			fixedHeaderTableTbody.width(fixedHeaderTableWidth);

			var fixedHeaderTableTheadHeight = fixedHeaderTableThead.height();

			fixedHeaderTableTbody.css('top', fixedHeaderTableTheadHeight);
			fixedHeaderTableTbody.height(fixedHeaderTableHeight - fixedHeaderTableTheadHeight);

			//THと同じ幅にする
			fixedHeaderTableTbody.children('tr:first').children().each(function (i) {
				$(this).width(fixedHeaderTableThList.eq(i).outerWidth(false));
			});

			//-----------------------------------------------------------------
			// ツールボックス以外をクリックしたらボックスを消去する
			//-----------------------------------------------------------------
			$(document).on('click', '*', function(e){
				var target = $(e.target);
				if(target.is('th') == false){
					if(target.hasClass('tableToolBoxButton') == false){
						var flag = false;
						target.parents('*').each(function(){
							if($(this).hasClass('divToolBox')){
								flag = true;
								return;
							}
						});
						if(flag == false){
							//表示中のToolBoxは閉じる
							$('div.divToolBox').remove();
						}
					}
				}
				target = null;
			});

			//---------------------------------
			// イベント登録
			//---------------------------------
			// リサイズイベント登録
			$(window).resize(function () {
				$('table.fixedTable').trigger('update');
			});
			//情報更新イベントの定義
			$(this).bind('update', function(){
				//先にツールボックスを消去する
				$('div.divToolBox:visible').css('visibility', 'hidden');

				var fixedHeaderTable = $('table.fixedTable');
				var fixedHeaderTableThead = fixedHeaderTable.children('thead');
				var fixedHeaderTableThList = fixedHeaderTableThead.find('th');
				var fixedHeaderTableTbody = fixedHeaderTable.children('tbody');
				var fixedHeaderTableParentWidth = fixedHeaderTable.parent().width();
				var fixedHeaderTableParentHeight = fixedHeaderTable.parent().height();

				/*
				if( fixedHeaderTableParentWidth > (1024 - mainTreeViewWidth)){
					fixedHeaderTable.width(fixedHeaderTableParentWidth);
				}else{
					fixedHeaderTable.width(1024 - mainTreeViewWidth);
				}
				*/
				fixedHeaderTable.width(fixedHeaderTableParentWidth);
				fixedHeaderTable.height(fixedHeaderTableParentHeight);

				var fixedHeaderTableWidth = fixedHeaderTable.width();
				var fixedHeaderTableHeight = fixedHeaderTable.height();

				fixedHeaderTableThead.width(fixedHeaderTableWidth - 16);
				fixedHeaderTableTbody.width(fixedHeaderTableWidth);

//				var fixedHeaderTableTheadWidth = fixedHeaderTableThead.width();
				var fixedHeaderTableTheadHeight = fixedHeaderTableThead.height();

				fixedHeaderTableTbody.css('top', fixedHeaderTableTheadHeight);
				fixedHeaderTableTbody.height(fixedHeaderTableHeight - fixedHeaderTableTheadHeight);

				//THサイズの補正
				//expandRowクラスがついている列の拡張を行う
				var thSum = 0;
				fixedHeaderTableThList.each(function () {
					thSum += $(this).width();
				});
				var expandLength = fixedHeaderTableParentWidth - thSum;
				if( expandLength > 0 ){
					var expandRowCell = fixedHeaderTableThList.filter('.expandRow');
					expandRowCell.width(expandRowCell.width()+expandLength);
					expandRowCell = null;
				}

				//THと同じ幅にする
				fixedHeaderTableThList = fixedHeaderTableThead.find('th');
				var borderWidth = 0;//parseInt(fixedHeaderTableThList.eq(0).css('border-width'));
				fixedHeaderTableTbody.children('tr:first').children().each(function (i) {
					$(this).width(fixedHeaderTableThList.eq(i).outerWidth(false)+(borderWidth*2));
				});

				fixedHeaderTable = null;
				fixedHeaderTableThead = null;
				fixedHeaderTableThList = null;
				fixedHeaderTableTbody = null;
			});

			fixedHeaderTable = null;
			fixedHeaderTableThead = null;
			fixedHeaderTableThList = null;
			fixedHeaderTableTbody = null;
		});
	}
	//=========================================================================
	// ツールボックス作成
	//=========================================================================
	,makeToolBox : function(option, targetTh) {
		var thisTh = $(targetTh);
		var toolBoxWidth = (option['width'] == undefined)?240:option['width'];
		var sortTableFlg = (option['sortTable']);
		var filterTableFlg = (option['filterTable']);
		var allConfirmedFlg = (option['allConfirmed']);
		//=========================================================================
		// ツールボックス内並び替え部品作成
		//=========================================================================
		function makeToolBoxSortParts(sortTypeSub, divToolBoxSub){
			var thisToolBox = $(divToolBoxSub);

			//-----------------------------------------------------------------
			// 対象が「<th>」かどうかをチェックする
			// 現状は、<th>にツールボックスを作成する
			//-----------------------------------------------------------------
			if(thisToolBox.is('div.divToolBox') == false){
				alert('表示対象外データです');
				thisToolBox = null;
				return;
			}
			//-----------------------------------------------------------------
			// ソートタイプに設定がなかったら何も表示しない
			//-----------------------------------------------------------------
			if(sortTypeSub == undefined){
				thisToolBox = null;
				return;
			}

			var addData = $('<h4/>').html('並び替え')
				.add($('<div/>').addClass('cursor selectShow orderAsc').html('昇順'))
				.add($('<div/>').addClass('cursor selectShow orderDesc').html('降順'));

			//ツールボックスにデータを追加する
			thisToolBox.append($(addData));
			addData = null;

			//部品を追加したので、データ数を加算する
			thisToolBox.data('dataLength', thisToolBox.data('dataLength')+1);
			thisToolBox.addClass(sortTypeSub);

			thisToolBox = null;
		}

		//=========================================================================
		// ツールボックス内絞込み部品作成
		//=========================================================================
		function makeToolBoxFilterParts(filterTypeSub, divToolBoxSub){
			var thisToolBox = $(divToolBoxSub);
			var addData = $('<h4/>').html('絞込み');

			//-----------------------------------------------------------------
			// 対象が「<th>」かどうかをチェックする
			// 現状は、<th>にツールボックスを作成する
			//-----------------------------------------------------------------
			if(thisToolBox.is('div.divToolBox') == false){
				alert('表示対象外データです');
				thisToolBox = null;
				return;
			}
			//-----------------------------------------------------------------
			// フィルタタイプに設定がなかったら何も表示しない
			//-----------------------------------------------------------------
			if(filterTypeSub == undefined){
				thisToolBox = null;
				return;
			}

			//-----------------------------------------------------------------
			// テキストデータの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeText'){
				addData = addData
							.add($('<div/>')
									.append( $('<input type="text"/>').addClass('toolBoxInputText').attr('name', 'filterText').attr('maxlength', '200').val('') )
							)
							.add($('<div/>')
									.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
									.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
							);
			}
			//-----------------------------------------------------------------
			// 日付データの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeDate'){
				addData = addData
							.add($('<div/>').html('～')
									.prepend( $('<input type="text"/>').addClass('toolBoxInputDate').attr('name', 'filterDateBefore').attr('maxlength', '200').val('') )
									.append( $('<input type="text"/>').addClass('toolBoxInputDate').attr('name', 'filterDate').attr('maxlength', '200').val('') )
							)
							.add($('<div/>')
									.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
									.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
							);
			}
			//-----------------------------------------------------------------
			// 有効無効データの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeEnable'){

				addData = addData
							.add($('<div/>')
									.append( $('<label/>').html('有効')
											.prepend( $('<input type="radio"/>').attr('name', 'enable').val('有効') )
									)
							)
							.add($('<div/>')
									.append( $('<label/>').html('無効')
											.prepend( $('<input type="radio"/>').attr('name', 'enable').val('無効') )
								)
							)
							.add($('<div/>')
									.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
									.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
							);
			}
			//-----------------------------------------------------------------
			// インスタンス内ステータスデータの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeMonitorStatus'){
				var statusIconHashTable = {
						'失敗':'../../images/summaryFailure16.png',
						'危険':'../../images/summaryDanger16.png',
						'注意':'../../images/summaryWarning16.png',
						'正常':'../../images/summaryInformation16.png'
							};
				addData = addData
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('失敗')
									.prepend( $('<img/>').attr('src', statusIconHashTable['失敗']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'monitorStatus').val('失敗') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('危険')
									.prepend( $('<img/>').attr('src', statusIconHashTable['危険']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'monitorStatus').val('危険') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('注意')
									.prepend( $('<img/>').attr('src', statusIconHashTable['注意']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'monitorStatus').val('注意') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('正常')
									.prepend( $('<img/>').attr('src', statusIconHashTable['正常']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'monitorStatus').val('正常') )
							)
					)
					.add($('<div/>')
							.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
							.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
					);
			}
			//-----------------------------------------------------------------
			// アクショントリガーデータの絞込み部品 および
			// インスタンスステータスデータの絞込み部品 および
			// アクションログトリガーの絞込み部品
			//-----------------------------------------------------------------
			if((filterTypeSub == 'filterTypeActionTrigger') || (filterTypeSub == 'filterTypeInstanceStatus') || (filterTypeSub == 'filterTypeActionTriggerLog')){
				var statusIconHashTable = {'disconnectComputer':'../../images/summaryDisconnectComputer16.png',
						'disconnectHelper':'../../images/summaryDisconnectHelper16.png',
						'disconnectAgent':'../../images/summaryDisconnectAgent16.png',
						'failure':'../../images/summaryFailure16.png',
						'danger':'../../images/summaryDanger16.png',
						'warning':'../../images/summaryWarning16.png',
						'normal':'../../images/summaryInformation16.png',
						'confirm': '../../images/confirm16.png',
						'invisible': '../../images/invisible16.png'};
				if(filterTypeSub == 'filterTypeActionTriggerLog'){
					addData = addData
						.add($('<div/>')
								.append( $('<span/>').html('インスタンス名').add('<br/>') )
								.append($('<label/>')
										.append($('<input type="text"/>').attr('name', 'instanceName').attr('maxlength', '200').val(''))
								)
						);
				}
				addData = addData
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('コンピューター接続エラー')
									.prepend( $('<img/>').attr('src', statusIconHashTable['disconnectComputer']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'disconnectComputer').val('disconnectComputer') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('ヘルパーサービス接続エラー')
									.prepend( $('<img/>').attr('src', statusIconHashTable['disconnectHelper']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'disconnectHelper').val('disconnectHelper') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('監視サービス停止中')
									.prepend( $('<img/>').attr('src', statusIconHashTable['disconnectAgent']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'disconnectAgent').val('disconnectAgent') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('失敗')
									.prepend( $('<img/>').attr('src', statusIconHashTable['failure']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'failure').val('failure') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('危険')
									.prepend( $('<img/>').attr('src', statusIconHashTable['danger']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'danger').val('danger') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('注意')
									.prepend( $('<img/>').attr('src', statusIconHashTable['warning']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'warning').val('warning') )
							)
					)
					.add($('<div/>')
							.append( $('<label/>').addClass('cursor').html('正常')
									.prepend( $('<img/>').attr('src', statusIconHashTable['normal']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'normal').val('normal') )
							)
					);

				//インスタンスステータスの絞り込みの場合には、確認済みのチェックボックスも追加する
				if(filterTypeSub == 'filterTypeInstanceStatus'){
					addData = addData
						.add($('<hr/>').addClass('confirmedSeparate'))
						.add($('<div/>')
								.append( $('<label/>').addClass('cursor').html('確認の絞り込みを行わない')
										.prepend( $('<input type="radio"/>').attr('name', 'statusConfirmed').attr('checked', 'checked').val('statusConfirmedAll') )
								)
						)
						.add($('<div/>')
								.append( $('<label/>').addClass('cursor').html('確認済みを絞り込む')
										.prepend( $('<img/>').attr('src', statusIconHashTable['confirm']) )
										.prepend( $('<input type="radio"/>').attr('name', 'statusConfirmed').val('statusConfirmed') )
								)
						)
						.add($('<div/>')
								.append( $('<label/>').addClass('cursor').html('未確認を絞り込む')
										.prepend( $('<img/>').attr('src', statusIconHashTable['invisible']) )
										.prepend( $('<input type="radio"/>').attr('name', 'statusConfirmed').val('statusNoConfirmed') )
								)
						);
				}
				addData = addData
					.add($('<div/>')
							.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
							.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
					);
			}
			//-----------------------------------------------------------------
			// ライセンスキーデータの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeLicenseKey'){
				addData = addData
					.add($('<div/>')
							.append($('<label/>').addClass('cursor').html('重複するキーのみ表示する')
									.prepend( $('<input type="checkbox"/>').attr('name', 'filterDuplication') )
							)
					)
					.add($('<div/>')
							.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
							.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
					);
			}
			//-----------------------------------------------------------------
			// アクション実行結果データの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeActionResult'){
				addData = addData
					.add($('<div/>')
							.append($('<label/>').html('成功')
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResult').val('0') )
							)
					)
					.add($('<div/>')
							.append($('<label/>').html('エラー')
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResult').val('1') )
							)
					)
					.add($('<div/>')
							.append($('<label/>').html('失敗')
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResult').val('2') )
							)
					)
					.add($('<div/>')
							.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
							.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
					);
			}
			//-----------------------------------------------------------------
			// 情報データの絞込み部品
			//-----------------------------------------------------------------
			if(filterTypeSub == 'filterTypeInformation'){
				// タイプ
				var typeIconHashTable = {'actionResultError':'../../images/logError16.png',
						'actionResultWarning':'../../images/logWarning16.png',
						'actionResultInformation':'../../images/logInformation16.png'};
				addData = addData
					.add($('<div/>')
							.append($('<label/>').addClass('cursor').html('エラー')
									.prepend( $('<img/>').attr('src', typeIconHashTable['actionResultError']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResultError').val('1') )
							)
					)
					.add($('<div/>')
							.append($('<label/>').addClass('cursor').html('警告')
									.prepend( $('<img/>').attr('src', typeIconHashTable['actionResultWarning']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResultWarning').val('2') )
							)
					)
					.add($('<div/>')
							.append($('<label/>').addClass('cursor').html('情報')
									.prepend( $('<img/>').attr('src', typeIconHashTable['actionResultInformation']) )
									.prepend( $('<input type="checkbox"/>').attr('name', 'actionResultInformation').val('4') )
							)
					)
					.add($('<div/>')
							.append( $('<input type="submit"/>').addClass('toolBoxFilterButton').val('絞込み') )
							.append( $('<input type="submit"/>').addClass('toolBoxFilterCancelButton').val('絞込み解除') )
					);
			}

			//ツールボックスにデータを追加する
			thisToolBox.append($(addData));
			//部品を追加したので、データ数を加算する
			thisToolBox.data('dataLength', thisToolBox.data('dataLength')+1);
			thisToolBox.addClass(filterTypeSub);

			thisToolBox = null;
		}

		//=========================================================================
		// ツールボックス内全確認部品作成
		//=========================================================================
		function makeToolBoxAllConfirmedParts(divToolBoxSub){
			var thisToolBox = $(divToolBoxSub);

			//-----------------------------------------------------------------
			// 対象が「<th>」かどうかをチェックする
			// 現状は、<th>にツールボックスを作成する
			//-----------------------------------------------------------------
			if(thisToolBox.is('div.divToolBox') == false){
				alert('表示対象外データです');
				thisToolBox = null;
				return;
			}

			var addData = $('<h4/>').html('一括確認')
				.add( $('<div/>').addClass('cursor selectShow allConfirmed').html('全一括確認') );

			//ツールボックスにデータを追加する
			thisToolBox.append($(addData));
			//部品を追加したので、データ数を加算する
			thisToolBox.data('dataLength', thisToolBox.data('dataLength')+1);

			thisToolBox = null;
		}

		//-----------------------------------------------------------------
		// 対象が「<th>」かどうかをチェックする
		// 現状は、<th>にツールボックスを作成する
		//-----------------------------------------------------------------
		if(thisTh.is('th') == false){
			alert('表示対象外データです');
			return;
		}

		//-----------------------------------------------------------------
		// 直前のクリックで開いたツールボックスの場合、閉じる処理しか
		// 行わない
		//-----------------------------------------------------------------
		var thisThIndex = thisTh.index('th');
		var closeFlg = false;
		$('div.divToolBox').each(function(){
			var clickIndex = $(this).data('clickIndex');
			if(clickIndex == thisThIndex){
				$(this).remove();
				closeFlg = true;
			}
			clickIndex = null;
		});
		thisThIndex = null;
		if(closeFlg){
			return;
		}

		//-----------------------------------------------------------------
		// ツールボックスはひとつしか表示させないため、
		// ほかのツールボックスは消す
		//-----------------------------------------------------------------
		$('div.divToolBox').remove();

		//-----------------------------------------------------------------
		// ツールボックス作成処理
		//-----------------------------------------------------------------
		//ツールボックスのタグを作成
		var divToolBox = $('<div/>').addClass('divToolBox');

		//テーブル位置、サイズを指定する
		var leftData = (thisTh.position().left);
		var topData = (thisTh.position().top + thisTh.outerHeight(false));
		//画面幅を越えている場合には、補正を行う
		if( (leftData+toolBoxWidth) > $(window).innerWidth()){
			leftData = leftData - ( (leftData + toolBoxWidth) - $(window).innerWidth() ) - 16;
		}
		divToolBox.css({left:leftData+'px', top:topData+'px'});
		divToolBox.css({width:toolBoxWidth+'px'});

		divToolBox.css('z-index', '100');
		divToolBox.css('visibility', 'visible');

		//THへの参照のため、保存しておく
		divToolBox.data('targetTh',thisTh);
		divToolBox.data('dataLength', 0);
		divToolBox.data('clickIndex',thisTh.index('th'));

		//クリック位置を保存しておく
		thisTh.parents('table').data('clickIndex', thisTh.index('th'));

		//---------------------------------------------------------------------
		// 並び替え部品追加
		//---------------------------------------------------------------------
		if(sortTableFlg == true){
			var sortType = undefined;
			if(thisTh.hasClass('sortTypeText')){
				sortType = 'sortTypeText';
			}else if(thisTh.hasClass('sortTypeLicense')){
				sortType = 'sortTypeLicense';
			}else if(thisTh.hasClass('sortTypeDate')){
				sortType = 'sortTypeDate';
			}else if(thisTh.hasClass('sortTypeInformation')){
				sortType = 'sortTypeInformation';
			}else if(thisTh.hasClass('sortTypeImplant')){
				sortType = 'sortTypeImplant';
			}else if(thisTh.hasClass('sortTypeActionTrigger')){
				sortType = 'sortTypeActionTrigger';
			}else if(thisTh.hasClass('sortTypeTextGroupSummary') ){
				sortType = 'sortTypeTextGroupSummary';
			}
			makeToolBoxSortParts(sortType, divToolBox);
		}

		//---------------------------------------------------------------------
		// 絞込み部品追加
		//---------------------------------------------------------------------
		if(filterTableFlg == true){
			var filterType = undefined;
			if(thisTh.hasClass('filterTypeText')){
				filterType = 'filterTypeText';
			}else if(thisTh.hasClass('filterTypeLicense')){
				filterType = 'filterTypeLicense';
			}else if(thisTh.hasClass('filterTypeDate')){
				filterType = 'filterTypeDate';
			}else if(thisTh.hasClass('filterTypeInformation')){
				filterType = 'filterTypeInformation';
			}else if(thisTh.hasClass('filterTypeInstanceStatus')){
				filterType = 'filterTypeInstanceStatus';
			}else if(thisTh.hasClass('filterTypeEnable')){
				filterType = 'filterTypeEnable';
			}else if(thisTh.hasClass('filterTypeMonitorStatus')){
				filterType = 'filterTypeMonitorStatus';
			}else if(thisTh.hasClass('filterTypeLicenseKey')){
				filterType = 'filterTypeLicenseKey';
			}else if(thisTh.hasClass('filterTypeActionTrigger')){
				filterType = 'filterTypeActionTrigger';
			}else if(thisTh.hasClass('filterTypeActionResult')){
				filterType = 'filterTypeActionResult';
			}else if(thisTh.hasClass('filterTypeActionTriggerLog')){
				filterType = 'filterTypeActionTriggerLog';
			}
			makeToolBoxFilterParts(filterType, divToolBox);
		}

		//---------------------------------------------------------------------
		// 一括確認部品追加
		//---------------------------------------------------------------------
		if(allConfirmedFlg == true){
			makeToolBoxAllConfirmedParts(divToolBox);
		}

		//そのページの<body>に追加する。
		thisTh.parents('body').append(divToolBox);

		divToolBox = null;
	}
	//=========================================================================
	// 並び替え処理
	//=========================================================================
	,tableDataSort : function(paramDivToolBox, paramOrderAsc) {
		var targetTable = $(this);
		var orderAsc = (paramOrderAsc == undefined)?null:paramOrderAsc;
		//---------------------------------------------------------------------
		// パラメータチェック
		//---------------------------------------------------------------------
		if(targetTable.is('table') != true){
			targetTable = null;
			return;
		}
		if( (paramDivToolBox != undefined) && (paramDivToolBox.is('div.divToolBox') != true) ){
			targetTable = null;
			return;
		}

		var sortTrData = targetTable.children('tbody').find('tr');
		var tdSelect = 0;
		var sortType = '';
		if( (paramDivToolBox != undefined) && (paramDivToolBox.is('div.divToolBox') == true) ){
			if(paramDivToolBox.hasClass('sortTypeText')){
				sortType = 'sortTypeText';
			}else if(paramDivToolBox.hasClass('sortTypeInfomationType')){
				sortType = 'sortTypeInfomationType';
			}else if(paramDivToolBox.hasClass('sortTypeImplant')){
				sortType = 'sortTypeImplant';
			}else if(paramDivToolBox.hasClass('sortTypeDate')){
				sortType = 'sortTypeDate';
			}else if(paramDivToolBox.hasClass('sortTypeStatus')){
				sortType = 'sortTypeStatus';
			}else if(paramDivToolBox.hasClass('dataConfirm')){
				sortType = 'dataConfirm';
			}else if(paramDivToolBox.hasClass('sortTypeTextGroupSummary')){
				sortType = 'sortTypeTextGroupSummary';
			}
			tdSelect = targetTable.data('clickIndex');
		}else{
			//再並び替えを行う
			var sortData = targetTable.data('sortData');
			if(sortData == undefined){
				return;
			}
			sortType = sortData['sortType'];
			tdSelect = sortData['tdSelect'];
			orderAsc = sortData['orderAsc'];
		}
		//並び替え処理を保存する
		targetTable.data('sortData', {'sortType':sortType, 'tdSelect': tdSelect, 'orderAsc': orderAsc});

		//データ指定種別によって処理を分ける
		if(sortType == 'sortTypeText'){
			//文字比較のソート
			sortTrData.sort(function(left,right){
				var leftValue = '';
				var rightValue = '';
				if(orderAsc){
					leftValue  = $(left).children('td').eq(tdSelect).text().toUpperCase();
					rightValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
				}else{
					leftValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
					rightValue = $(left).children('td').eq(tdSelect).text().toUpperCase();
				}
				//2つの文字が同じ長さだった場合
				var leftValueLength = leftValue.length;
				var rightValueLength = rightValue.length;
				if(leftValueLength == rightValueLength){
					var val = 0;
					for(var i=0;i<leftValueLength;i++){
						val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
						if(val != 0){
							return val;
						}
					}
					//ループが最後まで処理されたらすべての文字が同一
					val = 0;
					return val;
				}
				var val = 0;
				var shortStringLength = Math.min(leftValueLength,rightValueLength);
				var shortStringName = '';
				//短い文字列の数を入れる
				if(leftValueLength<rightValueLength){
					shortStringName = 'left';
				}else{
					shortStringName = 'right';
				}

				for(var i=0;i<shortStringLength;i++){
					val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
					if(val != 0){
						return val;
					}
				}
				//ループが最後まで処理されたらすべての文字が同一
				if(shortStringName=='left'){
					val = 1;
				}
				else{
					val = -1;
				}
				return val;
			});
		}else if(sortType == 'sortTypeInfomationType'){
			//データタイプ比較のソート
			sortTrData.sort(function(left,right){
				var leftValue = '';
				var rightValue = '';
				if(orderAsc){
					leftValue  = $(left).children('td').eq(tdSelect).text().toUpperCase();
					rightValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
				}else{
					leftValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
					rightValue = $(left).children('td').eq(tdSelect).text().toUpperCase();
				}
				//2つの文字が同じ長さだった場合
				var leftValueLength = leftValue.length;
				var rightValueLength = rightValue.length;
				if(leftValueLength == rightValueLength){
					var val = 0;
					for(var i=0;i<leftValueLength;i++){
						val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
						if(val != 0){
							return val;
						}
					}
					//ループが最後まで処理されたらすべての文字が同一
					val = 0;
					return val;
				}
				var val = 0;
				var shortStringLength = Math.min(leftValueLength,rightValueLength);
				var shortStringName = '';
				//短い文字列の数を入れる
				if(leftValueLength<rightValueLength){
					shortStringName = 'left';
				}else{
					shortStringName = 'right';
				}

				for(var i=0;i<shortStringLength;i++){
					val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
					if(val != 0){
						return val;
					}
				}
				//ループが最後まで処理されたらすべての文字が同一
				if(shortStringName=='left'){
					val = 1;
				}
				else{
					val = -1;
				}
				return val;
			});
		}else if(sortType == 'sortTypeImplant'){
			sortTrData.sort(function(left,right){
				var leftValue  = 0;
				var rightValue = 0;
				if(orderAsc){
					leftValue  = $(left).children('td').eq(tdSelect).find('[name=sortdata]').val();
					rightValue = $(right).children('td').eq(tdSelect).find('[name=sortdata]').val();
				}else{
					leftValue  = $(right).children('td').eq(tdSelect).find('[name=sortdata]').val();
					rightValue = $(left).children('td').eq(tdSelect).find('[name=sortdata]').val();
				}

				return (Number(leftValue)-Number(rightValue));
			});
		}else if(sortType == 'sortTypeDate'){
			//日付比較のソート
			sortTrData.sort(function(left,right){
				var leftValue = '';
				var rightValue = '';
				if(orderAsc){
					leftValue  = (new Date($(left).children('td').eq(tdSelect).find('input[name=date]').val())).getTime();
					rightValue = (new Date($(right).children('td').eq(tdSelect).find('input[name=date]').val())).getTime();
				}else{
					leftValue = (new Date($(right).children('td').eq(tdSelect).find('input[name=date]').val())).getTime();
					rightValue = (new Date($(left).children('td').eq(tdSelect).find('input[name=date]').val())).getTime();
				}
				if(isNaN(leftValue)){
					leftValue = 0;
				}
				if(isNaN(rightValue)){
					rightValue = 0;
				}
				return leftValue - rightValue;
			});
		}else if(sortType == 'sortTypeStatus'){
			//ステータスのソート
			sortTrData.sort(function(left,right){
				var leftValue = 0;
				var rightValue = 0;
				if(orderAsc){
					leftValue  = $(left).children('td').eq(tdSelect).find('[name=sortdata]').val();
					rightValue = $(right).children('td').eq(tdSelect).find('[name=sortdata]').val();
				}else{
					leftValue  = $(right).children('td').eq(tdSelect).find('[name=sortdata]').val();
					rightValue = $(left).children('td').eq(tdSelect).find('[name=sortdata]').val();
				}

				return (Number(leftValue)-Number(rightValue));
			});
		}else if(sortType == 'dataConfirm'){
			//チェックボックスのソート
			sortTrData.sort(function(left,right){
				var tempFirst = 0;
				var tempSecond = 0;
				var leftValue = 0;
				var rightValue = 0;

				if($(left).children('td').eq(tdSelect).find('input').is(':checked') == true){
					tempFirst = 1;
				}
				if($(right).children('td').eq(tdSelect).find('input').is(':checked') == true){
					tempSecond = 1;
				}

				if(orderAsc){
					leftValue = tempFirst;
					rightValue = tempSecond;
				}else{
					leftValue = tempSecond;
					rightValue = tempFirst;
				}
				return leftValue - rightValue;
			});
		}else if(sortType == 'sortTypeTextGroupSummary'){
				//グループデータ取得
				var sortTrDataGrp = getGrpInsFromTrData(sortTrData, true);
				//インスタンスデータ取得
				var sortTrDataIns = getGrpInsFromTrData(sortTrData, false);
				//グループデータ：文字比較のソート
				sortTrDataGrp.sort(function(left,right){
					var leftValue = '';
					var rightValue = '';
					if(orderAsc){
						leftValue  = $(left).children('td').eq(tdSelect).text().toUpperCase();
						rightValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
					}else{
						leftValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
						rightValue = $(left).children('td').eq(tdSelect).text().toUpperCase();
					}
					//2つの文字が同じ長さだった場合
					var leftValueLength = leftValue.length;
					var rightValueLength = rightValue.length;
					if(leftValueLength == rightValueLength){
						var val = 0;
						for(var i=0;i<leftValueLength;i++){
							val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
							if(val != 0){
								return val;
							}
						}
						//ループが最後まで処理されたらすべての文字が同一
						val = 0;
						return val;
					}
					var val = 0;
					var shortStringLength = Math.min(leftValueLength,rightValueLength);
					var shortStringName = '';
					//短い文字列の数を入れる
					if(leftValueLength<rightValueLength){
						shortStringName = 'left';
					}else{
						shortStringName = 'right';
					}

					for(var i=0;i<shortStringLength;i++){
						val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
						if(val != 0){
							return val;
						}
					}
					//ループが最後まで処理されたらすべての文字が同一
					if(shortStringName=='left'){
						val = 1;
					}
					else{
						val = -1;
					}
					return val;
				});

				//インスタンスデータ：文字比較のソート
				sortTrDataIns.sort(function(left,right){
					var leftValue = '';
					var rightValue = '';
					if(orderAsc){
						leftValue  = $(left).children('td').eq(tdSelect).text().toUpperCase();
						rightValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
					}else{
						leftValue = $(right).children('td').eq(tdSelect).text().toUpperCase();
						rightValue = $(left).children('td').eq(tdSelect).text().toUpperCase();
					}
					//2つの文字が同じ長さだった場合
					var leftValueLength = leftValue.length;
					var rightValueLength = rightValue.length;
					if(leftValueLength == rightValueLength){
						var val = 0;
						for(var i=0;i<leftValueLength;i++){
							val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
							if(val != 0){
								return val;
							}
						}
						//ループが最後まで処理されたらすべての文字が同一
						val = 0;
						return val;
					}
					var val = 0;
					var shortStringLength = Math.min(leftValueLength,rightValueLength);
					var shortStringName = '';
					//短い文字列の数を入れる
					if(leftValueLength<rightValueLength){
						shortStringName = 'left';
					}else{
						shortStringName = 'right';
					}

					for(var i=0;i<shortStringLength;i++){
						val = leftValue.charCodeAt(i) - rightValue.charCodeAt(i);
						if(val != 0){
							return val;
						}
					}
					//ループが最後まで処理されたらすべての文字が同一
					if(shortStringName=='left'){
						val = 1;
					}
					else{
						val = -1;
					}
					return val;
				});
				//ソート後のグループデータ、インスタンスデータデータのマージ
				if( orderAsc ){
					sortTrData = $.merge(sortTrDataGrp, sortTrDataIns);
				}else{
					sortTrData = $.merge(sortTrDataIns, sortTrDataGrp);
				}
				sortTrDataGrp = null;
				sortTrDataIns = null;
		}else{
			alert('想定外データ');
			return false;
		}

		//並び替えた結果を反映する
		targetTable.children('tbody').append(sortTrData);

		targetTable = null;
	}
	//=========================================================================
	// 絞込み処理
	//=========================================================================
	,tableDataFilter : function(paramDivToolBox, filterOnOff) {
		var targetTableBody = $(this).children('tbody');
		var targetIndex = paramDivToolBox.data('clickIndex');
		var targetTdWidthArray = [];
		var widthSetTr = undefined;

		//絞込み前に一度全表示にする
		targetTableBody.children('tr').css('display', 'table-row');
		if(filterOnOff == false){
			return;
		}

		//---------------------------------------------------------------------
		// テーブル幅を取得する
		//---------------------------------------------------------------------
		targetTableBody.children('tr:first').children().each(function(i){
			targetTdWidthArray[i] = $(this).width();
		});

		//---------------------------------------------------------------------
		// 対象条件に該当しない行を非表示にしていく
		//---------------------------------------------------------------------
		if( paramDivToolBox.hasClass('filterTypeText')){
			//テキストデータの絞込み
			var searchText = paramDivToolBox.find('input[name=filterText]').val();
			var tableSizeSetFlg = false;
			targetTableBody.children('tr').each(function(){
				var targetData = $(this).children('td').eq(targetIndex).text();
				//文字列を検索して、見つからなければ非表示にする
				if(targetData.indexOf(searchText) == -1){
					$(this).css('display', 'none');
				}else{
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
				}
			});
		}else if(paramDivToolBox.hasClass('filterTypeActionTrigger')){
			//アクション条件の絞込み
			var searchVal = 0;
			if(paramDivToolBox.find('input[name=disconnectComputer]').is(':checked')){
				searchVal += 64;
			}
			if(paramDivToolBox.find('input[name=disconnectHelper]').is(':checked')){
				searchVal += 32;
			}
			if(paramDivToolBox.find('input[name=disconnectAgent]').is(':checked')){
				searchVal += 16;
			}
			if(paramDivToolBox.find('input[name=failure]').is(':checked')){
				searchVal += 8;
			}
			if(paramDivToolBox.find('input[name=danger]').is(':checked')){
				searchVal += 4;
			}
			if(paramDivToolBox.find('input[name=warning]').is(':checked')){
				searchVal += 2;
			}
			if(paramDivToolBox.find('input[name=normal]').is(':checked')){
				searchVal += 1;
			}

			var tableSizeSetFlg = false;
			targetTableBody.children('tr').each(function(){
				var targetData = $(this).children('td').eq(targetIndex).find('input[name=sortdata]').val();
				var localSearchVal = searchVal;
				if( (localSearchVal>=64)&&(targetData>=64) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 64;
				targetData = targetData % 64;

				if( (localSearchVal>=32)&&(targetData>=32) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 32;
				targetData = targetData % 32;

				if( (localSearchVal>=16)&&(targetData>=16) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 16;
				targetData = targetData % 16;

				if( (localSearchVal>=8)&&(targetData>=8) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 8;
				targetData = targetData % 8;

				if( (localSearchVal>=4)&&(targetData>=4) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 4;
				targetData = targetData % 4;

				if( (localSearchVal>=2)&&(targetData>=2) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}
				localSearchVal = localSearchVal % 2;
				targetData = targetData % 2;

				if( (localSearchVal>=1)&&(targetData>=1) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
					return;
				}

				//見つからなかったので非表示にする
				$(this).css('display', 'none');
			});
		}else if(paramDivToolBox.hasClass('filterTypeDate')){
			//日付データの絞込み
			var nowDate = (new Date()).getTime();
			var startDate = (new Date(paramDivToolBox.find('input[name=filterDateBefore]').val())).getTime();
			var endDate = (new Date(paramDivToolBox.find('input[name=filterDate]').val())).getTime();

			//入力データが何もない場合には処理をしない
			if( (isNaN(startDate)) && (isNaN(endDate)) ){
				return;
			}

			//片方のみ入力がない場合の値を入れる
			if(isNaN(startDate)){
				//表示中の項目で一番昔の時間を入れる
				var minDate = nowDate;
				targetTableBody.find('input[name=date]').each(function(){
					var temp = (new Date($(this).val()).getTime());
					minDate = temp<minDate? temp:minDate;
				});
				startDate = minDate;
			}
			if(isNaN(endDate)){
				//今の時間を入れる
				endDate = nowDate;
			}

			var tableSizeSetFlg = false;
			targetTableBody.children('tr').each(function(){
				var targetData = (new Date($(this).children('td').eq(targetIndex).find('input[name=date]').val())).getTime();
				//まず、時刻データでなければ表示対象外
				if(isNaN(targetData)){
					$(this).css('display', 'none');
				}

				//対象データが絞り込みの範囲内になければ非表示にする
				if( (startDate <= targetData) && (targetData <= endDate) ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
				}else{
					$(this).css('display', 'none');
				}
			});
		}else if((paramDivToolBox.hasClass('filterTypeMonitorStatus')) || (paramDivToolBox.hasClass('filterTypeEnable'))){
			//インスタンス内ステータスデータの絞込みと有効無効データの絞込み
			var searchData = [];
			var checkedData = paramDivToolBox.find(':checked');
			for(var i=0; i<checkedData.length; i++){
				if( checkedData.eq(i).val() != '' ){
					searchData.push(checkedData.eq(i).val());
				}
			}
			checkedData = null;

			//入力データが何もない場合には処理をしない
			if( searchData.length <= 0 ){
				return;
			}

			var tableSizeSetFlg = false;
			targetTableBody.children('tr').each(function(){
				var targetData = $(this).children('td').eq(targetIndex).text();
				var visibleFlag = false;

				//or条件検索のため、一件でもヒットしたら、表示対象とする
				for(var i=0; i<searchData.length; i++){
					if( searchData[i] == targetData ){
						visibleFlag = true;
						break;
					}
				}
				//対象データが絞り込みの範囲内になければ非表示にする
				if( visibleFlag ){
					//ヒットした1行だけテーブルサイズ設定行とする
					if(tableSizeSetFlg == false){
						tableSizeSetFlg = true;
						widthSetTr = $(this);
					}
				}else{
					$(this).css('display', 'none');
				}
			});
		}else if(paramDivToolBox.hasClass('filterTypeLicenseKey')){
			// ライセンスチェック処理の場合は、licenseCheckVieweer.jsでデータの絞込み
			// を行なっているので、ここでは行わない
			return;
		}

		if(widthSetTr != undefined){
			//テーブルサイズを設定する
			widthSetTr.children().each(function(i){
				$(this).width(targetTdWidthArray[i]);
			});
		}

		targetTableBody = null;
		targetIndex = null;
		targetTdWidthArray = null;
		widthSetTr = null;
	}
	// シンプルなタブコントロール
	,simpleTabs : function(options) {
		return this.each(function(index) {
			var tabController = $(this);

			tabController.children('ul:first').children('li').click(function () {
				tabController.children('div').css('visibility', 'hidden');
				tabController.children('ul:first').children('li').addClass('simpleTabsUnselected');
				tabController.children('ul:first').children('li').removeClass('simpleTabsSelected');
				$($(this).children('a').parent()).addClass('simpleTabsSelected');
				$($(this).children('a').parent()).removeClass('simpleTabsUnselected');
				$($(this).children('a').attr('href')).css('visibility', 'visible');
			});

			if (options['tabIndex'] == undefined) {
				tabController.children('ul:first').children('li:first').click();
			} else {
				tabController.children('ul:first').children('li:eq(' + options['tabIndex'] + ')').click();
			}
		});
	},
	//=========================================================================
	// 処理中画面表示
	//=========================================================================
	viewLoadingScreen: function(timeoutSec){
		//---------------------------------------------------------------------
		// 呼び出したオブジェクトのボディーに読み込み画面を表示する
		//---------------------------------------------------------------------
		var thisBody = $(this);
		var divBackground = $('<div>').attr('id', 'nowLoadingBackground').addClass('nowLoadingBackground');
		var divBox = $('<div>').attr('id', 'nowLoading').addClass('nowLoading');
		var span = $('<span>').addClass('loadingText').append('データ取得中');
		divBox.append(span);
		//ボディーに挿入
		thisBody.append(divBackground).append(divBox);

		//オートリフレッシュタイマーを初期化する
		$('#autoRefreshIntervalCount').val(0);

		thisBody = null;
		divBackground = null;
		divBox = null;
		span = null;
	},
	//=========================================================================
	// 処理中画面消去
	//=========================================================================
	deleteLoadingScreen: function(timeoutSec){
		//---------------------------------------------------------------------
		// 呼び出したオブジェクトのボディーに読み込み画面を表示する
		//---------------------------------------------------------------------
		//ローディング表示を消す
	    $('#nowLoading,#nowLoadingBackground').remove();
	}
});

function onJQueryAjaxFailure (event, jqXHR, ajaxSettings, thrownError) {
	//タイムアウトの場合、各ページのタイムアウト処理を行う
	if(thrownError == 'timeout'){
		window.ajaxTimeout();
	}else{
		//サーバーからのエラーメッセージがある場合とjQueryライブラリ内で例外が設定されている場合には、
		//ログイン画面に背にする
		if( (jqXHR.responseText != '') || ( thrownError != '' ) ){
			onAjaxFailure(jqXHR, ajaxSettings);
		}
	}
}

function onAjaxFailure (e, ajaxComponent) {
	var responseText = $(e.responseText);
	var errorText = responseText.filter('pre:last').text();
	if (errorText != undefined) {
		var indexOfLF = errorText.indexOf('\t');
		if (indexOfLF < 0) {
			errorText.indexOf('\n');
		}
		if (indexOfLF > 0) {
			errorText = errorText.substring(0, indexOfLF);
		}
	}
	if (errorText == undefined) {
		errorText = e.statusText;
	}
	responseText = null;

	top.location = '/Indicator/view/login.html?outlineMessageText=' + errorText;
}

$(document).ready(function() {
	//ボタンを綺麗にする処理
	$('div.dialogButtons').children('button')
								.button()
							.end()
							.children('input[type=submit]')
								.button()
							.end()
							.children('input[type=button]')
								.button()
							.end()
							.children('input[type=reset]')
								.button();
	//ボタンを綺麗にする処理
	$('div.buttons').children('button')
						.button()
					.end()
					.children('input[type=submit]')
						.button()
					.end()
					.children('input[type=button]')
						.button()
					.end()
					.children('input[type=reset]')
						.button();

	//ボタンを綺麗にする処理
	$('span.buttons').children('button')
						.button()
					.end()
					.children('input[type=submit]')
						.button()
					.end()
					.children('input[type=button]')
						.button()
					.end()
					.children('input[type=reset]')
						.button();

	$('input[type=text].datepicker').datepicker({
		dateFormat:			'yy/mm/dd',
		showMonthAfterYear:	true,
		dayNamesMin:		['日', '月', '火', '水', '木', '金', '土'],
		dayNamesShort:		['日曜', '月曜', '火曜', '水曜', '木曜', '金曜', '土曜'],
		dayNames:			['日曜日', '月曜日', '火曜日', '水曜日', '木曜日', '金曜日', '土曜日'],
		monthNamesShort:	['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12'],
		monthNames:			['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
		yearSuffix:			'年'
	});

	//=========================================================================
	// ダイアログ関連の処理
	//=========================================================================
	//-------------------------------------------------------------------------
	// ダイアログ画面表示を変更
	//-------------------------------------------------------------------------
	var height = $('body').height()-$('.dialogButtons').outerHeight(false);
	$('div.dialogBody').css('height', height);
	//-------------------------------------------------------------------------
	// 閉じるボタンでダイアログを閉じる処理
	//-------------------------------------------------------------------------
	$(document).on('click', '#closeDialog', function(){
		window.parent.$('#indicatorDialog').dialog('close');
	});

	//=========================================================================
	// ｊQuery Ajax関連の処理
	//=========================================================================
	$.ajaxSetup( {
		cache  : true,
		timeout: 1800 * 1000} );
	$('body').ajaxError(onJQueryAjaxFailure);

	//-----------------------------------------------------------------
	// 画面をクリックした時の処理
	// 無操作系のタイマーをリセットする
	//-----------------------------------------------------------------
	$('body').on('mousedown', function(e){
		//自動実行タイマーのリセット
		if( top.window.autoExecTimerReset != undefined ){
			top.window.autoExecTimerReset();
		}
	});

	//-----------------------------------------------------------------
	// エラー文言の装飾処理
	//-----------------------------------------------------------------
	if($.trim($('#allMessages').text()) != ''){
		//ログイン画面以外の時に装飾を行う
		if( $('#allMessages').parents('#systemMessage').length == 0 ){
			$('#allMessages').wrap('<div></div>');
			$('#allMessages').parent('div').width($('table.dialogTable').width());
			$('#allMessages').parent('div').css('margin-left', $('table.dialogTable').css('margin-left'));
		}
	}
});

//=============================================================================
// ダイアログ関連処理
//=============================================================================
//-----------------------------------------------------------------------------
// 入力ダイアログ表示処理
//-----------------------------------------------------------------------------
function showInputDialog (title, message, defaultValue, closeFunction, width, height, resizable) {
	var localWidth = (width==undefined) ? 320 : width;
	var localHeight = (height==undefined) ? 190 : height;
	var localDefaultValue = (defaultValue==undefined) ? '' : defaultValue;
	var localCloseFunction = (closeFunction==undefined) ? function(){/* 空 */} : closeFunction;

	//ダイアログを表示する前に他のダイアログは要素毎削除する
	$('#indicatorInputDialog').remove();
	$('#indicatorInputDialog').removeData('retFunc');

	//新しいダイアログを作成する
	var dlg = $('<div id="indicatorInputDialog"></div>');
	var buttonResult = $('<input type="hidden" name="buttonResult" value="false" />');
	var messageText = $('<div id="indicatorInputDialogMessage"></div>').get(0).innerText = message;
	var inputText = $('<div id="indicatorInputDialogInputText"><input type="text" name="inputData" /></div>');
	var buttons = $('<div class="inputDialogButtons"><input type="button" name="okButton" tabindex="0" value="OK"/><input type="button" name="okButton" value="キャンセル"/></div>');
	inputText.find('input[name=inputData]').val(localDefaultValue);
	dlg.append(buttonResult).append(messageText).append(inputText).append(buttons);
	dlg.dialog({
		draggable: false,
		modal: true,
		dialogClass: 'dialog',
		width: localWidth,
		height: localHeight,
		position: 'center',
		resizable: false,
		show: 'blind',
		open: function(){
			//初期フォーカスをOKボタンに合わせる
			$('input[name=okButton][value=OK]').focus();
		},
		beforeClose: function(){
			var param = $('#indicatorInputDialog').data('retFunc');
			var retFunc = true;
			param = param==undefined?'':param;
			retFunc = localCloseFunction(param);
			return retFunc;
		},
		title: title,
	});
	$('#indicatorInputDialog').on('click', 'input[type=button]', function(){
		if($(this).val() == 'OK'){
			$('#indicatorInputDialog').data('retFunc', $('input[name=inputData]').val());
		}if($(this).val() == 'キャンセル'){
			$('#indicatorInputDialog').data('retFunc', '');
		}
		$('#indicatorInputDialog').dialog('close');
	});
	//ボタンを綺麗にする処理
	$('#indicatorInputDialog').find('input[type=button]').button();

	dlg = null;
	buttonResult = null;
	messageText = null;
	inputText = null;
	buttons = null;
}

function execGC(){
	//IEの場合、ガベージコレクションを行う
	if( (navigator.userAgent.search(/MSIE\s[89]\.\d/) != -1) ||
		(navigator.userAgent.search(/MSIE\s10\.\d/) != -1)){
		CollectGarbage();
	}
}

//=========================================================================
// グループデータとインスタンスデータの分解処理
// trData :グループサマリデータ、グループ、インスタンスデータ混在
// isGetGrp： true グループデータ取得、false グループ以外データ取得
//=========================================================================
function getGrpInsFromTrData(trData, isGetGrp){
	var resultData = new Array();
	var dataCount = 0;
	// グループデータとインスタンスデータに対してループ
	for(var i=0;i<trData.length;i++){
		// currentTypeを取得
		var dataType = $(trData[i]).find('[name=currentType]').val();
		//グループデータ取得
		if( isGetGrp ){
			if( dataType == 'GROUP' ){
				resultData[dataCount]=trData[i];
				dataCount = dataCount + 1;
			}
		//インスタンスデータ取得
		}else{
			if( dataType != 'GROUP' ){
				resultData[dataCount]=trData[i];
				dataCount = dataCount + 1;
			}
		}
	}
	return resultData;
}
