//*****************************************************************************
// Copyright (C) 2013-2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objgroupSummary = {};

$(document).ready(function(){
	//他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined){
		window.parent.tabPageClear();
	}

	//=========================================================================
	// プロパティ
	//=========================================================================
	objgroupSummary.groupId = $('#groupId').val();
	objgroupSummary.permission = ($(top.document).find('#permissionWrite').val()!=undefined)? $(top.document).find('#permissionWrite').val(): 'false';
	objgroupSummary.objectMapList = [];
	objgroupSummary.iconImgSrcTable = {
			'confirmed': '../../images/confirm32.png',
			'invisible': '../../images/invisible32.png'
	};

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// 子要素の取得要求
	//-------------------------------------------------------------------------
	objgroupSummary.ajaxChildObjectsRequest = function(){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : this.groupId};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupSummaryAction_ajaxChildObjects, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsGroup_groupSummaryAction', 'action' : 'ajaxChildObjects', 'AjaxParam0' : objgroupSummary.groupId}, detailsGroup_groupSummaryAction_ajaxChildObjects, 'json');
	};

	//-------------------------------------------------------------------------
	// 子要素の取得応答
	//-------------------------------------------------------------------------
	objgroupSummary.ajaxChildObjectsResponse = function( objectMapList ){
		try{
			if(objectMapList.length<=0) throw 'noItem';

			delete objgroupSummary.objectMapList;
			objgroupSummary.objectMapList = [];
			for (i in objectMapList) {
				objgroupSummary.objectMapList[i] = objectMapList[i];
				//ステータスの設定
				if(!('normal' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['normal'] = 0;
				}
				if(!('warning' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['warning'] = 0;
				}
				if(!('danger' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['danger'] = 0;
				}
				if(!('failure' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['failure'] = 0;
				}
				if(!('disconnectAgent' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['disconnectAgent'] = 'false';
				}
				if(!('disconnectHelper' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['disconnectHelper'] = 'false';
				}
				if(!('disconnectComputer' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['disconnectComputer'] = 'false';
				}
				if(!('statusConfirmed' in objgroupSummary.objectMapList[i])){
					objgroupSummary.objectMapList[i]['statusConfirmed'] = 'false';
				}
			}
		}catch(e){
			if(e == 'noItem'){
				delete objgroupSummary.objectMapList;
				objgroupSummary.objectMapList = [];
			}
		}
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objgroupSummary.pageUpdate = function(){
		try{
			var tableBody = $('#groupSummaryTable').children('tbody');
			var iconHashTable = {'GROUP':'folderClosed32',
					'BOM5WINDOWS':'bom5Windows32',
					'BOM5LINUX':'bom5Linux32',
					'BOM5VMWARE':'bom5Vmware32',
					'BOM6WINDOWS':'bom6Windows32',
					'BOM6LINUX':'bom6Linux32',
					'BOM6VMWARE':'bom6Vmware32',
					'BOM7WINDOWS':'bom7Windows32',
					'BOM7LINUX':'bom7Linux32',
					'BOM7VMWARE':'bom7Vmware32',
					'BOM8WINDOWS':'bom8Windows32',
					'BOM8LINUX':'bom8Linux32',
					'BOM8VMWARE':'bom8Vmware32'};

			var statusIconAltHashTable = {'disconnectComputer':'コンピューター接続エラー',
					'disconnectHelper':'ヘルパーサービス接続エラー',
					'disconnectAgent':'監視サービス停止中',
					'failure':'失敗',
					'danger':'危険',
					'warning':'注意',
					'normal':'正常',
					'invisible':''};
			var thisPermissionData = objgroupSummary.permission;

			tableBody.empty();

			//受信データがない場合には中身をクリアする
			if(objgroupSummary.objectMapList.length<=0){
				return;
			}

			//全アイテム分処理をする
			for(i in objgroupSummary.objectMapList){
				var thisObjectMap = objgroupSummary.objectMapList[i];

				//tr
				var tr = $('<tr>');

				//td
				//編集
				tr.append(function(){
					var td = $('<td>').addClass('groupSummaryEditStyle');
					var p = $('<p>');
					var inputEditObject = $('<input type="button" name="editObject" value="編集">').addClass('smallSizeButton').button();
					//書き込み権限がない場合に要素を無効化する
					if(thisPermissionData != 'true'){
						inputEditObject.attr('disabled', 'disabled').addClass('disabledTextColor').addClass('cursorNormal');
					}
					p.append(inputEditObject);
					td.append(p);
					return td;
				});

				//表示名
				tr.append(function(){
					var td = $('<td>').addClass('groupSummaryNameStyle');
					var p = $('<p>').addClass('objectLink').css('verticcal-align', 'text-bottom');
					var img = $('<img>').attr('src', objgroupSummary.iconImgSrcTable['invisible']).addClass(iconHashTable[thisObjectMap['type']]);
					var inputCurrentType = $('<input type="hidden" name="currentType">').attr('value', thisObjectMap['type']);
					var inputCurrentId = $('<input type="hidden" name="currentId">').attr('value', thisObjectMap['id']);
					var string = thisObjectMap['name'];
					p.attr('title', string).append(inputCurrentType).append(inputCurrentId).append(inputCurrentId).append(img).append(string);
					td.append(p);
					return td;
				});

				//ステータス
				tr.append(function(){
					var td = $('<td>').addClass('groupSummaryStatusStyle');
					var p = $('<p>');
					var statusConfirmed = (thisObjectMap['statusConfirmed']=='true')?'true':'false';
					var srcString = '';
					var titleString = '';
					var className = '';
					var implantData = 0;
					//コンピューター接続エラー
					if( ('disconnectComputer' in thisObjectMap) && ( thisObjectMap['disconnectComputer'] == 'true' ) ){
						className = 'instanseStateDisconnectComputer32';
						titleString = statusIconAltHashTable['disconnectComputer'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 64;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgDisconnectComputer = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//ヘルパーサービス接続エラー
					if( ('disconnectHelper' in thisObjectMap) && ( thisObjectMap['disconnectHelper'] == 'true' ) ){
						className = 'instanseStateDisconnectHelper32';
						titleString = statusIconAltHashTable['disconnectHelper'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 32;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgDisconnectHelper = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//監視サービス停止中
					if( ('disconnectAgent' in thisObjectMap) && ( thisObjectMap['disconnectAgent'] == 'true' ) ){
						className = 'instanseStateDisconnectAgent32';
						titleString = statusIconAltHashTable['disconnectAgent'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 16;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgDisconnectAgent = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//失敗
					if( ('failure' in thisObjectMap) && ( Number(thisObjectMap['failure']) > 0 ) ){
						className = 'instanseStateFailure32';
						titleString = statusIconAltHashTable['failure'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 8;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgFailure = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//危険
					if( ('danger' in thisObjectMap) && ( Number(thisObjectMap['danger']) > 0 ) ){
						className = 'instanseStateDanger32';
						titleString = statusIconAltHashTable['danger'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 4;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgDanger = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//注意
					if( ('warning' in thisObjectMap) && ( Number(thisObjectMap['warning']) > 0 ) ){
						className = 'instanseStateWarning32';
						titleString = statusIconAltHashTable['warning'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 2;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgWarning = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					//正常
					if( ('normal' in thisObjectMap) && ( Number(thisObjectMap['normal']) > 0 ) ){
						className = 'instanseStateSuccess32';
						titleString = statusIconAltHashTable['normal'];
						//確認マークの表示
						if(statusConfirmed == 'true'){
							srcString = objgroupSummary.iconImgSrcTable['confirmed'];
						}else{
							srcString = objgroupSummary.iconImgSrcTable['invisible'];
						}
						implantData += 1;
					}else{
						className = '';
						srcString = objgroupSummary.iconImgSrcTable['invisible'];
						titleString = '';
					}
					var imgNormal = $('<img>').attr('src', srcString).attr('title', titleString).addClass(className);

					var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', implantData);
					var inputStatusConfirmed = $('<input type="hidden" name="statusConfirmed">').attr('value', statusConfirmed);
					p.append(imgDisconnectComputer).append(imgDisconnectHelper).append(imgDisconnectAgent).append(imgFailure).append(imgDanger).append(imgWarning).append(imgNormal).append(inputSortdata).append(inputStatusConfirmed);
					td.append(p);
					return td;
				});

				//前回実行時刻
				tr.append(function(){
					var td = $('<td>').addClass('groupSummaryLastDateStyle');
					var p = $('<p>');
					var string = '';
					if('lastExecuteDate' in thisObjectMap){
						string = (new String(thisObjectMap['lastExecuteDate'])).replace(/ /, '<br/>');
					}else{
						string = '--';
					}
					var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['lastExecuteDate']);
					p.append(string).append(input);
					td.append(p);
					return td;
				});

				//ポーリング設定
				tr.append(function(){
					var td = $('<td>').addClass('groupSummaryPollingSettingStyle');
					var p = $('<p>');
					var string = '';
					var implantData = 0;
					if(('pollingEnabled' in thisObjectMap)&&(thisObjectMap['pollingEnabled']=='true')){
						string = (thisObjectMap['pollingInterval']/60)+'分間隔';
						implantData += thisObjectMap['pollingInterval'];
					}else{
						string = '設定無効';
					}
					var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', implantData);

					p.append(string).append(inputSortdata);
					td.append(p);
					return td;
				});

				tableBody.append(tr);
			}

			//テーブル要素の表示
			$('#groupSummaryTable').children('tbody')
										.css('visibility', 'visible')
									.end()
									.trigger('update');
	   	}finally{
			var divToolBox = $('#groupSummaryTable').data('divToolBox');
			if( divToolBox != undefined ){
				$('#groupSummaryTable').tableDataFilter(divToolBox, true);
			}
			if($('#groupSummaryTable').data('refresh') == true){
				$('#groupSummaryTable').tableDataSort();
				$('#groupSummaryTable').removeData('refresh');
			}
			//Loading終了
	   	    $('body').deleteLoadingScreen();
		};
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	//グループサマリー情報取得要求
	objgroupSummary.ajaxChildObjectsRequest();

   //テーブル機能の拡張を行う
	$('#groupSummaryTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupSummaryTable').on('click', '.objectLink', function(){
		var currentType = $(this).find('[name=currentType]').val();
		var currentId = $(this).find('[name=currentId]').val();

		//ページ移動
		if(currentType == 'GROUP'){
			$('#mainDetails', top.document).attr('src', 'detailsGroup/detailsGroup.html?groupId=' + currentId);
		}else{
			$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + currentId);
		}
	});
	//-------------------------------------------------------------------------
	//「編集」ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupSummaryTable').on('click', 'input:button[name="editObject"]', function(e){
		var thisTr = $(e.target).parents('tr');
		var currentType = thisTr.find('input[name="currentType"]').val();
		var currentId = thisTr.find('input[name="currentId"]').val();

		if(currentType=='GROUP'){
			//グループ編集ダイアログを表示する
			top.showDialog('group/groupView.html?edited=false&groupId=' + currentId, 'グループの編集');
		}else{
			//インスタンス編集ダイアログを表示する
			top.showDialog('instance/instanceView.html?edited=false&instanceId='+currentId, 'インスタンスの編集');
		}
	});

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#groupSummaryTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#groupSummaryTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#groupSummaryTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#groupSummaryTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			$('#groupSummaryTable').tableDataFilter($(this).parents('div.divToolBox'), true);
			$('#groupSummaryTable').removeData('divToolBox');
			//絞り込みのためのツールボックス情報と、クリック位置を保存する
			var clickIndex = $(this).parents('div.divToolBox').data('clickIndex');
			$('#groupSummaryTable').data('divToolBox', $(this).parents('div.divToolBox').clone(true).data('clickIndex', clickIndex));
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#groupSummaryTable').removeData('divToolBox');
			$('#groupSummaryTable').removeData('sortData');//ソート順も解除する
			$(this).parents('div.divToolBox').remove();
			//初期表示に戻すため、サーバーにデータを再要求する
			objgroupSummary.ajaxChildObjectsRequest();
		});

	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objgroupSummary.intervalTimerId = setInterval(autoRefreshTimer, 1000);
	//インターバルタイマーを停止する
	$(window).unload(function() {
		clearInterval(objgroupSummary.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// グループサマリー情報取得応答処理
//=============================================================================
function detailsGroup_groupSummaryAction_ajaxChildObjects(objectMapList) {
	//受信データ設定
	objgroupSummary.ajaxChildObjectsResponse(objectMapList);
	//ページ表示の更新
	objgroupSummary.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//グループサマリーのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#groupSummaryTable').data('refresh', true);
	//グループサマリー情報取得要求
	objgroupSummary.ajaxChildObjectsRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#groupSummaryTable').data('refresh') == true){
		$('#groupSummaryTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objgroupSummary.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#groupSummaryTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#groupSummaryTable').data('refresh') == true){
		$('#groupSummaryTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
