//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function() {
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	// グループ名のオートコンプリート候補取得
	var ajaxParam = {};
	ajaxParam.onFailure = onAjaxFailure;
	Kumu.Ajax.executeTeedaAjax(instance_instanceEditAction_ajaxGroupAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);

	// パスワード自動補完
	var _passwordAutoComplete = function () {
		if ($('#actionType').val() == 'Update') {
			var ajaxParam = {'AjaxParam0' : $('#instanceId').val()};
			ajaxParam.onFailure = onAjaxFailure;
			Kumu.Ajax.executeTeedaAjax(instance_instanceEditAction_ajaxPasswordAutoComplete, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_TEXT);
		}
	};
	_passwordAutoComplete();
	if ($('#actionType').val() != 'Update') {
		//「確認」「戻る」ボタンのクリックを有効にする
		$('#noButtonClick').remove();
	}

	// インスタンス種別選択時のデフォルトポート変更
	$('#instanceType').change(function () {
		if ($(this).val().indexOf('BOM') == 0) {
			$('#helperPort').val('200' + $(this).val().charAt(3) + '0');
		}
	});

	// インスタンス名のオートコンプリート候補取得用
	var _instanceAutoCompleteCandidate = function () {
		$('#instanceName').autocomplete({source : []});

		if ($('#targetComputer').val().length == 0) return;
		if ($('#helperPort').val().length == 0) return;
		if ($('#password').val().length == 0) return;
		if ($('#instanceType').val().length == 0) return;

		var ajaxParam = {'AjaxParam0' : $('#targetComputer').val(), 'AjaxParam1' : $('#helperPort').val(),'AjaxParam2' : $('#password').val(),'AjaxParam3' : $('#instanceType').val()};
		ajaxParam.onFailure = onAjaxFailure;
		Kumu.Ajax.executeTeedaAjax(instance_instanceEditAction_ajaxInstanceAutoCompleteCandidate, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
	};

	// インスタンス名 オートコンプリート
	$('#instanceName').focus(_instanceAutoCompleteCandidate);
	_instanceAutoCompleteCandidate;

	// 表示名 の自動補完
	$('#targetComputer,#instanceName').blur(function () {
		if ($('#actionType').val() == 'Insert') {
			$('#displayName').val(
					($('#targetComputer').val()).replace(/\.|:/g, '')
					+ '_' + ($('#instanceName').val()).replace(/\.|:/g, '')
				);
		}
	});

	// 個別ポーリング設定のEnable/Disable連動
	$('#pollingEnableTrue,#pollingEnableFalse').change(function() {
		if ($('#pollingEnableTrue:checked').val() == 'true') {
			$('#pollingInterval').removeAttr('disabled');
		} else if ($('#pollingEnableFalse:checked').val() == 'false') {
			$('#pollingInterval').attr('disabled', 'disabled');
		}else{
			//ポーリング「グループの設定に従う」の設定の時に
			//個別ポーリング設定ありの設定のチェックがなくなってしまうことがある
			//チェックがなくなってしまう表示になるのは問題なので、設定ありのチェックを入れておく
			$('#pollingEnableTrue').attr('checked', 'checked');
		}
	});
	$('#pollingEnableTrue,#pollingEnableFalse').change();

	// グループの設定に従う /個別のポーリング設定を行う
	$('#pollingExtendTrue,#pollingExtendFalse').change(function() {
		if ($('#pollingExtendTrue:checked').val() == 'true') {
			$('#pollingEnableTrue,#pollingEnableFalse').removeAttr('disabled');
			$('#pollingEnableTrue,#pollingEnableFalse').change();
		} else if ($('#pollingExtendFalse:checked').val() == 'false') {
			$('#pollingEnableTrue,#pollingEnableFalse').attr('disabled', 'disabled');
			$('#pollingInterval').attr('disabled', 'disabled');
		}
	});
	$('#pollingExtendTrue,#pollingExtendFalse').change();

	// リセットボタンを押した時の動作
	$('div.dialogButtons input[type=reset]').on('click', function(){
		$('#instanceEditForm').get(0).reset();
		$('#pollingEnableTrue,#pollingEnableFalse').change();
		$('#pollingExtendTrue,#pollingExtendFalse').change();
		_passwordAutoComplete();
		return false;
	});

	$('#doConfirm,#jumpInstanceView').on('click', function(){
		//ボタンクリック不可状態の場合には、処理しない
		if($('#noButtonClick').length > 0){
			return false;
		}
		//画面遷移中は他のボタンを効かないようにする
		// disabledを使用するとサーバーにデータが送られ無くなってしまうため、
		// クリックイベントを無視する方向に変更する
		$('div.dialogButtons').children('input').on('click', function(){
			return false;
		});
	});
	//オートコンプリートの表示が横にずれる問題の対策
	//<body>の幅をそのwindowの幅に設定する
	$('body').width($(window).width());
});

// Ajaxコールバック関数
function instance_instanceEditAction_ajaxGroupAutoCompleteCandidate(autoCompleteCandidate) {
	if (autoCompleteCandidate.length > 0) {
		$('#groupPath').autocomplete({
			source : autoCompleteCandidate,
			delay : 50,
			minLength : 0
		});
	}
}
function instance_instanceEditAction_ajaxPasswordAutoComplete(password) {
	$('#password').val(password);
	//パスワード取得後にボタンクリックを可能にする
	$('#noButtonClick').remove();
}

function instance_instanceEditAction_ajaxInstanceAutoCompleteCandidate(autoCompleteCandidate) {
	$('#instanceName').autocomplete({
		source : autoCompleteCandidate,
		delay : 50,
		minLength : 0
	});
}


