//*****************************************************************************
// Copyright (C) 2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objRecvLogList = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined){
		window.parent.tabPageClear();
	}

	//=========================================================================
	// プロパティ
	//=========================================================================
	objRecvLogList.groupId = $('#groupId').val();
	objRecvLogList.instanceId = $('#instanceId').val();
	objRecvLogList.maxRow = ($('#maxLogRow', top.document).val()!=undefined)? $('#maxLogRow', top.document).val(): '300';
	objRecvLogList.logOffset = 0;
	objRecvLogList.objectMapList = [];
	objRecvLogList.iconImgSrcTable = {
			'invisible': '../../images/invisible32.png'
	};
	objRecvLogList.requestParams = {};

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// サマリーの取得要求
	//-------------------------------------------------------------------------
	objRecvLogList.ajaxRecvLogListRequest = function( requestData ){
		//デフォルトパラメータ
		var requestParams = {'id':	objRecvLogList.groupId,
				'iid':				objRecvLogList.instanceId,
				'maxRow':			objRecvLogList.maxRow,
				'order':			false};
		if( requestData == undefined ){
			//未定義の場合には、現在の条件のまま、要求を行う
			requestParams = objRecvLogList.requestParams;
		}else if( requestData == 'default' ){
			//nullの場合には、絞込みの条件なしで、要求を行う
			//要求パラメータの保存
			objRecvLogList.requestParams = requestParams;
		}else{
			var requestType = {'タイプ':'filterTypeList','件名':'filterSubject', '未来時間表示送信日時過去時間表示':'filterDate', '送信元':'filterSendFrom', '本文':'filterMsgBody'};
			//設定のあった項目だけ上書きする
			if(requestType[requestData['filter']] == 'filterName'){
				requestParams['filterName'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterDate'){
				var timeStringBefore = requestData['data'].find(':text[name=filterDateBefore]').val();
				var temp = (Date.parse(timeStringBefore)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['beginDate'] = temp;
				}

				var timeString = requestData['data'].find(':text[name=filterDate]').val();
				var temp = (Date.parse(timeString)/1000).toFixed();
				//要エラーチェック
				if(isNaN(temp)==false){
					requestParams['endDate'] = temp;
				}
			}else if(requestType[requestData['filter']] == 'filterTypeList'){
				requestParams['filterTypeList'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterSubject'){
				requestParams['filterSubject'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterSendFrom'){
				requestParams['filterSendFrom'] = requestData['data'].find(':text').val();
			}else if(requestType[requestData['filter']] == 'filterMsgBody'){
				requestParams['filterMsgBody'] = requestData['data'].find(':text').val();
			}else{
				requestParams['NoSetFilter'] = 'yes';
			}
			//要求パラメータの保存
			objRecvLogList.requestParams = requestParams;
		}

		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceRecvLogAction', 'action' : 'ajaxRecvLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsInstance_instanceRecvLogAction_ajaxRecvLogList, 'json');
	};

	//-------------------------------------------------------------------------
	// サマリーの取得応答
	//-------------------------------------------------------------------------
	objRecvLogList.ajaxRecvLogListResponse = function(objectMapList){
		try{
			//次ページが存在しない場合には、過去時間表示のボタンを消す
			if(objectMapList.length<parseInt(objRecvLogList.maxRow)){
			    $('#iconGoPastPage').hide();
			}else{
			    $('#iconGoPastPage').show();
			}
			if(objectMapList.length<=0) throw 'noItem';
			delete objRecvLogList.objectMapList;
			objRecvLogList.objectMapList = [];
			for (i in objectMapList) {
				objRecvLogList.objectMapList[i] = objectMapList[i];
			}
		}catch(e){
			if(e == 'noItem'){
				delete objRecvLogList.objectMapList;
				objRecvLogList.objectMapList = [];
			}
		}
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objRecvLogList.pageUpdate = function(){
		try{
			var tableBody = $('#recvLogTable').children('tbody');

			objRecvLogList.statusIconHashTable = {1:'logRecvTypeMail32'};

			//受信データがない場合には中身をクリアする
			if(objRecvLogList.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//タイプ
			var tdTypeArray = [];
			for(i in objRecvLogList.objectMapList){
				var thisObjectMap = objRecvLogList.objectMapList[i];
				var td = $('<td>').addClass('recvLogTypeStyle');
				var p = $('<p>').attr('title', thisObjectMap['dispName']);
				var imgLogType = $('<img>').attr('src', objRecvLogList.iconImgSrcTable['invisible']).addClass(objRecvLogList.statusIconHashTable[thisObjectMap['logType']]);
				var string = thisObjectMap['dispName'];
				p.append(imgLogType).append(string);
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', thisObjectMap['logType']);
				td.append(p).append(inputSortdata);
				tdTypeArray.push(td);
			}

			//件名
			var tdSubjectArray = [];
			for(i in objRecvLogList.objectMapList){
				var thisObjectMap = objRecvLogList.objectMapList[i];
				var td = $('<td>').addClass('recvLogSubjectStyle');
				var p = $('<p>');
				var string = thisObjectMap['subject'];
				p.append(string);
				td.append(p);
				tdSubjectArray.push(td);
			}

			//日時
			var tdDateArray = [];
			for(i in objRecvLogList.objectMapList){
				var thisObjectMap = objRecvLogList.objectMapList[i];
				var td = $('<td>').addClass('recvLogDateStyle');
				var p = $('<p>');
				var string = (new String(thisObjectMap['date'])).replace(/ /, '<br/>');
				var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['date']);
				p.append(string).append(input);
				td.append(p);
				tdDateArray.push(td);
			}

			//送信元
			var tdSendFromArray = [];
			for(i in objRecvLogList.objectMapList){
				var thisObjectMap = objRecvLogList.objectMapList[i];
				var td = $('<td>').addClass('recvLogSendFromStyle');
				var p = $('<p>');
				var string = thisObjectMap['sendFrom'];
				p.append(string);
				td.append(p);
				tdSendFromArray.push(td);
			}

			//本文
			var tdMsgBodyArray = [];
			for(i in objRecvLogList.objectMapList){
				var thisObjectMap = objRecvLogList.objectMapList[i];
				var td = $('<td>').addClass('recvLogMsgBodyStyle');
				var p = $('<p>');
				var string = thisObjectMap['msgBody'];
				p.attr('title', string).append(string);
				td.append(p);
				tdMsgBodyArray.push(td);
			}

			//データを合成
			//tbody
			tableBody.empty();
			for(i in objRecvLogList.objectMapList){
				tableBody.append($('<tr>').append(tdTypeArray[i]).append(tdSubjectArray[i]).append(tdDateArray[i]).append(tdSendFromArray[i]).append(tdMsgBodyArray[i]));
			}

			tdTypeArray = null;
			tdSubjectArray = null;
			tdDateArray = null;
			tdSendFromArray = null;
			tdMsgBodyArray = null;

			//テーブル要素の表示
			$('#recvLogTable').children('tbody')
											.css('visibility', 'visible')
										.end()
										.trigger('update');
		}finally{
			if($('#recvLogTable').data('refresh') == true){
				$('#recvLogTable').tableDataSort();
				$('#recvLogTable').removeData('refresh');
			}
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objRecvLogList.ajaxRecvLogListRequest('default');

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//テーブル機能の拡張を行う
	$('#recvLogTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// 絞込みボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		var requestData = {'filter':thisDivToolBox.data('targetTh').text(), 'data':thisDivToolBox};
		objRecvLogList.logOffset = 0;
		objRecvLogList.ajaxRecvLogListRequest(requestData);
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 絞込み解除ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterCancelButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		objRecvLogList.logOffset = 0;
		objRecvLogList.ajaxRecvLogListRequest('default');
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 過去時間表示か未来時間表示をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#recvLogTable').on('click', '#iconGoFuturePage,#iconGoPastPage', function(){
		var maxRow = parseInt(objRecvLogList.maxRow);
		if($(this).attr('id') == 'iconGoPastPage'){
			objRecvLogList.logOffset+=maxRow;
		}else{
			if(objRecvLogList.logOffset >= maxRow){
				objRecvLogList.logOffset-=maxRow;
			}
		}
		//リクエストパラメータの編集
		var requestParams = objRecvLogList.requestParams;
		//表示ページを移動する
		requestParams['offset'] = objRecvLogList.logOffset;

		//データを要求する
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsGroup_groupHistoryLogAction_ajaxHistoryLogList, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceRecvLogAction', 'action' : 'ajaxRecvLogList', 'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)}, detailsInstance_instanceRecvLogAction_ajaxRecvLogList, 'json');
		return false;
	});
	//-------------------------------------------------------------------------
    // リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
/* 使用しない
	$('#recvLogTable').on('click', '.objectLink', function(){
    	var currentId = $(this).find('[name=currentId]').val();
		//ページ移動
    	$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + currentId);
    });
*/

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#recvLogTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#recvLogTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#recvLogTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#recvLogTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#recvLogTable').removeData('sortData');//ソート順も解除する
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objRecvLogList.intervalTimerId = setInterval(autoRefreshTimer, 1000);
	$(window).unload(function() {
		clearInterval(objRecvLogList.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// 子要素の取得応答
//=============================================================================
function detailsInstance_instanceRecvLogAction_ajaxRecvLogList(objectMapList) {
	//受信データ設定
	objRecvLogList.ajaxRecvLogListResponse(objectMapList);
	//ページ表示の更新
	objRecvLogList.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//受信ログのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#recvLogTable').data('refresh', true);
 //受信ログの情報取得要求
	objRecvLogList.ajaxRecvLogListRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#recvLogTable').data('refresh') == true){
		$('#recvLogTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objRecvLogList.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#recvLogTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
// ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#recvLogTable').data('refresh') == true){
		$('#recvLogTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
