//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objMonitorStatus = {};

$(document).ready(function(){
    //他のタブの情報を削除する
	if(window.parent.tabPageClear != undefined){
		window.parent.tabPageClear();
	}

	//=========================================================================
	// プロパティ
	//=========================================================================
	objMonitorStatus.instanceId = $('#instanceId').val();
	objMonitorStatus.objectMapList = [];

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// 要素の取得要求
	//-------------------------------------------------------------------------
	objMonitorStatus.ajaxMonitorStatusRequest = function(){
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : this.instanceId};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(detailsInstance_instanceStatusAction_ajaxMonitorStatus, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'detailsInstance_instanceStatusAction', 'action' : 'ajaxMonitorStatus', 'AjaxParam0' : objMonitorStatus.instanceId}, detailsInstance_instanceStatusAction_ajaxMonitorStatus, 'json');
	};

	//-------------------------------------------------------------------------
	// 要素の取得応答
	//-------------------------------------------------------------------------
	objMonitorStatus.ajaxMonitorStatusResponse = function(objectMapList){
		try{
			if(objectMapList.length<=0) throw 'noItem';

			delete objMonitorStatus.objectMapList;
			objMonitorStatus.objectMapList = [];
			for(i in objectMapList){
				objMonitorStatus.objectMapList[i] = objectMapList[i];
				//ステータスの設定
				if(!('lastDate' in objMonitorStatus.objectMapList[i])){
					objMonitorStatus.objectMapList[i]['lastDate'] = '--';
				}
				if(!('lastStatus' in objMonitorStatus.objectMapList[i])){
					objMonitorStatus.objectMapList[i]['lastStatus'] = '-1';
				}
				if(!('lastValue' in objMonitorStatus.objectMapList[i])){
					objMonitorStatus.objectMapList[i]['lastValue'] = '--';
				}
				if(!('lastResultCode' in objMonitorStatus.objectMapList[i])){
					objMonitorStatus.objectMapList[i]['lastResultCode'] = '--';
				}
				if(!('lastDuration' in objMonitorStatus.objectMapList[i])){
					objMonitorStatus.objectMapList[i]['lastDuration'] = '--';
				}
			}
		}catch(e){
			if(e == 'noItem'){
				delete objMonitorStatus.objectMapList;
				objMonitorStatus.objectMapList = [];
			}
		}
	};

	//ページ表示の更新処理
	objMonitorStatus.pageUpdate = function(){
		try{
			var tableBody = $('#instanceStatusTable').children('tbody');
			var iconMonitorItemTable = ['monitorCustom', 'monitorDisc', 'monitorFile', 'monitorService', 'monitorEventLog',
			                            'monitorEventLogExclusion', 'monitorPerformance', 'monitorProcessor', 'monitorMemory', 'monitorProcess',
			                            'monitorDiscAccess', 'monitorNetwork', 'monitorTextlog', 'monitorActiveSonar', 'monitorPort',
			                            'monitorOracle', 'monitorWtsSession', 'monitorWtsProcess', 'monitorWtsPerformance', 'monitorPing',
			                            'monitorEventLogVista32', 'monitorSmart', 'monitorHistoryLog', 'monitorVMwareStatus', 'monitorVMwareCount',
			                            'monitorVMwareHwStatus', 'monitorVMwareTaskLog',
			                            'monitorSQLDatabaseSpace', 'monitorSQLSessionNo', 'monitorSQLFreeDatabaseSpace', 'monitorSQLExtentNo',
			                            'monitorSqlCallSf', 'monitorInstSW', 'monitorUnknown', 
										'monitorRdsSession', 'monitorRdsProcess', 'monitorRdsPerformance',];
			var invisibleIcon = '../../images/invisible32.png';

			//受信データがない場合には中身をクリアする
			if(objMonitorStatus.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//名前
			var tdNameArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusNameStyle');
				var p = $('<p>');
				var imgMonitorIcon = $('<img>').attr('src', invisibleIcon).addClass(iconMonitorItemTable[thisObjectMap['iconIndex']]);
				var string = thisObjectMap['name'];
				p.attr('title', string).append(imgMonitorIcon).append(string);
				td.append(p);
				tdNameArray.push(td);
			}

			//ID
			var tdIdArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusIDStyle');
				var p = $('<p>');
				var string = thisObjectMap['monitorId'];
				p.append(string);
				td.append(p);
				tdIdArray.push(td);
			}

			//間隔
			var tdIntervalArray = [];
			var timeUnitHashTable = {'Seconds': '秒', 'Minutes': '分', 'Hours': '時間', 'Days': '日'};
			var timeUnitConvertHashTable = {'Seconds': 1, 'Minutes': 60, 'Hours': (60*60), 'Days': (24*60*60)};
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusIntervalStyle');
				var p = $('<p>');
				var enableFlg = thisObjectMap['enabled'];
				var string = '';
				var inputSortdata = 0;
				if(enableFlg == 'true'){
					string = thisObjectMap['interval'] + timeUnitHashTable[thisObjectMap['intervalUnit']];
					inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', (thisObjectMap['interval'] * timeUnitConvertHashTable[thisObjectMap['intervalUnit']]));
				}else{
					string = '無効';
					inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', 0);
				}
				p.append(string).append(inputSortdata);
				td.append(p);
				tdIntervalArray.push(td);
			}

			//ステータス
			var tdStatusArray = [];
			var lastStatusHashTable = {'0': '正常', '1': '注意', '2': '危険', '4': '失敗', '-1':'(なし)'};
			var lastStatusIconHashTable = {'0': 'instanseStateSuccess32', '1': 'instanseStateWarning32', '2': 'instanseStateDanger32', '4': 'instanseStateFailure32',  '-1':''};
			var allStatusImplantDataHashTable = {'0':1, '1':2, '2':4, '4':8};
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusStatusStyle');
				var p = $('<p>');
				var imgLastStatus = $('<img>').attr('src', invisibleIcon).addClass(lastStatusIconHashTable[thisObjectMap['lastStatus']]);
				var string = lastStatusHashTable[thisObjectMap['lastStatus']];
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', allStatusImplantDataHashTable[thisObjectMap['lastStatus']]);
				p.append(imgLastStatus).append(string).append(inputSortdata);
				td.append(p);
				tdStatusArray.push(td);
			}

			//前回の値
			var tdLastValueArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusLastValueStyle');
				var p = $('<p>');
				var string = thisObjectMap['lastValue'];
				if(string == '--'){
					string = "(なし)";
				}
				p.append(string);
				td.append(p);
				tdLastValueArray.push(td);
			}

			//前回の実行時刻
			var tdLastDateArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusLastDateStyle');
				var p = $('<span>');
				var string = (new String(thisObjectMap['lastDate'])).replace(/ /, '<br/>');
				var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['lastDate']);
				if(string == '--'){
					string = "(なし)";
				}
				p.append(string).append(input);
				td.append(p);
				tdLastDateArray.push(td);
			}

			//前回のコード
			var tdLastResultCodeArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusLastResultCodeStyle');
				var p = $('<p>');
				var string = '';
				var temp = thisObjectMap['lastResultCode'];
				if(temp != '--'){
					temp = Number(thisObjectMap['lastResultCode']);
					if(temp<0){
						temp = temp + parseInt('ffffffff', 16)+1;
					}
					temp = '0x'+ temp.toString(16).toUpperCase();
				} else {
					temp = "(なし)";
				}
				string = temp;
				p.append(string);
				td.append(p);
				tdLastResultCodeArray.push(td);
			}

			//前回の実行時間
			var tdLastExecuteTimeArray = [];
			for(i in objMonitorStatus.objectMapList){
				var thisObjectMap = objMonitorStatus.objectMapList[i];
				var td = $('<td>').addClass('instanceStatusLastTimeStyle');
				var p = $('<p>');
				var string = '';
				var temp = thisObjectMap['lastDuration'];
				var saveTime = 0;
				if(temp != '--'){
					saveTime = temp;
					temp = temp + '秒';
				} else {
					temp = "(なし)";
				}
				string = temp;
				var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', saveTime);
				p.append(string).append(inputSortdata);
				td.append(p);
				tdLastExecuteTimeArray.push(td);
			}

			//データの合成
			//tbody
			tableBody.empty();
			for(i in objMonitorStatus.objectMapList){
				tableBody.append($('<tr>').append(tdNameArray[i])
						.append(tdIdArray[i])
						.append(tdIntervalArray[i])
						.append(tdStatusArray[i])
						.append(tdLastValueArray[i])
						.append(tdLastDateArray[i])
						.append(tdLastResultCodeArray[i])
						.append(tdLastExecuteTimeArray[i]));
			}

			tdNameArray = null;
			tdIdArray = null;
			tdIntervalArray = null;
			tdStatusArray = null;
			tdLastValueArray = null;
			tdLastDateArray = null;
			tdLastResultCodeArray = null;
			tdLastExecuteTimeArray = null;

			//テーブル要素の表示
			$('#instanceStatusTable').children('tbody')
											.css('visibility', 'visible')
									.end()
									.trigger('update');
			//iPad用の処理
			//テーブルの幅を揃える
			if(navigator.userAgent.search(/iPad/) != -1){
				$('#instanceStatusTable').find('tbody').width($('#instanceStatusTable').find('thead').width());
			}
		}finally{
			var divToolBox = $('#instanceStatusTable').data('divToolBox');
			if( divToolBox != undefined ){
				$('#instanceStatusTable').tableDataFilter(divToolBox, true);
			}
			if($('#instanceStatusTable').data('refresh') == true){
				$('#instanceStatusTable').tableDataSort();
				$('#instanceStatusTable').removeData('refresh');
			}
            //Loading終了
		    $('body').deleteLoadingScreen();
		}
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	objMonitorStatus.ajaxMonitorStatusRequest();

	//テーブル機能の拡張を行う
	$('#instanceStatusTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#instanceStatusTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#instanceStatusTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#instanceStatusTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#instanceStatusTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			$('#instanceStatusTable').tableDataFilter($(this).parents('div.divToolBox'), true);
			$('#instanceStatusTable').removeData('divToolBox');
			//絞り込みのためのツールボックス情報と、クリック位置を保存する
			var clickIndex = $(this).parents('div.divToolBox').data('clickIndex');
			$('#instanceStatusTable').data('divToolBox', $(this).parents('div.divToolBox').clone(true).data('clickIndex', clickIndex));
			$(this).parents('div.divToolBox').remove();
			$('#instanceStatusTable').trigger('update');
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			$('#instanceStatusTable').removeData('divToolBox');
			$('#instanceStatusTable').removeData('sortData');//ソート順も解除する
			$(this).parents('div.divToolBox').remove();
			$('#instanceStatusTable').trigger('update');
			//初期表示に戻すため、サーバーにデータを再要求する
			objMonitorStatus.ajaxMonitorStatusRequest();
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objMonitorStatus.intervalTimerId = setInterval(autoRefreshTimer, 1000);
});

//=============================================================================
// 子要素の取得応答
//=============================================================================
function detailsInstance_instanceStatusAction_ajaxMonitorStatus(objectMapList) {
	//受信データ設定
	objMonitorStatus.ajaxMonitorStatusResponse(objectMapList);
	//ページ表示の更新
	objMonitorStatus.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//インスタンスステータスのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#instanceStatusTable').data('refresh', true);
	//インスタンスステータス情報取得要求
	objMonitorStatus.ajaxMonitorStatusRequest();
}

//=============================================================================
//詳細ビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#instanceStatusTable').data('refresh') == true){
		$('#instanceStatusTable').removeData('refresh');
	}
	//リフレッシュ用のタイマーを停止する
	clearInterval(objMonitorStatus.intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#instanceStatusTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#instanceStatusTable').data('refresh') == true){
		$('#instanceStatusTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('detailView');
}
