SELECT
	action.action_id,
	action_name,
	action.group_id,
	enabled,
	condition_normal,
	condition_warning,
	condition_danger,
	condition_failure,
	condition_monitor_disconnect,
	condition_helper_disconnect,
	condition_computer_disconnect,
	action_kind,
	action_command,
	action_params,
	action_working_directory,
	create_datetime,
	create_user_id,
	(SELECT user_name FROM user WHERE user_id = action.create_user_id) AS create_user_name,
	update_datetime,
	update_user_id,
	(SELECT user_name FROM user WHERE user_id = action.update_user_id) AS update_user_name,
	action_log_id,
	datetime,
	duration,
	result_code,
	exit_code,
	output,
	instance_id,
	status_normal,
	status_warning,
	status_danger,
	status_failure,
	status_monitor_disconnect,
	status_helper_disconnect,
	status_computer_disconnect,
	outline_string,
	single_run
FROM
	action
	LEFT OUTER JOIN
	(
		SELECT
			action_id,
			MAX(datetime) as last_datetime
		FROM
			action_log
		GROUP BY
			action_id
	) action_log_last_date
	ON (action.action_id = action_log_last_date.action_id)
	LEFT OUTER JOIN
	action_log
	ON (action_log_last_date.action_id = action_log.action_id AND action_log_last_date.last_datetime = action_log.datetime)
WHERE
	action.group_id=/*group_id*/1
	AND action_name=/*action_name*/'action_name'
