SELECT
	action_log_id,
	action_log.action_id,
	action.action_name,
	action.group_id,
	instance_group.group_name,
	action.enabled,
	action.condition_normal,
	action.condition_warning,
	action.condition_danger,
	action.condition_failure,
	action.condition_monitor_disconnect,
	action.condition_helper_disconnect,
	action.condition_computer_disconnect,
	action_log.datetime,
	action_log.duration,
	action_log.result_code,
	action_log.exit_code,
	action_log.output,
	action_log.instance_id,
	instance.display_name,
	instance.instance_kind,
	action_log.status_normal,
	action_log.status_warning,
	action_log.status_danger,
	action_log.status_failure,
	action_log.status_monitor_disconnect,
	action_log.status_helper_disconnect,
	action_log.status_computer_disconnect,
	action_log.outline_string
FROM
	action_log
	LEFT OUTER JOIN
	action
	ON (action_log.action_id = action.action_id)
	LEFT OUTER JOIN
	instance_group
	ON (action.group_id = instance_group.group_id)
	LEFT OUTER JOIN
	instance
	ON (action_log.instance_id = instance.instance_id)
/*BEGIN*/
WHERE
	/*IF filter_condition_list != null && !filter_condition_list.isEmpty*/
	(
		/*IF "normal" in filter_condition_list*/(status_normal = TRUE)/*END*/
		/*IF "warning" in filter_condition_list*/OR (status_warning = TRUE)/*END*/
		/*IF "danger" in filter_condition_list*/OR (status_danger = TRUE)/*END*/
		/*IF "failure" in filter_condition_list*/OR (status_failure = TRUE)/*END*/
		/*IF "disconnectAgent" in filter_condition_list*/OR (status_monitor_disconnect = TRUE)/*END*/
		/*IF "disconnectHelper" in filter_condition_list*/OR (status_helper_disconnect = TRUE)/*END*/
		/*IF "disconnectComputer" in filter_condition_list*/OR (status_computer_disconnect = TRUE)/*END*/
	)
	/*END*/
	/*IF group_id_list != null*/AND action_log.group_id IN /*group_id_list*/(1,2)/*END*/
	/*IF begin_date != null*/AND datetime >= /*begin_date*/'1970-01-01 0:00:00+09:00'/*END*/
	/*IF end_date != null*/AND datetime <= /*end_date*/CURRENT_TIMESTAMP/*END*/
	/*IF filter_action_name != null*/AND action_name LIKE '%' || /*filter_action_name*/'%' || '%'/*END*/
	/*IF filter_instance_name != null*/AND display_name LIKE '%' || /*filter_instance_name*/'%' || '%'/*END*/
	/*IF filter_result_code_list != null && !filter_result_code_list.isEmpty*/AND result_code IN /*filter_result_code_list*/(0,1,2)/*END*/
	/*IF filter_exit_code_list != null && !filter_exit_code_list.isEmpty*/AND exit_code IN /*filter_exit_code_list*/(0)/*END*/
	/*IF filter_outline != null*/AND outline_string LIKE '%' || /*filter_outline*/'%' || '%'/*END*/
/*END*/
ORDER BY datetime /*IF order == false*/DESC/*END*/
/*IF max_row != null*/
	LIMIT /*max_row*/100
	/*IF offset != null*/OFFSET /*offset*/0/*END*/
/*END*/
