SELECT
	bom_history_log_id,
	bom_history_log.instance_id,
	display_name,
	instance_kind,
	datetime,
	type,
	category,
	summary,
	message
FROM
	bom_history_log
	LEFT OUTER JOIN
	instance
	ON (bom_history_log.instance_id = instance.instance_id)
/*BEGIN*/
WHERE
	/*IF filter_type != null*/
	(
		/*IF 1 in filter_type*/type = 1/*END*/
		/*IF 2 in filter_type*/OR type = 2/*END*/
		/*IF 4 in filter_type*/OR type = 4/*END*/
	)
	/*END*/
	/*IF instance_id_list != null && !instance_id_list.isEmpty*/AND bom_history_log.instance_id IN /*instance_id_list*/(1,2)/*END*/
	/*IF begin_date != null*/AND datetime >= /*begin_date*/'1970-01-01 0:00:00+09:00'/*END*/
	/*IF end_date != null*/AND datetime <= /*end_date*/CURRENT_TIMESTAMP/*END*/
	/*IF filter_name != null*/AND display_name LIKE '%' || /*filter_name*/'%' || '%'/*END*/
	/*IF filter_category != null*/AND category LIKE '%' || /*filter_category*/'%' || '%'/*END*/
	/*IF filter_summary != null*/AND summary LIKE '%' || /*filter_summary*/'%' || '%'/*END*/
/*END*/
ORDER BY datetime /*IF order == false*/DESC/*END*/
/*IF max_row != null*/
	LIMIT /*max_row*/100
	/*IF offset != null*/OFFSET /*offset*/0/*END*/
/*END*/