SELECT
	bom_monitor.instance_id,
	bom_monitor.bom_monitor_id,
	monitor_type,
	monitor_group_id,
	monitor_monitor_id,
	monitor_name,
	monitor_started_time,
	monitor_interval,
	monitor_interval_unit,
	clsid,
	object_name,
	value_name,
	options,
	danger_value,
	danger_type,
	warning_value,
	warning_type,
	comment,
	icon_index,
	enabled,
	display_unit,
	scale,
	bom_monitor_log_id,
	datetime,
	rundatetime,
	duration,
	result_code,
	value,
	status
FROM
	(
		SELECT
			*
		FROM
			bom_monitor
		WHERE
			instance_id = /*instance_id*/1
	) AS bom_monitor
	LEFT OUTER JOIN
	(
		SELECT
			bom_monitor_id,
			MAX(datetime) AS max_datetime
		FROM
			bom_monitor_log
		GROUP BY
			bom_monitor_id
	) AS bom_monitor_log_last_datetime
	ON (bom_monitor.bom_monitor_id = bom_monitor_log_last_datetime.bom_monitor_id)
	LEFT OUTER JOIN
	bom_monitor_log
	ON (bom_monitor_log_last_datetime.bom_monitor_id = bom_monitor_log.bom_monitor_id AND bom_monitor_log_last_datetime.max_datetime = bom_monitor_log.datetime)
