SELECT
	bom_recv_log_id,
	bom_recv_log.recv_set_id,
	mail_setting.display_name,
	mail_setting.group_id,
	instance_group.group_name,
	mail_setting.instance_id,
	instance.display_name as instance_name,
	instance.instance_kind,
	subject,
	bom_monitor_kind,
	send_time,
	subject,
	send_from,
	message,
	status
FROM
	bom_recv_log
	LEFT OUTER JOIN
	mail_setting
	ON (bom_recv_log.recv_set_id = mail_setting.mail_set_id)
	LEFT OUTER JOIN
	instance_group
	ON (mail_setting.group_id = instance_group.group_id)
	LEFT OUTER JOIN
	instance
	ON (mail_setting.instance_id = instance.instance_id)
/*BEGIN*/
WHERE
	/*IF filter_type != null*/mail_setting.display_name LIKE '%' || /*filter_type*/'%' || '%'/*END*/
	/*IF instance_id_list != null && !instance_id_list.isEmpty*/AND mail_setting.instance_id IN /*instance_id_list*/(1,2)/*END*/
	/*IF begin_date != null*/AND send_time >= /*begin_date*/'1970-01-01 0:00:00+09:00'/*END*/
	/*IF end_date != null*/AND send_time <= /*end_date*/CURRENT_TIMESTAMP/*END*/
	/*IF filter_subject != null*/AND subject LIKE '%' || /*filter_subject*/'%' || '%'/*END*/
	/*IF filter_send_from != null*/AND send_from LIKE '%' || /*filter_send_from*/'%' || '%'/*END*/
	/*IF filter_msg_body != null*/AND message LIKE '%' || /*filter_msg_body*/'%' || '%'/*END*/
/*END*/
ORDER BY send_time /*IF order == false*/DESC/*END*/
/*IF max_row != null*/
	LIMIT /*max_row*/100
	/*IF offset != null*/OFFSET /*offset*/0/*END*/
/*END*/