SELECT
	instance.instance_id,
	instance.group_id,
	display_name,
	computer_name,
	helper_service_port,
	bom_user,
	bom_password_encrypted,
	instance_kind,
	instance_name,
	polling_extend,
	polling_enabled,
	polling_interval,
	instance.create_datetime,
	instance.create_user_id,
	instance.update_datetime,
	instance.update_user_id,
	(SELECT user_name FROM user WHERE user_id = instance.create_user_id) AS create_user_name,
	(SELECT user_name FROM user WHERE user_id = instance.update_user_id) AS update_user_name,
	group_name,
	parent_group_id,
	group_polling_enabled,
	group_polling_interval,
	last_polling_datetime,
	next_polling_datetime,
	during_execute,
	bom_instance_id,
	bom_instance_name,
	host,
	domain,
	logon_user_id,
	logon_password_encrypted,
	connection_type
FROM
	instance
	LEFT OUTER JOIN
	instance_group
	ON (instance.group_id = instance_group.group_id)
	LEFT OUTER JOIN
	polling
	ON (instance.instance_id = polling.instance_id)
	LEFT OUTER JOIN
	bom_instance
	ON (instance.instance_id = bom_instance.instance_id)
WHERE
	instance.group_id = /*group_id*/
	AND
	display_name = /*display_name*/

