SELECT
	instance_log_id,
	instance_log.instance_id,
	group_id,
	display_name,
	instance_kind,
	datetime,
	polling_status_disconnect_computer,
	polling_status_disconnect_helper,
	polling_status_disconnect_agent,
	failure_count,
	danger_count,
	warning_count,
	normal_count,
	confirm_status,
	outline_string
FROM
	instance_log
	LEFT OUTER JOIN
	instance
	ON (instance_log.instance_id = instance.instance_id)
/*BEGIN*/
WHERE
	/*IF filter_status_list != null && !filter_status_list.isEmpty && ("normal" in filter_status_list || "warning" in filter_status_list || "danger" in filter_status_list || "failure" in filter_status_list || "disconnectAgent" in filter_status_list || "disconnectHelper" in filter_status_list || "disconnectComputer" in filter_status_list)*/
	(
		/*IF "normal" in filter_status_list*/normal_count > 0/*END*/
		/*IF "warning" in filter_status_list*/OR warning_count > 0/*END*/
		/*IF "danger" in filter_status_list*/OR danger_count > 0/*END*/
		/*IF "failure" in filter_status_list*/OR failure_count > 0/*END*/
		/*IF "disconnectAgent" in filter_status_list*/OR polling_status_disconnect_agent = TRUE/*END*/
		/*IF "disconnectHelper" in filter_status_list*/OR polling_status_disconnect_helper = TRUE/*END*/
		/*IF "disconnectComputer" in filter_status_list*/OR polling_status_disconnect_computer = TRUE/*END*/
	)
	/*IF "statusConfirmed" in filter_status_list*/AND confirm_status = TRUE/*END*/
	/*IF "statusNoConfirmed" in filter_status_list*/AND confirm_status = FALSE/*END*/
	/*END*/
	/*IF filter_status_list != null && !filter_status_list.isEmpty && filter_status_list.size == 1 && ("statusConfirmed" in filter_status_list || "statusNoConfirmed" in filter_status_list)*/
		/*IF "statusConfirmed" in filter_status_list*/confirm_status = TRUE/*END*/
		/*IF "statusNoConfirmed" in filter_status_list*/confirm_status = FALSE/*END*/
	/*END*/
	/*IF instance_id_list != null && !instance_id_list.isEmpty*/AND instance_log.instance_id IN /*instance_id_list*/(1,2)/*END*/
	/*IF begin_date != null*/AND datetime >= /*begin_date*/'1970-01-01 0:00:00+09:00'/*END*/
	/*IF end_date != null*/AND datetime <= /*end_date*/CURRENT_TIMESTAMP/*END*/
	/*IF filter_name != null*/AND display_name LIKE '%' || /*filter_name*/'%' || '%'/*END*/
	/*IF filter_failure_count != null*/AND failure_count = /*filter_failure_count*/0/*END*/
	/*IF filter_danger_count != null*/AND danger_count = /*filter_danger_count*/0/*END*/
	/*IF filter_warning_count != null*/AND warning_count = /*filter_warning_count*/0/*END*/
	/*IF filter_normal_count != null*/AND normal_count = /*filter_normal_count*/0/*END*/
	/*IF filter_outline != null*/AND outline_string LIKE '%' || /*filter_outline*/'%' || '%'/*END*/
/*END*/
ORDER BY datetime /*IF order == false*/DESC/*END*/
/*IF max_row != null*/
	LIMIT /*max_row*/100
	/*IF offset != null*/OFFSET /*offset*/0/*END*/
/*END*/
