SELECT
	instance.instance_id,
	display_name,
	instance_kind,
	group_id,
	normal_count,
	warning_count,
	danger_count,
	failure_count,
	polling_status_disconnect_agent,
	polling_status_disconnect_helper,
	polling_status_disconnect_computer,
	confirm_status
FROM
	instance
	LEFT OUTER JOIN
	(
	SELECT
		instance_id,
		SUM(normal_count) AS normal_count,
		SUM(warning_count) AS warning_count,
		SUM(danger_count) AS danger_count,
		SUM(failure_count) AS failure_count,
		CASE WHEN SUM(polling_status_disconnect_agent) > 0 THEN TRUE ELSE FALSE END AS polling_status_disconnect_agent,
		CASE WHEN SUM(polling_status_disconnect_helper) > 0 THEN TRUE ELSE FALSE END AS polling_status_disconnect_helper,
		CASE WHEN SUM(polling_status_disconnect_computer) > 0 THEN TRUE ELSE FALSE END AS polling_status_disconnect_computer,
		confirm_status
	FROM
		instance_log
	GROUP BY
		instance_id,
		confirm_status
	) instance_log_summary
	ON (instance_log_summary.instance_id = instance.instance_id)
