SELECT
	system_log_id,
	datetime,
	level,
	category,
	message
FROM
	system_log
/*BEGIN*/
WHERE
	/*IF filter_level != null*/
	(
		/*IF 1 in filter_level*/level = 'ERROR'/*END*/
		/*IF 2 in filter_level*/OR level = 'WARNING'/*END*/
		/*IF 4 in filter_level*/OR level = 'INFORMATION'/*END*/
	)
	/*END*/
	/*IF begin_date != null*/AND datetime >= /*begin_date*/'1970-01-01 0:00:00+09:00'/*END*/
	/*IF end_date != null*/AND datetime <= /*end_date*/CURRENT_TIMESTAMP/*END*/
	/*IF filter_category != null*/AND category LIKE '%' || /*filter_category*/'%' || '%'/*END*/
	/*IF filter_message != null*/AND message LIKE '%' || /*filter_message*/'%' || '%'/*END*/
/*END*/
ORDER BY datetime /*IF order == false*/DESC/*END*/,
system_log_id /*IF order == false*/DESC/*END*/
/*IF max_row != null*/
	LIMIT /*max_row*/100
	/*IF offset != null*/OFFSET /*offset*/0/*END*/
/*END*/
