CREATE TABLE action_log (
	action_log_id					IDENTITY	PRIMARY KEY,
	group_id						BIGINT		NOT NULL,
	action_id						BIGINT		NOT NULL,
	datetime						TIMESTAMP	NOT NULL,
	duration						DOUBLE		NOT NULL,
	result_code						INTEGER		NOT NULL,
	exit_code						INTEGER		NOT NULL,
	output							VARCHAR,
	instance_id						BIGINT		NOT NULL,
	status_normal					BOOLEAN		NOT NULL,
	status_warning					BOOLEAN		NOT NULL,
	status_danger					BOOLEAN		NOT NULL,
	status_failure					BOOLEAN		NOT NULL,
	status_monitor_disconnect		BOOLEAN		NOT NULL,
	status_helper_disconnect		BOOLEAN		NOT NULL,
	status_computer_disconnect		BOOLEAN		NOT NULL,
	outline_string					VARCHAR		NOT NULL
);
CREATE INDEX index_action_log_action_id ON action_log (
	action_id
);
CREATE INDEX index_action_log_instanceid ON action_log (
	instance_id
);
CREATE INDEX index_action_log_datetime ON action_log (
	datetime DESC
);
CREATE HASH INDEX index_action_log_result_code_instance_id ON action_log (
	result_code,
	instance_id
);
CREATE HASH INDEX index_action_log_exit_code_instance_id ON action_log (
	exit_code,
	instance_id
);

