CREATE TABLE instance_log(
	instance_log_id						IDENTITY	PRIMARY KEY,
	instance_id							BIGINT		NOT NULL,
	datetime							TIMESTAMP	NOT NULL,
	polling_status_disconnect_computer	BOOLEAN		NOT NULL,
	polling_status_disconnect_helper	BOOLEAN		NOT NULL,
	polling_status_disconnect_agent		BOOLEAN		NOT NULL,
	failure_count						INTEGER		NOT NULL,
	danger_count						INTEGER		NOT NULL,
	warning_count						INTEGER		NOT NULL,
	normal_count						INTEGER		NOT NULL,
	confirm_status						BOOLEAN		NOT NULL,
	outline_string						VARCHAR		NOT NULL,
	create_datetime						TIMESTAMP	NOT NULL,
	create_user_id						VARCHAR		NOT NULL,
	update_datetime						TIMESTAMP	NOT NULL,
	update_user_id						VARCHAR		NOT NULL
);
CREATE INDEX index_instance_log_instanceid ON instance_log (
	instance_id
);
CREATE INDEX index_instance_log_datetime ON instance_log (
	datetime DESC
);

CREATE INDEX index_instance_log_instanceid_confirmstatus ON instance_log (
	instance_id,
	confirm_status
);
