//*****************************************************************************
// Copyright (C) 2013-2014 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var objLogview = {};
objLogview.requestParam = {};


$(document).ready(function(){
	//=========================================================================
	// プロパティ定義
	//=========================================================================
	//受信データ保存
	objLogview.objectMapList = [];

	//=========================================================================
	// メソッド
	//=========================================================================
	//-------------------------------------------------------------------------
	// サマリーの取得要求
	//-------------------------------------------------------------------------
	objLogview.ajaxSummaryLogRequest = function(){
		var beforeTime = ((new Date()-($('#recentLogTime', top.document).val()*1000))/1000).toFixed()/*はじまりの時間*/;
		//パラメータ
		objLogview.requestParam = 	{'order':			false,
									'maxRow':			500,
									'beginDate':		beforeTime};
		//Loadingタイマー開始
		$('body').viewLoadingScreen();
		//var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(this.requestParam)};
		//ajaxParam.onFailure = onAjaxFailure;
		//Kumu.Ajax.executeTeedaAjax(logview_logviewAction_ajaxSummaryLog, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		$.get('/Indicator/view/teeda.ajax', {'component' : 'logview_logviewAction', 'action' : 'ajaxSummaryLog', 'AjaxParam0' : Kumu.JSONSerializer.serialize(objLogview.requestParam)}, logview_logviewAction_ajaxSummaryLog, 'json');
	};

	//-------------------------------------------------------------------------
	// 子要素の取得応答
	//-------------------------------------------------------------------------
	objLogview.ajaxSummaryLogResponse = function( objectMapList ){
		try{
			if(objectMapList.length<=0) throw 'noItem';

			delete objLogview.objectMapList;
			objLogview.objectMapList = [];
			for (i in objectMapList) {
				objLogview.objectMapList[i] = objectMapList[i];
				if(!('targetName' in objLogview.objectMapList[i])){
					objLogview.objectMapList[i]['targetName'] = 'システム';
				}
			}
		}catch(e){
			if(e == 'noItem'){
				delete objLogview.objectMapList;
				objLogview.objectMapList = [];
			}
		};
	};

	//-------------------------------------------------------------------------
	// ページ表示の更新処理
	//-------------------------------------------------------------------------
	objLogview.pageUpdate = function(){
		try{
			var tableBody = $('#logviewTable').children('tbody');

			//受信データがない場合には中身をクリアする
			if(objLogview.objectMapList.length<=0){
				tableBody.empty();
				return;
			}

			//タイプ
			var tdTypeArray = [];
			var statusStringHashTable = {1:'エラー', 2:'警告', 4:'情報'};
			var statusIconHashTable = {1:'logStateError16', 2:'logStateWarning16', 4:'logStateInformation16'};
			for(i in objLogview.objectMapList){
				var thisObjectMap = objLogview.objectMapList[i];
				var td = $('<td>').addClass('logviewTypeStyle')
					.append($('<p/>').html(statusStringHashTable[thisObjectMap['logType']])
							.prepend( $('<img/>').attr('src', '../../images/invisible16.png').addClass(statusIconHashTable[thisObjectMap['logType']]) )
					)
					.append($('<input type="hidden"/>').attr('name', 'sortdata').val(thisObjectMap['logType'])
					);
				tdTypeArray.push(td);
				td = null;
			}

			//ターゲット
			var tdTargetArray = [];
			for(i in objLogview.objectMapList){
				var thisObjectMap = objLogview.objectMapList[i];
				var td = $('<td>').addClass('logviewTargetNameStyle')
					.append($('<p>').addClass('objectLink').attr('title', thisObjectMap['targetName']).html(thisObjectMap['targetName'])
							.prepend( $('<input type="hidden"/>').attr('name', 'category').val(thisObjectMap['category']) )
							.prepend( $('<input type="hidden"/>').attr('name', 'currentId').val(thisObjectMap['targetId']) )
							.prepend( $('<input type="hidden"/>').attr('name', 'currentType').val(thisObjectMap['type']) )
							.prepend( $('<input type="hidden"/>').attr('name', 'parentId').val(thisObjectMap['targetParentId']) )
					);
				tdTargetArray.push(td);
				td = null;
			}

			//日時
			var tdDateArray = [];
			for(i in objLogview.objectMapList){
				var thisObjectMap = objLogview.objectMapList[i];
				var td = $('<td>').addClass('logviewDateStyle')
					.append($('<p>').html(thisObjectMap['date'])
							.append( $('<input type="hidden"/>').attr('name', 'date').val(thisObjectMap['date']) )
					);
				tdDateArray.push(td);
				td = null;
			}

			//カテゴリ
			var tdCategoryArray = [];
			for(i in objLogview.objectMapList){
				var thisObjectMap = objLogview.objectMapList[i];
				var td = $('<td>').addClass('logviewCategoryStyle')
					.append( $('<p>').html(thisObjectMap['category']) );
				tdCategoryArray.push(td);
				td = null;
			}

			//サマリー
			var tdSummaryArray = [];
			for(i in objLogview.objectMapList){
				var thisObjectMap = objLogview.objectMapList[i];
				var td = $('<td>').addClass('logviewSummaryStyle')
					.append( $('<p>').attr('title', thisObjectMap['summary']).html(thisObjectMap['summary']) );
				tdSummaryArray.push(td);
				td = null;
			}

			//合成する
			tableBody.empty();
			for(i in objLogview.objectMapList){
				tableBody.append($('<tr>').append(tdTypeArray[i]).append(tdTargetArray[i]).append(tdDateArray[i]).append(tdCategoryArray[i]).append(tdSummaryArray[i]));
			}

			tdTypeArray = null;
			tdTargetArray = null;
			tdDateArray = null;
			tdCategoryArray = null;
			tdSummaryArray = null;

			//テーブル要素の表示
			$('#logviewTable').children('tbody')
									.css('visibility', 'visible')
								.end()
								.trigger('update');
		}finally{
			if($('#logviewTable').data('refresh') == true){
				$('#logviewTable').tableDataSort();
				$('#logviewTable').removeData('refresh');
			}
			//処理中画面消去
			$('body').deleteLoadingScreen();
		};
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	//ログ情報取得要求
	objLogview.ajaxSummaryLogRequest();

   //テーブル機能の拡張を行う
	$('#logviewTable').fixedHeaderTable();

	//=========================================================================
	// コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
    // リスト内のアイテムをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#logviewTable').on('click', '.objectLink', function(){
    	var parentId = $(this).find('[name=parentId]').val();
    	var currentType = $(this).find('[name=currentType]').val();
    	var currentId = $(this).find('[name=currentId]').val();
    	var category = $(this).find('[name=category]').val();
    	var tabIndex = '0';

		if(category == 'ステータスログ'){
			tabIndex = '2';
		}else if(category == 'ヒストリーログ'){
			tabIndex = '3';
		}else if(category == 'アクションログ'){
			tabIndex = '4';
		}else if(category == 'システムログ'){
			//システムログを表示する
			window.parent.showDialog('systemLog/systemLogViewer.html', 'システムログ表示', 800, 600, true);
			return;
		}else{
			//該当するものがない場合には処理を行わない
			return;
		}

		//ページ移動
		if (currentType == 'GROUP') {
			$('#mainDetails', top.document).attr('src', 'detailsGroup/detailsGroup.html?groupId=' + currentId + '&tabIndex=' + tabIndex);
		} else if (currentType == 'ACTION') {
			$('#mainDetails', top.document).attr('src', 'detailsGroup/detailsGroup.html?groupId=' + parentId + '&tabIndex=' + tabIndex);
		} else {
    		$('#mainDetails', top.document).attr('src', 'detailsInstance/detailsInstance.html?instanceId=' + currentId + '&tabIndex=' + tabIndex);
		}
    });

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#logviewTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#logviewTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#logviewTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#logviewTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	objLogview.intervalTimerId = setInterval(autoRefreshTimer, 1000);

	//インターバルタイマーを停止する
	$(window).unload(function() {
		clearInterval(objLogview.intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
});

//=============================================================================
// ログ情報取得応答処理
//=============================================================================
function logview_logviewAction_ajaxSummaryLog(objectMapList) {
	//受信データ設定
	objLogview.ajaxSummaryLogResponse(objectMapList);
	//ページ表示の更新
	objLogview.pageUpdate();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('logView');
	execGC();
}

//=============================================================================
// ログビューのリフレッシュ処理要求
//=============================================================================
function windowRefresh(){
	$('#logviewTable').data('refresh', true);
	//ログ情報取得要求
	objLogview.ajaxSummaryLogRequest();
}

//=============================================================================
//ログビューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#logviewTable').data('refresh') == true){
		$('#logviewTable').removeData('refresh');
	}
	//自動更新用のタイマーを停止する
	clearInterval(objLogview.intervalTimerId);

	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('logView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());
		count = count+1;

		if(count >= autoRefreshTime){
			if($('#logviewTable').data('refresh') != true){
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
// ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#logviewTable').data('refresh') == true){
		$('#logviewTable').removeData('refresh');
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('logView');
}