//*****************************************************************************
// Copyright (C) 2013-2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

var autoLogoutTimeCount = 0;
var autoGoHomeTimeCount = 0;
var autoExecTimerId = 0;
var autoLogoutTimeCountInit = false;

$(document).ready(function(){
	//iPad区別用
	var isiPad = (navigator.userAgent).search(/iPad/)!=-1?true:false;

	//iPad用初期処理
	if(isiPad){
		//初期設定
		$(window).bind("load",function(){
			if(Math.abs(window.orientation) === 90){
				//横向き
				$('#mainLogview').height(190);
			}else{
				//縦向き
				$('#mainTreeView').height(918);
				$('#mainDetails').height(918);
				$('#mainLogview').css('top', 970);
				$('#mainLogview').height(190);
			}		});
		//iPadは、回転イベント時にはリロードをする
		$(window).bind("orientationchange",function(){
			$('body').hide();
			location.reload();
		});
		//サイズ変更バーなどは表示しない
		$('#informationPlate').hide();
		$('#verticalSplitBar').hide();
		$('#horizonSplitBar').hide();
	}

	var resize = function() {
		if(isiPad){
			//iPadは、なにもしない
			return;
		}
		var top = $(window);
		var treeView = $('#mainTreeView');
		var commandBar = $('#mainCommandBar');
		var details = $('#mainDetails');
		var logview = $('#mainLogview');

		commandBar.width(top.innerWidth());
		treeView.height(top.innerHeight() - commandBar.height() - logview.height());
		treeView.contents().find('#treeGroupView').contents().find('#divTreeViewBody').height(treeView.height()-25);
		details.css('top', commandBar.height());
		details.css('left', treeView.width());
		details.height(treeView.height());
		details.width(top.innerWidth() - (treeView.width()));
		logview.css('top', commandBar.height() + treeView.height());
		logview.width(top.innerWidth());

		//DOM参照をクリア
		top = null;
		treeView = null;
		commandBar = null;
		details = null;
		logview = null;
	};
	resize();

	$(window).resize(resize);

	//メンテナンスモードの設定
	if( $.jStorage.get('maintenanceMode', '') == 'ON'){
		//メンテナンスモードが設定されている場合にはメンテナンスモードに移行する
		//現状、ページリロードのみでしか処理がされない
		$('#operationMode').val('maintenance');
	}

	//各ページ要素の読み込み
	$('#mainTreeView').attr('src', 'tree/treeView.html');
	$('#mainCommandBar').attr('src', 'commandBar/commandBar.html');
	$('#mainLogview').attr('src', 'logview/logview.html');

	$('#mainTreeView, #mainCommandBar, #mainDetails, #mainLogview').css('visibility', 'visible');

	//戻るボタン用配列を設定しておく。
	$('body', top.document).data('pageNavigateArray', []);

	//サイズ変更用のスプリットバーを表示する
	//縦サイズ変更用スプリットバー
	var cacheHorizonSplitBar = $('#horizonSplitBar');
	cacheHorizonSplitBar.offset(function(){
		var top  = 0;
		top = $('#mainDetails').position().top + $('#mainDetails').outerHeight(false) - $(this).outerHeight(false);
		return {top: top, left: 0};
	});
	cacheHorizonSplitBar.width(function(){
		return $('#mainLogview').outerWidth(false) - $(this).outerWidth(false);
	});
	//スプリットバーを置いた分、他の要素のサイズを減らす
	$('#mainTreeView,#mainDetails').each(function(){
		$(this).height($(this).height() - cacheHorizonSplitBar.outerHeight(false));
	});
	cacheHorizonSplitBar.css('visibility', 'visible');
	cacheHorizonSplitBar.on('mousedown', function(event){
		var cacheInformationPlate = $('#informationPlate');
		cacheInformationPlate.data('horizonSplitBar', cacheHorizonSplitBar)
								.data('horizonSplitResize', true)
								.data('upFrame', $('#mainTreeView,#mainDetails'))
								.data('downFrame', $('#mainLogview'));
		cacheInformationPlate.css('cursor', 'ns-resize');
		cacheInformationPlate.css('visibility', 'visible');
		//DOM参照をクリア
		cacheInformationPlate = null;
	});
	$(window).resize(function(){
		var top = $(window).innerHeight()-$('#mainLogview').outerHeight(false)-$('#horizonSplitBar').outerHeight(false);
		$('#horizonSplitBar').offset({top: top});
		$('#horizonSplitBar').width($(window).innerWidth());
	});

	//横サイズ変更用スプリットバー
	var cacheVerticalSplitBar = $('#verticalSplitBar');
	cacheVerticalSplitBar.offset(function(){
		var top   = 0;
		var left  = 0;
		top  = $('#mainCommandBar').position().top + $('#mainCommandBar').outerHeight(false);
		left = $('#mainTreeView').position().left + ($('#mainTreeView').outerWidth(false)) - $(this).outerWidth(false);
		return {top: top, left: left};
	});
	cacheVerticalSplitBar.height(function(){
		var height = 0;
		height = $('#mainTreeView').innerHeight() - $(this).outerHeight(false);
		return height;
	});
	//スプリットバーを置いた分、他の要素のサイズを減らす
	$('#mainTreeView').each(function(){
		$(this).width($(this).width() - cacheVerticalSplitBar.outerWidth(false));
	});
	cacheVerticalSplitBar.css('visibility', 'visible');
	//-------------------------------------------------------------------------
	// スプリットバーへのマウスボタン押下時の処理
	//-------------------------------------------------------------------------
	cacheVerticalSplitBar.on('mousedown', function(event){
		var cacheInformationPlate = $('#informationPlate');
		cacheInformationPlate.data('verticalSplitBar', cacheVerticalSplitBar)
								.data('verticalSplitResize', true)
								.data('leftFrame', $('#mainTreeView'))
								.data('rightFrame', $('#mainDetails'));
		cacheInformationPlate.css('cursor', 'ew-resize');
		cacheInformationPlate.css('visibility', 'visible');
		//DOM参照をクリア
		cacheInformationPlate = null;
	});
	$(window).resize(function(){
		var verticalSplitBarHeight = $(window).innerHeight()-$('#mainLogview').outerHeight(false)-$('#mainCommandBar').outerHeight(false)-$('#horizonSplitBar').outerHeight(false);
		if(verticalSplitBarHeight < 0){
			verticalSplitBarHeight = 0;
			$('#verticalSplitBar').css('visibility', 'hidden');
		}else{
			$('#verticalSplitBar').css('visibility', 'visible');
		}
		$('#verticalSplitBar').height(verticalSplitBarHeight);
	});

	//-------------------------------------------------------------------------
	// サイズ変更中のマウスドラッグ中の処理
	//-------------------------------------------------------------------------
	$('#informationPlate').on('mousemove', function(event){
		var cacheInformationPlate = $(this);
		if(cacheInformationPlate.data('verticalSplitResize') == true){
			var verticalSplitBar = cacheInformationPlate.data('verticalSplitBar');
			//この座標を1ずらしておかないと「mouseup」イベントが発行されない
			verticalSplitBar.offset({left: event.pageX+1});
			verticalSplitBar.css('z-index', cacheInformationPlate.css('z-index')+1);
			if(event.pageX <= 220){
				$('#informationPlate').data('mouseOut', 'xmin');
				$('#informationPlate').trigger('mouseup');
			}
			if(event.pageX >= $(window).innerWidth()-30 ){
				$('#informationPlate').data('mouseOut', 'xmax');
				$('#informationPlate').trigger('mouseup');
			}
		}
		if(cacheInformationPlate.data('horizonSplitResize') == true){
			var verticalSplitBar = cacheInformationPlate.data('horizonSplitBar');
			//この座標を1ずらしておかないと「mouseup」イベントが発行されない
			verticalSplitBar.offset({top: event.pageY+1});
			verticalSplitBar.css('z-index', cacheInformationPlate.css('z-index')+1);
			if(event.pageY <= $('#mainCommandBar').outerHeight(false)){
				$('#informationPlate').data('mouseOut', 'ymin');
				$('#informationPlate').trigger('mouseup');
			}
			if(event.pageY >= $(window).innerHeight()-30 ){
				$('#informationPlate').data('mouseOut', 'ymax');
				$('#informationPlate').trigger('mouseup');
			}
		}
		//DOM参照をクリア
		cacheInformationPlate = null;
	});

	//-------------------------------------------------------------------------
	// サイズ変更中のマウスボタンを離したときの処理
	//-------------------------------------------------------------------------
	$('#informationPlate').on('mouseup', function(event){
		var cacheInformationPlate = $(this);
		var pageX = event.pageX;
		var pageY = event.pageY;
		if(pageX == undefined){
			if(cacheInformationPlate.data('mouseOut') == 'xmin'){
				pageX = 220;
			}else{
				pageX = $(window).innerWidth()-30;
			}
		}
		if(pageY == undefined){
			if(cacheInformationPlate.data('mouseOut') == 'ymin'){
				pageY = $('#mainCommandBar').outerHeight(false);
			}else{
				pageY = $(window).innerHeight()-30;
			}
		}
		$('#informationPlate').removeData('mouseOut');

		cacheInformationPlate.css('visibility', 'hidden');
		if(cacheInformationPlate.data('verticalSplitResize') == true){
			var verticalSplitBar = cacheInformationPlate.data('verticalSplitBar');
			var leftFrame = cacheInformationPlate.data('leftFrame');

			verticalSplitBar.offset({left: pageX});
			leftFrame.each(function(){
				$(this).width(pageX);
			});
			cacheInformationPlate.data('verticalSplitResize', false);
			cacheInformationPlate.css('cursor', 'auto');
			verticalSplitBar.css('z-index', 20);
			//ウィンドウのリサイズ
			$(window).resize();
		}
		if(cacheInformationPlate.data('horizonSplitResize') == true){
			var horizonSplitBar = cacheInformationPlate.data('horizonSplitBar');
			var downFrame = cacheInformationPlate.data('downFrame');
			var downFrameHeight = $(window).innerHeight()-pageY-horizonSplitBar.outerHeight(false);
			var commandBarSpace = $(window).innerHeight() - $('#mainCommandBar').outerHeight(false);
			if(downFrameHeight > commandBarSpace ){
				downFrameHeight = commandBarSpace;
			}

			//高さを設定する
			downFrame.height(downFrameHeight);

			//後処理
			cacheInformationPlate.data('horizonSplitResize', false);
			cacheInformationPlate.css('cursor', 'auto');
			horizonSplitBar.css('z-index', 20);
			//ウィンドウのリサイズ
			$(window).resize();
		}
		//DOM参照をクリア
		cacheInformationPlate = null;
	});

	//全Windowリフレッシュ用情報の初期化を行う
	var refreshList = {'treeView': false, 'logView': false, 'detailView': false};
	$('#allRefreshWindow').data('allRefreshWindow', refreshList);

//	//オートリフレッシュタイマー開始
//	$('#autoRefreshIntervalCount', top.document).val(0);
//	setInterval(autoRefreshTimer, 1000);
	$(window).unload(function() {
		(function(){
			clearInterval(autoExecTimerId);
			//ホーム画面遷移処理によるリロードの場合には、
			//自動ログアウトタイマーを継続するために保存する
			if($.jStorage.get('goHomeFlag') == true){
				$.jStorage.set('autoLogoutTimeCount', autoLogoutTimeCount);
			}else{
				$.jStorage.set('autoLogoutTimeCount', 0);
			};
			//iPadではないブラウザの場合全要素を消去する
			if(navigator.userAgent.search(/iPad/) == -1){
				$(document).empty();
				$(window).remove();
			}
		})();
		execGC();
	});

	//初回実行時は、自動ログアウト時間の復元
	if(autoLogoutTimeCountInit == false){
		autoLogoutTimeCountInit = true;
		autoLogoutTimeCount = $.jStorage.get('autoLogoutTimeCount', 0);
		$.jStorage.set('autoLogoutTimeCount', 0);
	}
	//自動実行タイマーの開始
	autoExecTimerId = setInterval(autoExecTimeout, 1000*60);

	$(window).load(function(){
		//自動ホーム画面遷移でこのページが表示された時にはダイアログ表示を行う
		if($.jStorage.get('goHomeFlag', false) == true){
			//児童ホーム画面遷移した記録を消去する
			$.jStorage.set('goHomeFlag', false);

			//ダイアログ表示部分
			var dlg = $('<div id="goHomeIndDiv"><p id="goHomeIndText">一定時間操作がなかったため、ホーム画面に戻りました。</p></div>');
			var button = $('<div id="goHomeButton"><input type="button" name="okButton" value="OK" style="margin-right: 5px;"/></div>');
			dlg.append(button);
			dlg.dialog({
				draggable: false,
				modal: true,
				dialogClass: 'dialog',
				width: 320,
				height: 125,
				position: 'center',
				resizable: false,
				show: 'blind',
				title: 'ホーム画面に戻りました。'
			});
			$('#goHomeButton').on('click', 'input[type=button]', function(){
				$('#goHomeIndDiv').dialog('close');
			});
			$('#goHomeButton').find('input[type=button]').button();

			dlg = null;
			button = null;
		}
	});
});


//=============================================================================
// ダイアログ関連処理
//=============================================================================
//-----------------------------------------------------------------------------
//ダイアログ表示処理
//-----------------------------------------------------------------------------
function showDialog (uri, title, width, height, resizable) {
	var localWidth = (width==undefined) ? 640 : width;
	var localHeight = (height==undefined) ? 480 : height;

	//ダイアログを表示する前に他のダイアログは要素毎削除する
	$('#indicatorDialog').remove();

	//新しいダイアログを作成する
	var dlg = $('<div id="indicatorDialog"><iframe class="innerDialog" src="' + uri + '" frameborder="0"/></div>');
	dlg.dialog({
		draggable: true,
		modal: true,
		dialogClass: 'dialog',
		width: localWidth,
		height: localHeight,
		position: 'center',
		resizable: false,
		show: 'blind',
		title: title,
		beforeClose: function(e){
			var indicatorDialog = $(e.target);
			if( indicatorDialog.find('iframe').contents().find('#canClose').val() == 'false' ){
				return false;
			}
		},
		close: function(e){
			var indicatorDialog = $(e.target);
			//=================================================================
			// ダイアログを閉じた時の処理
			//=================================================================
			if( indicatorDialog.find('iframe').contents().find('#edited').val() == 'true' ){
				updateAllWindow();
			}else{
				if(indicatorDialog.data('edited') == 'true' ){
					indicatorDialog.data('edited', 'false');
					updateAllWindow();
				}
			}
			indicatorDialog.children('iframe.innerDialog').removeAttr('src');
		}
	});
}

//-----------------------------------------------------------------------------
// 全体表示のローディングダイアログ表示
//-----------------------------------------------------------------------------
function mainscreenViewLoading( message, width ){
	message = message==null?'':message;
	width = width==undefined?250:width;

	//処理中表示
	$.blockUI({
		message: message,
	    fadeIn:  0,
	    overlayCSS:  {
			backgroundColor: '#aaa',
			opacity:         0.6,
			cursor:          'wait'},
		css: {
			padding: '45px 40px',
			margin:  0,
			width:   width + 'px',
			border:  '2px solid #aaa',}
	});
}

function mainscreenViewLoadingClear(){
	//ローディング表示の消去
	$.unblockUI();
}

//-----------------------------------------------------------------------------
//全体表示の通信断ダイアログ
//-----------------------------------------------------------------------------
function mainscreenViewServerDown(){

	//処理中表示
	$.blockUI({
		message: '<div>サーバーとの通信でエラーが発生いたしました。</div><div>サーバーの動作を確認していただき、ブラウザーの再読み込みをお願い致します。</div>',
	    fadeIn:  0,
	    overlayCSS:  {
			backgroundColor: '#aaa',
			opacity:         0.9,
			cursor:          'default'},
		css: {
			padding: '45px 40px',
			margin:  0,
			width:   350 + 'px',
			cursor:          'default',
			border:  '2px solid #aaa',}
	});
}

//=============================================================================
// 全Windowリフレッシュ処理
//=============================================================================
function updateAllWindow(visiblePlate){
	if(visiblePlate != false){
		//砂時計表示Windowを作成する
		var mainBody = $('body', top.document);
		var span = $('span.mainCursorPlateItemText', top.document);
		var img = $('img.mainCursorPlateItemLoadImg', top.document);
		var div = $('#mainCursorPlate', top.document);
		var spanWidth = span.outerWidth(false);
		var imgWidth = img.outerWidth(false);
		var totalWidth = spanWidth + imgWidth;
		var spanHeight = span.outerHeight(false);
		var imgHeight = img.outerHeight(false);
		img.css('left', (mainBody.outerWidth(false)/2) - (totalWidth/2));
		img.css('top', (mainBody.outerHeight(false)/2) - (imgHeight/2));
		span.css('left', ((mainBody.outerWidth(false)/2) - (totalWidth/2))+ imgWidth);
		span.css('top', (mainBody.outerHeight(false)/2) - (imgHeight/2)+((imgHeight-spanHeight)/2));
		div.css('visibility', 'visible');
		img.css('visibility', 'visible');
		span.css('visibility', 'visible');
		//DOM参照をクリア
		mainBody = null;
	}

	//---------------------------------------------------------------------
	// リフレッシュ処理
	//---------------------------------------------------------------------
	var allFrame = $('iframe',top.document);
	//全Windowリフレッシュ用情報の設定を行う
	var refreshList = {'treeView': true, 'logView': true, 'detailView': true, 'commandBar': true};
	$('#allRefreshWindow').data('allRefreshWindow', refreshList);
	//全フレームのリフレッシュ処理を呼び出す
	allFrame.each(function(){
		var windowObject = $(this).get(0).contentWindow;
		if(windowObject.windowRefresh != undefined){
			windowObject.windowRefresh();
		}
		//DOM参照をクリア
		windowObject = null;
	});
}

//=============================================================================
// リフレッシュ終了処理
//=============================================================================
function windowRefreshEnd(targetWindow){
	if((targetWindow == 'treeView')||(targetWindow == 'logView')||(targetWindow == 'detailView')||(targetWindow == 'commandBar')){
		//ページリフレッシュリストの更新
		var refreshList = $('#allRefreshWindow', top.document).data('allRefreshWindow');
		refreshList[targetWindow] = false;
		$('#allRefreshWindow', top.document).data('allRefreshWindow', refreshList);
		if( ($('#mainCursorPlate').size() > 0) && (refreshList['treeView'] == false) && (refreshList['logView'] == false) && (refreshList['detailView'] == false) && (refreshList['commandBar'] == false) ){
			$('#mainCursorPlate').css('visibility', 'hidden')
				.find('span.mainCursorPlateItemText').css('visibility', 'hidden').end()
				.find('img.mainCursorPlateItemLoadImg').css('visibility', 'hidden');
		}
	}
}
//=============================================================================
//リフレッシュ画面強制終了処理
//=============================================================================
function forceAllWindowRefreshEnd(){
	var allFrame = $('iframe',top.document);
	//全フレームのリフレッシュ処理を呼び出す
	allFrame.each(function(){
		var windowObject = $(this).get(0).contentWindow;
		if(windowObject.forceWindowRefreshEnd != undefined){
			windowObject.forceWindowRefreshEnd();
		}
		//DOM参照をクリア
		windowObject = null;
	});
	//自動的に画面が遷移するタイマーも停止する。
	clearInterval(autoExecTimerId);
}

//=============================================================================
// 「戻る」用URL設定処理
//=============================================================================
function pageNavigatePush(urlString){
	var tempArray = $('body', top.document).data('pageNavigateArray');
	tempArray.push(urlString);
	$('body', top.document).data('pageNavigateArray', tempArray);
}

//=============================================================================
//「戻る」用URL取り出し処理
//=============================================================================
function pageNavigatePop(){
	var tempArray = $('body', top.document).data('pageNavigateArray');
	var srcString = tempArray.pop();
	var urlString = tempArray.pop();
	if(urlString == undefined){
		urlString = '';
		//戻れない場合には元のページ情報を入れておく
		tempArray.push(srcString);
	}
	$('body', top.document).data('pageNavigateArray', tempArray);
	return urlString;
}

////=============================================================================
////オートリフレッシュ処理
////=============================================================================
//function autoRefreshTimer(){
//	var count = parseInt($('#autoRefreshIntervalCount', top.document).val());
//	var autoRefreshTime = parseInt($('#autoRefreshInterval').val());
//	count = count+1;
//
//	if(count >= autoRefreshTime){
//		updateAllWindow(false);
//		count = 0;
//	}
//
//	//時間を保存する
//	$('#autoRefreshIntervalCount', top.document).val(count);
//}

//=============================================================================
// タイムアウト処理
//=============================================================================
function autoExecTimeout(){
	//-------------------------------------------------------------------------
	// 自動ログアウト処理
	//-------------------------------------------------------------------------
	autoLogoutTimeCount++;
	if( parseInt($('#autoLogoutTime').val()) > 0
			&& ($('#autoLogoutTime').val()/60) <= autoLogoutTimeCount ){
		top.location = '/Indicator/view/logout.html';
		//自動ログアウトを行ったことを保存する
		$.jStorage.set('autoLogoutMessageFlag', true);
		return;
	}
	//-------------------------------------------------------------------------
	// ホーム画面遷移処理
	//-------------------------------------------------------------------------
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		autoGoHomeTimeCount++;
		if( ($('#autoGoHomeTime').val()/60) <= autoGoHomeTimeCount ){
			//ホーム画面遷移処理を行ったことを保存する
			$.jStorage.set('goHomeFlag', true);
			//ページのリロードを行いホーム画面に遷移する
			top.location.reload();
			return;
		}
	}
}

//=============================================================================
// 自動ログアウトタイマーのリセット処理
//=============================================================================
function autoExecTimerReset(){
	autoLogoutTimeCount = 0;
	autoGoHomeTimeCount = 0;
	//自動ログアウトタイマーの再設定
	clearInterval(autoExecTimerId);
	autoExecTimerId = setInterval(autoExecTimeout, 1000*60);
}

