//*****************************************************************************
// Copyright (C) 2013 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
$(document).ready(function(){
	var useragent= navigator.userAgent;
	if(useragent.search(/iPad/) != -1){
		//ダイアログの高さを設定する
		$('div.dialogBody').height($(top.document).find('#indicatorDialog').height()-$('div.dialogButtons').outerHeight(false)-10);
	}
	//クラス定義
	var systemLog = function(maxRow){
		this.maxRow = (maxRow!=undefined)? maxRow: '300';
		//受信データ保存
		this.objectMapList = [];
		this.requestParams = {};
		this.logOffset = 0;

		//メソッド
		//サマリーの取得要求
		this.ajaxSystemLogRequest = function( requestData ){
			//パラメータ
			var requestParams = {'order': false};
			if (this.maxRow != undefined) {
				requestParams['maxRow'] = this.maxRow;
			}

			if( requestData == undefined ){
				//未定義の場合には、現在の条件のまま、要求を行う
				requestParams = this.requestParams;
			}else if( requestData == 'default' ){
				//nullの場合には、絞込みの条件なしで、要求を行う
				//要求パラメータの保存
				this.requestParams = requestParams;
			}else{
				var requestType = {'タイプ':'filterTypeList', '未来時間表示日時過去時間表示':'filterDate', 'カテゴリ':'filterCategory', 'サマリー': 'filterMessage'};
				//設定のあった項目だけ上書きする
				if(requestType[requestData['filter']] == 'filterDate'){
					var timeStringBefore = requestData['data'].find(':text[name=filterDateBefore]').val();
					var temp = (Date.parse(timeStringBefore)/1000).toFixed();
					//要エラーチェック
					if(isNaN(temp)==false){
						requestParams['beginDate'] = temp;
					}

					var timeString = requestData['data'].find(':text[name=filterDate]').val();
					var temp = (Date.parse(timeString)/1000).toFixed();
					//要エラーチェック
					if(isNaN(temp)==false){
						requestParams['endDate'] = temp;
					}
				}else if(requestType[requestData['filter']] == 'filterTypeList'){
					var typeList = [];
					requestData['data'].find(':checked').each(function(){
						typeList.push($(this).val());
					});
					requestParams['filterTypeList'] = typeList;
				}else if(requestType[requestData['filter']] == 'filterCategory'){
					requestParams['filterCategory'] = requestData['data'].find(':text').val();
				}else if(requestType[requestData['filter']] == 'filterMessage'){
					requestParams['filterMessage'] = requestData['data'].find(':text').val();
				}
				//要求パラメータの保存
				this.requestParams = requestParams;
			}
			//Loadingタイマー開始
			$('body').viewLoadingScreen();
			var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
			ajaxParam.onFailure = onAjaxFailure;
			Kumu.Ajax.executeTeedaAjax(systemLog_systemLogViewerAction_ajaxSystemLog, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		};
		//子要素の取得応答
		this.ajaxSystemLogResponse = function(objectMapList){
			try{
				//次ページが存在しない場合には、過去時間表示のボタンを消す
				if(objectMapList.length<parseInt(this.maxRow)){
				    $('#iconGoPastPage').hide();
				}else{
				    $('#iconGoPastPage').show();
				}
				if(objectMapList.length<=0) throw 'noItem';
				delete this.objectMapList;
				this.objectMapList = [];
				for (i in objectMapList) {
					this.objectMapList[i] = objectMapList[i];
				}
			}catch(e){
				if(e == 'noItem'){
					delete this.objectMapList;
					this.objectMapList = [];
				}
			}
		};
		//ページ表示の更新処理
		this.pageUpdate = function(){
			try{
				var tableBody = $('#systemLogViewerTable').children('tbody');

				//受信データがない場合には中身をクリアする
				if(this.objectMapList.length<=0){
					tableBody.empty();
					return;
				}

				//タイプ
				var tdTypeArray = [];
				var statusStringHashTable = {1:'エラー', 2:'警告', 4:'情報'};
				var statusIconHashTable = {1:'logStateError16', 2:'logStateWarning16', 4:'logStateInformation16'};
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('systemlogTypeStyle');
					var p = $('<p>');
					var img = $('<img>').attr('src', '../../images/invisible16.png').addClass(statusIconHashTable[thisObjectMap['logType']]);
					var string = statusStringHashTable[thisObjectMap['logType']];
					p.append(img).append(string);
					var inputSortdata = $('<input type="hidden" name="sortdata">').attr('value', thisObjectMap['logType']);
					td.append(p).append(inputSortdata);
					tdTypeArray.push(td);
				}

				//日時
				var tdDateArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('systemlogDateStyle');
					var p = $('<p>');
					var string = (new String(thisObjectMap['date'])).replace(/ /, '<br/>');
					//検索用に日時データを保存する
					var input = $('<input type="hidden" name="date">').attr('value', thisObjectMap['date']);
					p.append(string).append(input);
					td.append(p);
					tdDateArray.push(td);
				}

//				//カテゴリ
//				var tdCategoryArray = [];
//				for(i in this.objectMapList){
//					var thisObjectMap = this.objectMapList[i];
//					var td = $('<td>').addClass('systemlogCategoryStyle');
//					var p = $('<p>');
//					var string = thisObjectMap['category'];
//					p.append(string);
//					td.append(p);
//					tdCategoryArray.push(td);
//				}

				//メッセージ本文
				var tdMessageArray = [];
				for(i in this.objectMapList){
					var thisObjectMap = this.objectMapList[i];
					var td = $('<td>').addClass('systemlogSummaryStyle');
					var string = $('<p>').attr('title', thisObjectMap['message']).append(thisObjectMap['message']);
					td.append(string);
					tdMessageArray.push(td);
				}

				//合成する
				var tableBodyObj = tableBody.clone(true);
				tableBodyObj.empty();
				for(i in this.objectMapList){
					var tr = $('<tr>');
					tr.append(tdTypeArray[i]).append(tdDateArray[i]).append(tdMessageArray[i]);
					tableBodyObj.append(tr);
				}
				//テーブル内容の書き換え
				tableBody.replaceWith(tableBodyObj);

				//テーブル要素の表示
				$('#systemLogViewerTable').children('tbody')
												.css('visibility', 'visible')
											.end()
											.trigger('update');
			}finally{
				if($('#systemLogViewerTable').data('refresh') == true){
					$('#systemLogViewerTable').tableDataSort();
				}
	            //Loading終了
			    $('body').deleteLoadingScreen();
			}
		};
		//テーブル機能の拡張を行う
		$('#systemLogViewerTable').fixedHeaderTable();
	};

	//=========================================================================
	// 初回実行時の処理
	//=========================================================================
	//このオブジェクト変数だけは、グローバルスコープ
	objLogview = new systemLog($('#maxLogRow', top.document).val());
	//ログ情報取得要求
	objLogview.ajaxSystemLogRequest('default');

	$('th').children('button').each(function(){
		thisButton = $(this);
		thisButton.button({
			icons:{primary:thisButton.val()},
			text: false});
		//UIボタンにクラス指定しても効果がない場合があり、直接値を設定する
		thisButton.css({
			'width': '16px',
			'height': '16px',
			'margin': '0px',
			'padding': '0px',
			'vertical-align': 'middle'});
	});

	//=========================================================================
	//コールバックメソッドの設定
	//=========================================================================
	//-------------------------------------------------------------------------
	// ログ情報取得応答処理
	//-------------------------------------------------------------------------
	function systemLog_systemLogViewerAction_ajaxSystemLog(objectMapList) {
		//受信データ設定
		objLogview.ajaxSystemLogResponse(objectMapList);
		//ページ表示の更新
		objLogview.pageUpdate();
	}
	//-------------------------------------------------------------------------
	// 過去時間表示か未来時間表示をクリックした時の処理
	//-------------------------------------------------------------------------
	$('#systemLogViewerTable').on('click', '#iconGoFuturePage,#iconGoPastPage', function(){
		var maxRow = parseInt(objLogview.maxRow);
		if($(this).attr('id') == 'iconGoPastPage'){
			objLogview.logOffset+=maxRow;
		}else{
			if(objLogview.logOffset >= maxRow){
				objLogview.logOffset-=maxRow;
			}
		}
		//リクエストパラメータの編集
		var requestParams = objLogview.requestParams;
		//表示ページを移動する
		requestParams['offset'] = objLogview.logOffset;

		//データを要求する
		$('body').viewLoadingScreen();
		var ajaxParam = {'AjaxParam0' : Kumu.JSONSerializer.serialize(requestParams)};
		ajaxParam.onFailure = onAjaxFailure;
		Kumu.Ajax.executeTeedaAjax(systemLog_systemLogViewerAction_ajaxSystemLog, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
		return false;
	});
	//-------------------------------------------------------------------------
	// 絞込みボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		var requestData = {'filter':thisDivToolBox.data('targetTh').text(), 'data':thisDivToolBox};
		objLogview.logOffset = 0;
		objLogview.ajaxSystemLogRequest(requestData);
		thisDivToolBox.remove();
	});
	//-------------------------------------------------------------------------
	// 絞込み解除ボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('body').on('click', 'input.toolBoxFilterCancelButton', function(){
		var thisDivToolBox = $(this).parents('div.divToolBox');
		objLogview.logOffset = 0;
		objLogview.ajaxSystemLogRequest('default');
		thisDivToolBox.remove();
	});

	//-------------------------------------------------------------------------
	// ツールボックスボタンをクリックした時の処理
	//-------------------------------------------------------------------------
	$('#systemLogViewerTable').on('click', 'img.tableToolBoxButton', function(e){
		var thisTh = $(e.target).parents('th');
		var option = {'sortTable': true, 'filterTable': true};
		   //テーブル機能の拡張を行う
		$('#systemLogViewerTable').makeToolBox(option, thisTh);

		//---------------------------------------------------------------------
		// 昇順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderAsc', function(){
			$('#systemLogViewerTable').tableDataSort($(this).parents('div.divToolBox'), true);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 降順並び替え
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.orderDesc', function(){
			$('#systemLogViewerTable').tableDataSort($(this).parents('div.divToolBox'), false);
			$(this).parents('div.divToolBox').remove();
		});
		//---------------------------------------------------------------------
		// 絞込み
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
		});
		//---------------------------------------------------------------------
		// 絞込み解除
		//---------------------------------------------------------------------
		$('div.divToolBox').on('click', '.toolBoxFilterCancelButton', function(){
			//サーバー側での絞り込みを行うため、こちらでは絞り込みを行わない
			$('#systemLogViewerTable').removeData('sortData');//ソート順も解除する
		});
	});
});
