//*****************************************************************************
// Copyright (C) 2013-2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************
var ICON_HASH_TABLE = {
	'GROUP':				'folderClosed16',
	'BOM5WINDOWS':			'bom5Windows16',
	'BOM5LINUX':			'bom5Linux16',
	'BOM5VMWARE':			'bom5Vmware16',
	'BOM6WINDOWS':			'bom6Windows16',
	'BOM6LINUX':			'bom6Linux16',
	'BOM6VMWARE':			'bom6Vmware16',
	'BOM7WINDOWS':			'bom7Windows16',
	'BOM7LINUX':			'bom7Linux16',
	'BOM7VMWARE':			'bom7Vmware16',
	'BOM8WINDOWS':			'bom8Windows16',
	'BOM8LINUX':			'bom8Linux16',
	'BOM8VMWARE':			'bom8Vmware16',
};
var STATUS_ICON_HASH_TABLE = {
	'disconnectComputer':	'instanseStateDisconnectComputer16',
	'disconnectHelper':		'instanseStateDisconnectHelper16',
	'disconnectAgent':		'instanseStateDisconnectAgent16',
	'failure':				'instanseStateFailure16',
	'danger':				'instanseStateDanger16',
	'warning':				'instanseStateWarning16',
	'normal':				'instanseStateSuccess16',
	'invisible':			'',
};
var CLASS_HASH_TABLE = {
	'GROUP':				'treeviewFolder',
	'BOM5WINDOWS':			'treeviewInstance',
	'BOM5LINUX':			'treeviewInstance',
	'BOM5VMWARE':			'treeviewInstance',
	'BOM6WINDOWS':			'treeviewInstance',
	'BOM6LINUX':			'treeviewInstance',
	'BOM6VMWARE':			'treeviewInstance',
	'BOM7WINDOWS':			'treeviewInstance',
	'BOM7LINUX':			'treeviewInstance',
	'BOM7VMWARE':			'treeviewInstance',
	'BOM8WINDOWS':			'treeviewInstance',
	'BOM8LINUX':			'treeviewInstance',
	'BOM8VMWARE':			'treeviewInstance',
};

var intervalTimerId;

$(document).ready(function(){
	var treeViewTop = $('#treeViewForm');

	//iPad区別用
	var isiPad = (navigator.userAgent).search(/iPad/)!=-1?true:false;
	//iPadの場合、横幅のサイズを変更する
	//iPad用初期処理
	if(isiPad){
		treeViewTop.width(1024);
	}

	treeViewTop.data('initialize', true);
	treeViewTop.data('openGroupList', []);
	treeViewTop.data('refreshGroupList', []);
	treeViewTop.data('refreshExec', false);

	//=======================================================================
	// ツリー内でのすべてのクリックイベント
	//=======================================================================
	treeViewTop.on('click', function(e){
		var clickObject = $(e.target);
		if(clickObject.hasClass('treeFolderItem') || clickObject.hasClass('treeInstanceItem')){
			var ret = '';
			//一個ずつ処理を記載していく
			ret = itemSelect(clickObject);
			itemGet(clickObject, ret);
			ret = null;
		}
		clickObject = null;
	});

	//=======================================================================
	// 初回実行時の処理
	//=======================================================================
	//ルート要素の取得処理
	//var ajaxParam = {'AjaxParam0' : ''};
	//ajaxParam.onFailure = onAjaxFailure;
	//Kumu.Ajax.executeTeedaAjax(tree_treeGroupViewAction_ajaxChildObjects, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeGroupViewAction', 'action' : 'ajaxChildObjects', 'AjaxParam0' : ''}, tree_treeGroupViewAction_ajaxChildObjects, 'json');

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	intervalTimerId = setInterval(autoRefreshTimer, 1000);
	//インターバルタイマーを停止する
	$(window).unload(function() {
		clearInterval(intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});

	//画面のサイズが変更になった時の処理
	//スプリットバーが移動してもイベントを発生させている
	$(window).resize(function(){
		$('#treeViewForm').width( $('body').width() );
	});
	$(window).resize();
});

//=========================================================================
// アイテムの選択処理
// 引数：	itemObject		選択されたjQueryオブジェクト
// 戻り値：	アクション種別
//			noAction		アクションなし
//			groupSelect		グループ選択
//			groupOpen		グループ開く
//			groupClose		グループ閉じる
//			instanceSelect	インスタンス選択
//=========================================================================
function itemSelect(itemObject){
	var treeViewTop = $('#treeViewForm');
	var itemData = itemObject.parent();
	var targetId = $('input:hidden[title=groupId]', itemData).val();
	var parentGroupId = $('input:hidden[title=parentGroupId]', itemData).val();
	var retValue = 'noAction';
	if(itemObject.hasClass('treeFolderItem') == true){
		//グループの処理
		if (itemData.hasClass('folderOpened') == true) {
			//--------------------------------
			// グループが開いている時の処理
			//--------------------------------
			// クリックしたのがrootの場合、ツリービューのリフレッシュ処理を行う
			if(targetId == '1'){
				windowRefresh();
				retValue = 'groupSelect';
			}else if (itemData.hasClass('folderSelected') == false) {
				//-------------------------------------------------------------
				// グループ選択状態にする
				//-------------------------------------------------------------
				$('.folderSelected', '#treeViewBody').each(function(){
					$(this).removeClass('folderSelected');
				});
				itemData.addClass('folderSelected');
				retValue = 'groupSelect';
			}else{
				//-------------------------------------------------------------
				// グループを閉じ、その子孫の要素を削除する
				//-------------------------------------------------------------
				var deleteIdList = [targetId];
				itemData.removeClass('folderOpened');
				itemData.children('span').removeClass('folderOpened16').addClass('folderClosed16');
				var padding = parseInt(itemData.css('padding-left'));
				var groupIndex = itemData.index();
				var loopFlg = false;
				itemData.parent().children().each(function(){
					if(loopFlg){
						return;
					}
					var thisItem = $(this);
					var thisPadding = parseInt(thisItem.css('padding-left'));
					//自分より前の要素は処理しない
					if(thisItem.index() > groupIndex){
						if(thisPadding > padding){
							if( thisItem.children('input').is('input[title=groupId]')){
								deleteIdList.push(thisItem.children('input[title=groupId]').val());
							}
							thisItem.remove();
						}else{
							loopFlg = true;
						}
					}
					thisItem = null;
				});

				//更新要求リストから番号を削除する
				var newRefreshList = [];
				var openGroupList = treeViewTop.data('openGroupList');
				for(var i in openGroupList){
					var thisOpenGroup = openGroupList[i];
					var searchHit = false;
					for(var j in deleteIdList){
						var thisDelteId = deleteIdList[j];
						if(thisOpenGroup['id'] == thisDelteId){
							searchHit = true;
							break;
						}
						thisDelteId = null;
					}
					if(searchHit == false){
						newRefreshList.push(thisOpenGroup);
					}
					thisOpenGroup = null;
				}
				treeViewTop.data('openGroupList', newRefreshList);
				retValue = 'groupClose';

				deleteIdList = null;
				newRefreshList = null;
				openGroupList = null;
			}
		}else{
			//--------------------------------
			// グループが閉じている時の処理
			//--------------------------------
			//グループを開く
			itemData.addClass('folderOpened');
			//グループ選択状態にする
			$('.folderSelected', '#treeViewBody').each(function(){
				$(this).removeClass('folderSelected');
			});
			itemData.addClass('folderSelected');
			//更新要求リストに追加する
			var openGroupList = treeViewTop.data('openGroupList');
			var searchHit = false;
			for(var i in openGroupList){
				if(targetId == openGroupList[i]['id']){
					searchHit = true;
				}
			}
			if(searchHit == false){
				var newItem = {};
				newItem['id'] = targetId;
				newItem['parentGroupId'] = parentGroupId;
				openGroupList.push(newItem);
				newItem = null;
			}
			treeViewTop.data('openGroupList', openGroupList);

			itemData.children('span').removeClass('folderClosed16').addClass('folderOpened16');
			retValue = 'groupOpen';

			openGroupList = null;
		}
	}else{
		//---------------------------------------------------------------------
		// インスタンスが選択されたため、グループの選択状態を解除する
		//---------------------------------------------------------------------
		treeViewTop.find('.folderSelected').removeClass('folderSelected');
		retValue = 'instanceSelect';
	}

	treeViewTop = null;
	itemData = null;

	return retValue;
}

//=========================================================================
// アイテムの取得処理
// 引数：	itemObject			選択されたjQueryオブジェクト
//			itemSelectResult	アクション種別
//								noAction		アクションなし
//								groupSelect		グループ選択
//								groupOpen		グループ開く
//								groupClose		グループ閉じる
//								instanceSelect	インスタンス選択
//=========================================================================
function itemGet(itemObject, itemSelectResult){
	var itemData = itemObject.parent();
	var targetId = 0;
	var srcString = '';
	if(itemObject.hasClass('treeFolderItem') == true){
		targetId = $('input:hidden[title=groupId]' , itemData).val();
		srcString= 'detailsGroup/detailsGroup.html?groupId=' + targetId;
		if (itemData.hasClass('folderOpened') == true) {
			if(itemSelectResult == 'groupOpen'){
				//Loadingタイマー開始
				$('body').viewLoadingScreen();
				//子要素取得要求を行う
				//var ajaxParam = {'AjaxParam0' : targetId};
				//ajaxParam.onFailure = onAjaxFailure;
				//Kumu.Ajax.executeTeedaAjax(tree_treeGroupViewAction_ajaxChildObjects, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
				$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeGroupViewAction', 'action' : 'ajaxChildObjects', 'AjaxParam0' : targetId}, tree_treeGroupViewAction_ajaxChildObjects, 'json');
			}
		}
	}else{
		targetId = $('input:hidden[title=instanceId]', itemData).val();
		srcString= 'detailsInstance/detailsInstance.html?instanceId=' + targetId;
	}

	//グループを閉じた時と、リフレッシュ時には、処理を行わない
	if((itemSelectResult == 'groupOpen') || (itemSelectResult == 'instanceSelect') || (itemSelectResult == 'groupSelect')){
		//ページ遷移かリフレッシュを行う
		if( srcString != $('#mainDetails', top.document).attr('src') ){
			//ページ遷移をする
			$('#mainDetails', top.document).attr('src', srcString);
		}else{
			//詳細ページをリフレッシュする
			top.mainDetails.windowRefresh();
		}
	}
	itemData = null;
}

//=======================================================================
// ツリービューのリフレッシュ処理
//=======================================================================
function windowRefresh(){
	var treeViewTop = $('#treeViewForm');
	treeViewTop.data('refreshExec', true);
	treeViewTop.data('refreshGroupList', treeViewTop.data('openGroupList'));

	$('body').viewLoadingScreen();
	//var ajaxParam = {'AjaxParam0' : ''};
	//ajaxParam.onFailure = onAjaxFailure;
	//Kumu.Ajax.executeTeedaAjax(tree_treeGroupViewAction_ajaxChildObjects, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
	$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeGroupViewAction', 'action' : 'ajaxChildObjects', 'AjaxParam0' : ''}, tree_treeGroupViewAction_ajaxChildObjects, 'json');
	treeViewTop.empty();

	treeViewTop = null;
}

//=============================================================================
//ツリービューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#treeViewForm').data('refreshExec') == true){
		$('#treeViewForm').data('refreshExec', false);
	}
	//自動更新用のタイマーをクリア
	clearInterval(intervalTimerId);
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('treeView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());

		count = count+1;

		if($('#treeViewForm').data('refreshExec') == false){
			if(count >= autoRefreshTime){
				// リフレッシュ中でなく、かつ指定秒数以上経過した場合だけリフレッシュを行う。
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=========================================================================
// 指定したグループIDを親に持つグループとその子孫を再帰的に削除したリストを返す
//=========================================================================
function recursiveDeleteParentGroupId(argGroupList, argParentGroupId, argExcludeGroupIdList) {
	var groupList = new Array().concat(argGroupList);
	var excludeGroupIdList = [];
	if(argExcludeGroupIdList){
		excludeGroupIdList = argExcludeGroupIdList;
	}
	for(var i=groupList.length-1; i>=0; i--){
		var group = groupList[i];
		if(group == undefined){
			continue;
		}
		var groupId = group['id'];
		var parentGroupId = group['parentGroupId'];
		group = null;

		var exclude = false;
		for(var j in excludeGroupIdList){
			if(excludeGroupIdList[j] == groupId){
				exclude = true;
				break;
			}
		}
		if(exclude) {
			continue;
		}

		if(parentGroupId == argParentGroupId){
			groupList.splice(i,1);
			groupList = arguments.callee(groupList, groupId, excludeGroupIdList); // 再帰呼び出し
		}
	}

	excludeGroupIdList = null;

	try { return groupList; } finally { groupList = null; }
}

//=========================================================================
// 指定したグループIDを削除したリストを返す
//=========================================================================
function deleteGroupId(argGroupList, argGroupId) {
	var groupList = new Array().concat(argGroupList);
	for(var i=groupList.length-1; i>=0; i--){
		var group = groupList[i];
		if(group == undefined){
			continue;
		}
		if(group['id'] == argGroupId){
			groupList.splice(i,1);
		}
		group = null;
	}

	try { return groupList; } finally { groupList = null; }
}

//=========================================================================
// ツリーパーツを作成処理
//=========================================================================
function makeTreeParts(paramThisObjectMapList, padding){
	var paramNewDataList = [];
	for(var i in paramThisObjectMapList) {
		var thisObjectMap = paramThisObjectMapList[i];
		var div = $('<div/>').addClass(CLASS_HASH_TABLE[thisObjectMap['type']]).addClass(STATUS_ICON_HASH_TABLE[statusCheck(thisObjectMap)]).css('padding-left', padding+'px');
		div.append($('<input type="hidden"/>').attr('title', 'parentGroupId').val(thisObjectMap['parentGroupId']));
		if(thisObjectMap['type']=='GROUP'){
			//グループ
			div.append($('<input type="hidden"/>').attr('title', 'groupId').val(thisObjectMap['id']));
			div.append($('<span/>').addClass('treeFolderItem').addClass(ICON_HASH_TABLE[thisObjectMap['type']]).attr('title', thisObjectMap['name']).html(thisObjectMap['name']));
		}else{
			//インスタンス
			div.append($('<input type="hidden"/>').attr('title', 'instanceId').val(thisObjectMap['id']));
			div.append($('<span/>').addClass('treeInstanceItem').addClass(ICON_HASH_TABLE[thisObjectMap['type']]).attr('title', thisObjectMap['name']).html(thisObjectMap['name']));
		}
		//iPad区別用
		var isiPad = (navigator.userAgent).search(/iPad/)!=-1?true:false;
		if(isiPad){
			div.css("height","1.2em");
		}
		paramNewDataList.push(div);
		thisObjectMap = null;
		div = null;
	}

	try { return paramNewDataList; } finally { paramNewDataList = null; }
}

//=========================================================================
// ステータス返却処理
//=========================================================================
function statusCheck(objectMap){
	if('disconnectComputer' in objectMap){
		if(objectMap['disconnectComputer']=='true'){
			return 'disconnectComputer';
		}
	}
	if('disconnectHelper' in objectMap){
		if(objectMap['disconnectHelper']=='true'){
			return 'disconnectHelper';
		}
	}
	if('disconnectAgent' in objectMap){
		if(objectMap['disconnectAgent']=='true'){
			return 'disconnectAgent';
		}
	}
	if('failure' in objectMap){
		if(objectMap['failure']>0){
			return 'failure';
		}
	}
	if('danger' in objectMap){
		if(objectMap['danger']>0){
			return 'danger';
		}
	}
	if('warning' in objectMap){
		if(objectMap['warning']>0){
			return 'warning';
		}
	}
	if('normal' in objectMap){
		if(objectMap['normal']>0){
			return 'normal';
		}
	}
	return 'invisible';
}

//=======================================================================
//子要素受信時の処理
//=======================================================================
function tree_treeGroupViewAction_ajaxChildObjects(objectMapList) {
	var treeViewTop = $('#treeViewForm');
	var thisObjectMapList = objectMapList;

	// 親の要素を取得する
	var parentGroupId = undefined;
	if(thisObjectMapList.length>0){
		parentGroupId = thisObjectMapList[0]['parentGroupId'];
	}
	var searchString = 'input:hidden[title=groupId][value=' + parentGroupId + ']';
	var parentGroupObject = treeViewTop.find(searchString).parent('div.treeviewFolder');

	if(thisObjectMapList.length>0){
		// 親IDがない場合にはルート処理
		// またはリフレッシュ処理
		if(parentGroupId == undefined){
			//初期のルート要素の設定
			var rootGroupDiv = $('<div/>').addClass('treeviewFolder').addClass(STATUS_ICON_HASH_TABLE[statusCheck(thisObjectMapList[0])]).css('padding-left', '20px');
			rootGroupDiv.append($('<input type="hidden"/>').attr('title', 'groupId').val('1'));
			rootGroupDiv.append($('<span/>').addClass('treeFolderItem').addClass(ICON_HASH_TABLE['GROUP']).attr('title', thisObjectMapList[0]['name']).html(thisObjectMapList[0]['name']));

			//画面に反映
			rootGroupDiv.appendTo(treeViewTop);

			//初期でrootをクリックした状態とする
			if(treeViewTop.data('initialize')){
				treeViewTop.data('initialize', false);

				rootGroupDiv.children('span.treeFolderItem').trigger('click');

				treeViewTop = null;
				thisObjectMapList = null;
				parentGroupObject = null;
				rootGroupDiv = null;
				return;
			}
			rootGroupDiv = null;
		}

		// ツリーパーツを作成する
		var newDataList = makeTreeParts(thisObjectMapList, parseInt(parentGroupObject.css('padding-left'))+16);

		// ツリーパーツをの追加、または更新
		//子ブロックがない場合(自分が親IDになっているものがない場合)には、
		//新規要素追加という判断で、親に要素を追加する
		//子ブロック作成(全挿入)
		newDataList.reverse();
		for(var i in newDataList){
			newDataList[i].insertAfter(parentGroupObject);
		}
		newDataList = null;
	}

	// リフレッシュ中の場合、次の要素の要求を行う
	if(treeViewTop.data('refreshExec') == true){
		var refreshGroupList = treeViewTop.data('refreshGroupList');
		var refreshDoGroupList = [];

		//オープングループリストから今受信した子要素が存在するかを探し、リフレッシュ要求を行う
		for(var i in refreshGroupList){
			var thisOpenGroup = refreshGroupList[i];
			for(var j in thisObjectMapList){
				if(thisObjectMapList[j]['type'] == 'GROUP' && thisOpenGroup['id'] == thisObjectMapList[j]['id']){
					//子要素取得要求を行う
					refreshDoGroupList.push(thisOpenGroup['id']);
					//var ajaxParam = {'AjaxParam0' : thisOpenGroup['id']};
					//ajaxParam.onFailure = onAjaxFailure;
					//Kumu.Ajax.executeTeedaAjax(tree_treeGroupViewAction_ajaxChildObjects, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
					$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeGroupViewAction', 'action' : 'ajaxChildObjects', 'AjaxParam0' : thisOpenGroup['id']}, tree_treeGroupViewAction_ajaxChildObjects, 'json');
				}
			}
			paramNewDataList = null;
		}

		refreshGroupList = recursiveDeleteParentGroupId(refreshGroupList, parentGroupId, refreshDoGroupList);
		for(var i in refreshDoGroupList){
			refreshGroupList = deleteGroupId(refreshGroupList, refreshDoGroupList[i]);
		}

		if(thisObjectMapList.length==0){
			refreshGroupList = [];
		}

		treeViewTop.data('refreshGroupList', refreshGroupList);
		if(refreshGroupList.length <= 0){
			treeViewTop.data('refreshExec', false);
			//オープンフォルダリストのフォルダを開いた表示にする
			var openGroupList = treeViewTop.data('openGroupList');
			for(var i in openGroupList){
				var thisOpenGroupId = openGroupList[i]['id'];
				searchString = 'input:hidden[title=groupId][value=' + thisOpenGroupId + ']';
				var openGroupFolder = treeViewTop.find(searchString).parent('div.treeviewFolder');
				openGroupFolder.addClass('folderOpened');
				openGroupFolder.children('span').removeClass('folderClosed16').addClass('folderOpened16');
				thisOpenGroupId = null;
				openGroupFolder = null;
			}
			//リフレッシュ終了情報を設定する
			top.window.windowRefreshEnd('treeView');

			// リサイズの呼び出しとローディング表示の終了
			$('body').deleteLoadingScreen();
			openGroupList = null;
		}

		refreshGroupList = null;
		refreshDoGroupList = null;
	}else{
		// リサイズの呼び出しとローディング表示の終了
	    $('body').deleteLoadingScreen();
	}

	treeViewTop = null;
	thisObjectMapList = null;
	parentGroupObject = null;
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#treeViewForm').data('refreshExec') == true){
		$('#treeViewForm').data('refreshExec', false);
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('treeView');
}
