//*****************************************************************************
// Copyright (C) 2013-2017 SAY Technologies, Inc. All rights reserved.
//*****************************************************************************

//IDとajaxパラメータを変換するテーブル
var ID_TO_PARAM = {
	'treeStatusDisConnectComputerItem':	'DISCONNECT_COMPUTER',
	'treeStatusDisConnectHelperItem':	'DISCONNECT_HELPER',
	'treeStatusStopAgentItem':			'STOPPED_AGENT',
	'treeStatusFailureItem':			'FAILURE',
	'treeStatusErrorItem':				'DANGER',
	'treeStatusWarningItem':			'WARNING',
	'treeStatusNormalItem':				'NORMAL',
};
var ICON_HASH_TABLE = {
	'GROUP':							'folderClosed16',
	'BOM5WINDOWS':						'bom5Windows16',
	'BOM5LINUX':						'bom5Linux16',
	'BOM5VMWARE':						'bom5Vmware16',
	'BOM6WINDOWS':						'bom6Windows16',
	'BOM6LINUX':						'bom6Linux16',
	'BOM6VMWARE':						'bom6Vmware16',
	'BOM7WINDOWS':						'bom7Windows16',
	'BOM7LINUX':						'bom7Linux16',
	'BOM7VMWARE':						'bom7Vmware16',
	'BOM8WINDOWS':						'bom8Windows16',
	'BOM8LINUX':						'bom8Linux16',
	'BOM8VMWARE':						'bom8Vmware16',
};
//受信データとデータ捜査対象を関連付けるテーブル
var TARGET_HASH_TABLE = {
	'disconnectComputer':				'#treeStatusDisConnectComputer',
	'disconnectHelper':					'#treeStatusDisConnectHelper',
	'stoppedAgent':						'#treeStatusStopAgent',
	'failure':							'#treeStatusFailure',
	'danger':							'#treeStatusError',
	'warning':							'#treeStatusWarning',
	'normal':							'#treeStatusNormal',
};
var intervalTimerId;

$(document).ready(function(){
	//iPad区別用
	var isiPad = (navigator.userAgent).search(/iPad/)!=-1?true:false;
	//iPadの場合、横幅のサイズを変更する
	//iPad用初期処理
	if(isiPad){
		$('#treeViewForm').width(1024);
	}

	$('#treeViewForm').data('refreshExec', false);

	//=========================================================================
	// クリックイベントの登録
	//=========================================================================
	var allItemIdList = $('#treeStatusDisConnectComputerItem,#treeStatusDisConnectHelperItem,#treeStatusStopAgentItem,#treeStatusFailureItem,#treeStatusErrorItem,#treeStatusWarningItem,#treeStatusNormalItem');
	//グループをクリックした場合の処理
	allItemIdList.on('click', function(e){
		var thisSpan = $(this);
		var thisGroup = thisSpan.children('img');
		var flgGroupClosed =  thisGroup.hasClass('folderClosed16');

		//全グループの表示を閉じて、削除する
		allItemIdList.each(function(){
			$(this).children().removeClass('folderOpened16').addClass('folderClosed16');
		});
		allItemIdList.each(function(){
			$(this).siblings().remove();
		});

		if(flgGroupClosed == true){
			//グループが閉じている場合には、ステータスのインスタンスリストを取得しにいく
			$('body').viewLoadingScreen();

			//ステータスのインスタンスリストを取得しにいく
			//var ajaxParam = {'AjaxParam0' : ID_TO_PARAM[$(this).attr('id')]};
			//ajaxParam.onFailure = onAjaxFailure;
			//Kumu.Ajax.executeTeedaAjax(tree_treeStatusViewAction_ajaxStatusInstances, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
			$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeStatusViewAction', 'action' : 'ajaxStatusInstances', 'AjaxParam0' : ID_TO_PARAM[$(this).attr('id')]}, tree_treeStatusViewAction_ajaxStatusInstances, 'json');
			thisGroup.removeClass('folderClosed16').addClass('folderOpened16');
		}
		thisSpan = null;
		thisGroup = null;
	});

	//=========================================================================
	// インスタンスアイテムクリック時の処理
	//=========================================================================
	$('#treeViewForm').on('click', 'span.instanceItem', function(e){
		var thisInstanceItem = $(e.target);
		var thisInstanceId = thisInstanceItem.siblings('input[title=instanceId]').val();
		var srcString = 'detailsInstance/detailsInstance.html?instanceId=' + thisInstanceId;
		var detailPage = $(top.document).find('#mainDetails');
		if( srcString != detailPage.attr('src') ){
			//ページ遷移をする
			detailPage.attr('src', srcString);
		}else{
			//詳細ページをリフレッシュする
			top.mainDetails.windowRefresh();
		}
		thisInstanceItem = null;
		detailPage = null;
		return false;
	});

	//オートリフレッシュタイマー開始
	$('#autoRefreshIntervalCount').val(0);
	intervalTimerId = setInterval(autoRefreshTimer, 1000);
	//インターバルタイマーを停止する
	$(window).unload(function() {
		clearInterval(intervalTimerId);
		//iPadではないブラウザの場合全要素を消去する
		if(navigator.userAgent.search(/iPad/) == -1){
			$('*').remove();
		}
	});
	//画面のサイズが変更になった時の処理
	//スプリットバーが移動してもイベントを発生させている
	$(window).resize(function(){
		$('#treeViewForm').width( $('body').width() );
	});
	$(window).resize();
});

//=======================================================================
//表示すべきステータスを返却する関数
//=======================================================================
function statusCheck(objectMap){
	if('disconnectComputer' in objectMap){
		if(objectMap['disconnectComputer']=='true'){
			return 'disconnectComputer';
		}
	}
	if('disconnectHelper' in objectMap){
		if(objectMap['disconnectHelper']=='true'){
			return 'disconnectHelper';
		}
	}
	if('stoppedAgent' in objectMap){
		if(objectMap['stoppedAgent']=='true'){
			return 'stoppedAgent';
		}
	}
	if('failure' in objectMap){
		if(objectMap['failure']>0){
			return 'failure';
		}
	}
	if('danger' in objectMap){
		if(objectMap['danger']>0){
			return 'danger';
		}
	}
	if('warning' in objectMap){
		if(objectMap['warning']>0){
			return 'warning';
		}
	}
	if('normal' in objectMap){
		if(objectMap['normal']>0){
			return 'normal';
		}
	}
	return 'none';
}


//=======================================================================
// ステータス要求のajax応答受信時の処理
//=======================================================================
function tree_treeStatusViewAction_ajaxStatusInstances (objectMapList) {
	//Loading終了
	$('#treeViewForm').data('refreshExec', false);
	$('body').deleteLoadingScreen();
	if($(objectMapList).size()<=0){
		//リフレッシュ終了情報を設定する
		top.window.windowRefreshEnd('treeView');
		return;
	}

	//表示データを作成し、対象のDIVへ追加する
	var target = $(TARGET_HASH_TABLE[statusCheck(objectMapList[0])]);
	for (var i in objectMapList) {
		var div = $('<div/>');
		//iPad区別用
		var isiPad = (navigator.userAgent).search(/iPad/)!=-1?true:false;
		if(isiPad){
			div.css("height","1.2em");
			div.css("padding-top","1px");
		}
		div.append($('<input type="hidden"/>').attr('title', 'instanceId').val(objectMapList[i]['id']));
		div.append($('<span/>').addClass('instanceItem').addClass(ICON_HASH_TABLE[objectMapList[i]['type']]).attr('title', objectMapList[i]['name']).html(objectMapList[i]['name']));
		target.append(div);
		div = null;
	}
	target = null;

	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('treeView');
}

//=======================================================================
// リフレッシュ処理
//=======================================================================
function windowRefresh(){
	if($('img.folderOpened16').size() <= 0){
		//リフレッシュ終了情報を設定する
		top.window.windowRefreshEnd('treeView');
	}
	$('img.folderOpened16').each(function(){
		var thisSpanId = $(this).closest('span').attr('id');
		if(thisSpanId != undefined){
			//すでに受信済みデータは削除する
			$(this).closest('span').siblings('div').remove();
			//データ取得
			$('body').viewLoadingScreen();
			$('#treeViewForm').data('refreshExec', true);
			//var ajaxParam = {'AjaxParam0' : ID_TO_PARAM[thisSpanId]};
			//ajaxParam.onFailure = onAjaxFailure;
			//Kumu.Ajax.executeTeedaAjax(tree_treeStatusViewAction_ajaxStatusInstances, ajaxParam, Kumu.Ajax.RESPONSE_TYPE_JSON);
			$.get('/Indicator/view/teeda.ajax', {'component' : 'tree_treeStatusViewAction', 'action' : 'ajaxStatusInstances', 'AjaxParam0' : ID_TO_PARAM[thisSpanId]}, tree_treeStatusViewAction_ajaxStatusInstances, 'json');
		}
		thisSpanId = null;
	});
}

//=============================================================================
//ツリービューのリフレッシュ画面強制消去
//=============================================================================
function forceWindowRefreshEnd(){
	//リフレッシュ中フラグを消去
	if($('#treeViewForm').data('refreshExec') == true){
		$('#treeViewForm').data('refreshExec', false);
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('treeView');
}

//=============================================================================
//オートリフレッシュ処理
//=============================================================================
function autoRefreshTimer(){
	if( $('#operationMode', top.document).val() != 'maintenance' ){
		var count = parseInt($('#autoRefreshIntervalCount').val());
		var autoRefreshTime = parseInt($('#autoRefreshInterval', top.document).val());

		count = count+1;

		if($('#treeViewForm').data('refreshExec') == false){
			if(count >= autoRefreshTime){
				// リフレッシュ中でなく、かつ指定秒数以上経過した場合だけリフレッシュを行う。
				windowRefresh();
				count = 0;
			}
		}

		//時間を保存する
		$('#autoRefreshIntervalCount').val(count);
	}
}

//=============================================================================
//ajaxTimeout処理
//=============================================================================
function ajaxTimeout(){
	//リフレッシュ中フラグを消去
	if($('#treeViewForm').data('refreshExec') == true){
		$('#treeViewForm').data('refreshExec', false);
	}
	//処理中画面消去
	$('body').deleteLoadingScreen();
	//リフレッシュ終了情報を設定する
	top.window.windowRefreshEnd('treeView');
}
